import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.* ;
import java.io.*;
import java.net.*;
import java.time.format.DateTimeFormatter;  
import java.time.LocalDateTime;
import org.json.simple.*;
import org.json.simple.parser.*;
import com.packenius.library.xspdf.*;

class Java_php{

    private final String USER_AGENT = "Mozilla/5.0";

        Company sendingGetRequest(int the_key) throws Exception {
 
            String urlString = "https://vndos.onrender.com/fetch?key="+the_key;
 
            URL url = new URL(urlString);
            HttpURLConnection con = (HttpURLConnection)url.openConnection();
 
            // By default it is GET request
            con.setRequestMethod("GET");
 
            //add request header
            con.setRequestProperty("User-Agent", USER_AGENT);
 
            int responseCode = con.getResponseCode();
            //System.out.println("Response code : "+ responseCode);
 
            // Reading response from input Stream
              BufferedReader in = new BufferedReader(
                    new InputStreamReader(con.getInputStream()));
              String output;
              StringBuffer response = new StringBuffer();
 
            while ((output = in.readLine()) != null) {
            
                response.append(output);
            }
            
            in.close();

        Object Obj = new JSONParser().parse(response.toString());
        
        JSONObject The_json = (JSONObject)Obj;
        
        JSONObject Invoice = (JSONObject)The_json.get("invoice");
        
        Company Comp = new Company(Invoice.get("bus_name").toString(), The_json.get("role").toString(), The_json.get("name").toString());
        
        Comp.set_invoice(new Invoice("00", Invoice.get("bus_name").toString(), Invoice.get("bus_address").toString(), Invoice.get("province").toString(), Invoice.get("country").toString(), Invoice.get("phone").toString(), Invoice.get("email").toString(), Invoice.get("currency").toString(), Float.parseFloat(Invoice.get("tax_rate").toString())));
        
        ArrayList<Category> Cat_list = new ArrayList<Category>();
        
        JSONArray Categories = (JSONArray)The_json.get("categories");
        
        for(Object Cat: Categories){
        
            Cat_list.add(new Category(Cat.toString()));
        }
        
        Comp.set_cat_list(Cat_list);
        
        ArrayList<Brand> Bra_list = new ArrayList<Brand>();
        
        JSONArray Brands = (JSONArray)The_json.get("brands");
        
        for(Object Bra: Brands){
        
            Bra_list.add(new Brand(Bra.toString()));
        }
        
        Comp.set_bra_list(Bra_list);
        
        JSONArray Products = (JSONArray)The_json.get("products");
                
        ArrayList<JSONObject> Prod_list = new ArrayList<JSONObject>();
        
        for(Object Pro: Products){
        
            Prod_list.add((JSONObject)Pro);
        }
        
        ArrayList<Product> Pro_list = new ArrayList<Product>();
        
        for(JSONObject Pro: Prod_list){
        
            Product New_product = new Product(Pro.get("name").toString(), Pro.get("code").toString(), Float.parseFloat(Pro.get("price").toString()), Integer.parseInt(Pro.get("warranty").toString()), Pro.get("category").toString(), Pro.get("brand").toString(), Pro.get("description").toString());
            
            Pro_list.add(New_product);
        }
        
        Comp.set_pro_list(Pro_list);
        
        JSONArray Customers = (JSONArray)The_json.get("customers");
                
        ArrayList<JSONObject> Cust_list = new ArrayList<JSONObject>();
        
        for(Object Cus: Customers){
        
            Cust_list.add((JSONObject)Cus);
        }
        
        ArrayList<Customer> Cus_list = new ArrayList<Customer>();
        
        for(JSONObject Cus: Cust_list){
        
            Customer New_custom = new Customer(Cus.get("name").toString(), Cus.get("code").toString(), Cus.get("email").toString(), Cus.get("contact").toString(), Cus.get("address").toString());
            
            Cus_list.add(New_custom);
        }
        
        Comp.set_cus_list(Cus_list);
        
        JSONArray Vendors = (JSONArray)The_json.get("vendors");
                
        ArrayList<JSONObject> Vend_list = new ArrayList<JSONObject>();
        
        for(Object Ven: Vendors){
        
            Vend_list.add((JSONObject)Ven);
        }
        
        ArrayList<Vendor> Ven_list = new ArrayList<Vendor>();
        
        for(JSONObject Ven: Vend_list){
        
            Vendor New_vendor = new Vendor(Ven.get("name").toString(), Ven.get("email").toString(), Ven.get("contact").toString(), Ven.get("address").toString(), true);
            
            Ven_list.add(New_vendor);
        }
        
        Comp.set_ven_list(Ven_list);
        
        ArrayList<Sale> Sales = new ArrayList<Sale>();
        
        JSONArray Sals = (JSONArray)The_json.get("sales");
        
        ArrayList<JSONObject> Sales_obj = new ArrayList<JSONObject>();
        
        for(Object Sale: Sals){
        
            Sales_obj.add((JSONObject)Sale);
        }
        
        for(JSONObject Sale: Sales_obj){
        
            ArrayList<Payment> Pay_list = new ArrayList<Payment>(); 
        
            JSONObject Payments = (JSONObject)Sale.get("payments");
            
            JSONArray Amounts = (JSONArray)Payments.get("amounts");
            ArrayList<Float> Amt_list = new ArrayList<Float>(); 
            
            JSONArray Types = (JSONArray)Payments.get("types");
            ArrayList<String> Type_list = new ArrayList<String>(); 
            
            JSONArray Refs = (JSONArray)Payments.get("refs");
            ArrayList<String> Ref_list = new ArrayList<String>(); 
            
            for(Object Amount: Amounts){
            
                Amt_list.add(Float.parseFloat(Amount.toString()));
            }
            
            for(Object Type: Types){
            
                Type_list.add(Type.toString());
            }
            
            for(Object Ref: Refs){
            
                Ref_list.add(Ref.toString());
            }
            
            int count1 = 0;
            
            for(float Amount: Amt_list){
            
                Pay_list.add(new Payment(Ref_list.get(count1), Amount, Type_list.get(count1)));
                count1++;
            }
            
            ArrayList<String> Code_list = new ArrayList<String>();
            
            JSONArray Codes = (JSONArray)Sale.get("codes");
            
            for(Object Code: Codes){
            
                Code_list.add(Code.toString());
            }
            
            ArrayList<Integer> Qt_list = new ArrayList<Integer>();
            
            JSONArray Qts = (JSONArray)Sale.get("qts");
            
            for(Object Qt: Qts){
            
                Qt_list.add(Integer.parseInt(Qt.toString()));
            }
            
            Customer Custom = null;
            
            for(Customer Cus: Cus_list){
            
                if(Cus.get_name().equals(Sale.get("customer").toString())){
                
                    Custom = Cus;
                }
            }
            
            
            Sales.add(new Sale(Integer.parseInt(Sale.get("id").toString()), Sale.get("vendor").toString(), Custom, Pay_list, Sale.get("date").toString(), Sale.get("time").toString(), Code_list, Qt_list));
        }
        
        Comp.set_sales(Sales);
        
        Comp.set_sales_count(Sales.size());
        
        return Comp;
 
        }
    
}

class Sale extends Feature{

    public int inv_no;
    public String vendor;
    public Customer Custom;
    public ArrayList<Payment> Pay_list = new ArrayList<Payment>();
    public String date;
    public String time;
    public ArrayList<String> Codes = new ArrayList<String>();
    public ArrayList<Integer> Qts = new ArrayList<Integer>();

    public Sale(int inv_no, String vendor, Customer Custom, ArrayList<Payment> Pay_list, String date, String time, ArrayList<String> Codes, ArrayList<Integer> Qts){

        super(Integer.toString(inv_no));
        this.inv_no = inv_no;
        this.vendor = vendor;
        this.Custom = Custom;
        this.Pay_list = Pay_list;
        this.date = date;
        this.time = time;
        this.Codes = Codes;
        this.Qts = Qts;
    }

    public int get_inv_no(){
    
        return inv_no;
    }

    public String get_vendor(){

        return vendor;
    }

    public Customer get_custom(){

        return Custom;
    }

    public ArrayList<Payment> get_pay_list(){

        return Pay_list;
    }

    public String get_date(){

        return date;
    }

    public String get_time(){

        return time;
    }

    public void set_codes(ArrayList<String> Codes){

        this.Codes = Codes;
    }

    public ArrayList<String> get_codes(){

        return Codes;
    }

    public void set_qts(ArrayList<Integer> Qts){

        this.Qts = Qts;
    }

    public ArrayList<Integer> get_qts(){

        return Qts;
    }
}

class Payment extends Feature{

    public String reference;
    public float amount;
    public String type;

    public Payment(String reference, float amount, String type){

        super(reference);
        this.reference = reference;
        this.amount = amount;
        this.type = type;
    }

    public String get_ref(){

        return reference;
    }

    public float get_amount(){

        return amount;
    }

    public String get_type(){

        return type;
    }
}

class Invoice extends Feature implements XS{

    public String bus_name;
    public String bus_add;
    public String bus_prov;
    public String bus_country;
    public String bus_phone;    
    public String bus_email;
    public String currency;
    public float tax;

    public Invoice(String name, String bus_name, String bus_add, String bus_prov, String bus_country, String bus_phone, String bus_email, String currency, float tax){

        super(name);

        this.bus_name = bus_name;
        this.bus_add = bus_add;
        this.bus_prov = bus_prov;
        this.bus_country = bus_country;
        this.bus_phone = bus_phone;
        this.bus_email = bus_email;
        this.currency = currency;
        this.tax = tax;
    }

//this method generates a customized invoice according to class and parameter values
    public void new_invoice(String a_date, String a_time, String a_inv_no, String a_vendor, String a_cus_name, String a_cus_code, String a_cus_address, String a_cus_phone, String a_currency, String a_prod_names[], float a_prod_prices[], int a_prod_qts[], float a_payments[], String a_types[], String a_refs[]) throws IOException {

            String bus_name = this.bus_name;
            String address = this.bus_add;
            String province = this.bus_prov;
            String country = this.bus_country;
            String phone = this.bus_phone;
            String email = this.bus_email;
            String date = a_date;
            String time = a_time;
            String inv_no = a_inv_no;
            String vendor = a_vendor;

            String div = "----------------------------------------";

            String cus_name = a_cus_name;
            String cus_code = a_cus_code;
            String cus_address = a_cus_address;
            String cus_phone = a_cus_phone;
            String currency = a_currency;

	        float tax = this.tax;
	        float acum_subtotal_no_tax = 0;    
	        float acum_subtotal_tax = 0;

            String prod_names[] = a_prod_names;
            float prod_prices[] = a_prod_prices;
            int prod_qts[] = a_prod_qts;

	        float payments[] = a_payments;
	        String types[] = a_types;
	        String refs[] = a_refs;
	        float acum_payments = 0;

            XSPDF xsPDF = new XSPDF();
            xsPDF.setPageSize(80, 270);
            xsPDF.setAlignment(CENTERED);
            xsPDF.setTextParagraphIndentationSpaces(1);
            xsPDF.setFont(COURIER, BOLD);
            xsPDF.setFontSize(2.66);
            xsPDF.setLineLeadingInPercent(75);

            xsPDF.print(bus_name + "\n" + address + "\n" + province + " | " + country + "\n" + phone + " | " + email + "\nDate: " + date + " at: " + time + "\n" + "Invoice #" + inv_no + " | by: " + vendor + "\n\n" + div + "\n");


            xsPDF.print("\nBill to: " + cus_name + " | " + cus_code + "\n" + cus_address + " | " + cus_phone + "\n\n" + div + "\n");

            int count1 = 0;
            float acum_total = 0;

            for(int a = 0; a < prod_names.length; a++){

                xsPDF.print("\n" + prod_names[a] + "\n");
                xsPDF.print((prod_prices[count1] * ((100 - tax)/100)) + " " + currency + " x " + prod_qts[count1] + " . . . ");
                xsPDF.print(((prod_prices[count1] * ((100 - tax)/100)) * prod_qts[count1]) + " " + currency + "\n");

		        acum_subtotal_no_tax += ((prod_prices[count1] * ((100 - tax)/100)) * prod_qts[count1]);
		        acum_subtotal_tax += (prod_prices[count1] * prod_qts[count1]);

                count1++;     
            }

            xsPDF.print("\n" + div + "\n\nSubtotal . . . . . . " + acum_subtotal_no_tax + " " + currency + "\n" + tax + "% TAX . . . . . . " + acum_subtotal_tax * (tax/100) + " " + currency + "\n\nTotal . . . . . . " + acum_subtotal_tax + " " + currency + "\n\n" + div + "\n");

	        for(int a = 0; a < payments.length; a++){

		        xsPDF.print("\n" + refs[a] + "\n" + types[a] + " | " + payments[a] + " USD\n");

		        acum_payments += payments[a];
	        }

	        xsPDF.print("\n" + div + "\n\n" + "Payment . . . . . . " + acum_payments + " " + currency + "\n\n" + div);

            xsPDF.createPdf("invoice_" + inv_no + ".pdf");

            if (Desktop.isDesktopSupported()) {

                try {

                    File myFile = new File("invoice_" + inv_no + ".pdf");

                    Desktop.getDesktop().open(myFile);

                } catch (IOException ex) {
                    // no application registered for PDFs
                }
            }
    }

    public void set_bus_name(String bus_name){

        this.bus_name = bus_name;
    }

    public String get_bus_name(){

        return bus_name;
    }

    public void set_bus_add(String bus_add){

        this.bus_add = bus_add;
    }

    public String get_bus_add(){

        return bus_add;
    }

    public void set_bus_prov(String bus_prov){

        this.bus_prov = bus_prov;
    }

    public String get_bus_prov(){

        return bus_prov;
    }

    public void set_bus_country(String bus_country){

        this.bus_country= bus_country;
    }

    public String get_bus_country(){

        return bus_country;
    }

    public void set_bus_phone(String bus_phone){

        this.bus_phone = bus_phone;
    }

    public String get_bus_phone(){

        return bus_phone;
    }

    public void set_bus_email(String bus_email){

        this.bus_email = bus_email;
    }

    public String get_bus_email(){

        return bus_email;
    }

    public void set_currency(String currency){

        this.currency = currency;
    }

    public String get_currency(){

        return currency;
    } 

    public void set_tax(float tax){

        this.tax = tax;
    }

    public float get_tax(){

        return tax;
    }       
}

class Customer extends Feature{

    public String code;
    public String email;
    public String contact;
    public String address;

    public Customer(String name, String code, String email, String contact, String address){

        super(name);

        this.email = email;
        this.code = code;
        this.contact = contact;
        this.address = address;
    }

    public void set_code(String code){

        this.code = code;
    }

    public String get_code(){

        return code;
    }

    public void set_email(String email){

        this.email = email;
    }

    public String get_email(){

        return email;
    }

    public void set_contact(String contact){

        this.contact = contact;
    }

    public String get_contact(){

        return contact;
    }

    public void set_address(String address){

        this.address = address;
    }

    public String get_address(){

        return address;
    }    
}

class Vendor extends Feature{

    public String email;
    public String contact;
    public String address;
    public boolean active;

    public Vendor(String name, String email, String contact, String address, boolean active){

        super(name);

        this.email = email;
        this.contact = contact;
        this.address = address;
        this.active = active;
    }

    public void set_email(String email){

        this.email = email;
    }

    public String get_email(){

        return email;
    }

    public void set_contact(String contact){

        this.contact = contact;
    }

    public String get_contact(){

        return contact;
    }

    public void set_address(String address){

        this.address = address;
    }

    public String get_address(){

        return address;
    }

    public void set_active(boolean active){

        this.active = active;
    }

    public boolean get_active(){

        return active;
    }    
}

class Product extends Feature{

    public String code;
    public float price;
    public String category;
    public String brand;
    public String description;
    public int warranty;

    public Product(String name, String code, float price, int warranty, String category, String brand, String description){

        super(name);

        this.code = code;
        this.price = price;
        this.category = category;
        this.brand = brand;
        this.warranty = warranty;
        this.description = description;
    }

    public void set_code(String code){

        this.code = code;
    }

    public String get_code(){

        return code;
    }

    public void set_price(float price){

        this.price = price;
    }

    public float get_price(){

        return price;
    }

    public void set_category(String category){

        this.category = category;
    }

    public String get_category(){

        return category;
    }

    public void set_brand(String code){

        this.brand = brand;
    }

    public String get_brand(){

        return brand;
    }

    public void set_warranty(int warranty){

        this.warranty = warranty;
    }

    public int get_warranty(){

        return warranty;
    }

    public void set_description(String description){

        this.description = description;
    }

    public String get_description(){

        return description;
    }
}

class Brand extends Feature{

    public Brand(String name){

        super(name);
    }
}

class Category extends Feature{

    public Category(String name){

        super(name);
    }
}

class Company extends Feature{

    static int sales_count;
    ArrayList<Category> Cat_list = new ArrayList<Category>();
    ArrayList<Brand> Bra_list = new ArrayList<Brand>();
    ArrayList<Product> Pro_list = new ArrayList<Product>();
    ArrayList<Vendor> Ven_list = new ArrayList<Vendor>();
    ArrayList<Customer> Cus_list = new ArrayList<Customer>();
    ArrayList<Sale> Sales = new ArrayList<Sale>();
    ArrayList<String> Codes = new ArrayList<String>();
    ArrayList<Integer> Qts = new ArrayList<Integer>();
    ArrayList<Payment> Current_pays = new ArrayList<Payment>();
    Invoice Inv;
    String current_custom;
    String current_vendor;
    String role;
    String vendor;

    public Company(String name, String role, String vendor){

        super(name);

        Inv = new Invoice("00", "Your Business Name N000000", "Your Address", "Province", "Country", "Phone", "Email", "USD", (float)10);
        
        this.role = role;
        this.vendor = vendor;

        sales_count = 0;
    }

    public void set_cat_list(ArrayList<Category> Cat_list){

        this.Cat_list = Cat_list;
    }

    public ArrayList<Category> get_cat_list(){

        return Cat_list;
    }

    public void set_bra_list(ArrayList<Brand> Bra_list){

        this.Bra_list = Bra_list;
    }

    public ArrayList<Brand> get_bra_list(){

        return Bra_list;
    }

    public void set_pro_list(ArrayList<Product> Pro_list){

        this.Pro_list = Pro_list;
    }

    public ArrayList<Product> get_pro_list(){

        return Pro_list;
    }

    public void set_ven_list(ArrayList<Vendor> Ven_list){

        this.Ven_list = Ven_list;
    }

    public ArrayList<Vendor> get_ven_list(){

        return Ven_list;
    }

    public void set_cus_list(ArrayList<Customer> Cus_list){

        this.Cus_list = Cus_list;
    }

    public ArrayList<Customer> get_cus_list(){

        return Cus_list;
    }

    public void set_invoice(Invoice Inv){

        this.Inv = Inv;
    }

    public Invoice get_invoice(){

        return Inv;
    }

    public void set_sales(ArrayList<Sale> Sales){

        this.Sales = Sales;
    }

    public ArrayList<Sale> get_sales(){
        
        return Sales;
    }

    public void set_codes(ArrayList<String> Codes){

        this.Codes = Codes;
    }

    public ArrayList<String> get_codes(){

        return Codes;
    }

    public void set_qts(ArrayList<Integer> Qts){

        this.Qts = Qts;
    }

    public ArrayList<Integer> get_qts(){

        return Qts;
    }

    public void set_current_custom(String current_custom){

        this.current_custom = current_custom;
    }

    public String get_current_custom(){

        return current_custom;
    }

    public String get_current_vendor(){

        return current_vendor;
    }

    public void set_current_pays(ArrayList<Payment> Current_pays){

        this.Current_pays = Current_pays;
    }

    public ArrayList<Payment> get_current_pays(){

        return Current_pays;
    }

    public static int get_sales_count(){

        return sales_count;
    }

    public static void set_sales_count(int count){

        sales_count = count;
    }
    
    public String get_vendor(){
    
        return vendor;
    }
    
    public String get_role(){
    
        return role;
    }
}

//super class for every point of sales object
class Feature implements Serializable{

    protected String name;

    public Feature(String name){

        this.name = name;
    }

    public void set_name(String name){

        this.name = name;
    }

    public String get_name(){

        return name;
    }
}

//super class for every tab panel object
class Tab_panel extends JPanel{

ArrayList<Company> C_list = new ArrayList<Company>();
static protected Image img = new ImageIcon("images/lobby_bg.png").getImage();
static protected JLabel Current_company = new JLabel("select a company");
static protected Company Comp;
static protected int comp_index;
Vndos_suite Win;


    Tab_panel(){

            Dimension size = new Dimension(img.getWidth(null), img.getHeight(null));
            setPreferredSize(size);
            setMinimumSize(size);
            setMaximumSize(size);
            setSize(size);
    }

    //this method saves all Companies in Vndos_record.bin
    public void save_companies(ArrayList<Company> Comp_list, String file_name)throws IOException{

        ObjectOutputStream Comp_file = new ObjectOutputStream(new FileOutputStream(file_name));
        Comp_file.writeObject(Comp_list);
        Comp_file.close();
    }

    //this method reads all Companies from Vndos_record.bin
    public ArrayList<Company> read_companies(String file_name)throws IOException, ClassNotFoundException{

        ObjectInputStream Comp_file = new ObjectInputStream(new FileInputStream(file_name));

        ArrayList<?> Raw = (ArrayList<?>)Comp_file.readObject();
        
        C_list.clear();

        for(Object El: Raw){

            C_list.add((Company)El);
        }

        Comp_file.close();

        return C_list;
    }

    //this method set a control for company instance
    public void switch_company(Company Comp){

        this.Comp = Comp;
        comp_index = C_list.indexOf(Comp);
        Current_company.setText(this.Comp.get_name());
    }

    //this method sets empty company instance
    public void switch_company(String empty){

        Current_company.setText(empty);
    }

    //this method repaint the current panel
    public void update(){

        revalidate();
        repaint();
    }

    //this method draws the background image
    public void paintComponent(Graphics g) {

        g.drawImage(img, 0, 0,getWidth(),getHeight(),this);
    }
}

class Board extends JPanel{

    ArrayList<Sale> Sales;
    ArrayList<String> Dates;
    ArrayList<Product> Pro_list;
    Invoice Inv;
	ArrayList<Integer> N_sales = new ArrayList<Integer>();
    ArrayList<Integer> Xline = new ArrayList<Integer>();
    ArrayList<Integer> Yline = new ArrayList<Integer>();
    ArrayList<String> Pre_dates = new ArrayList<String>();
    ArrayList<Float> Means_values;
    ArrayList<String> Means_from;
    ArrayList<Integer>  Means_index_from;
    ArrayList<String> Means_to;
    ArrayList<Integer> Means_index_to;
    ArrayList<Integer> Means_sales;
    boolean days = true; 

    int[] scale = {0,50,100,200,250,500,1000,2500,5000};

    int[] aug_scale = {0,10,30,40,50,70,80,90,100,120,140,160,180,200,220,230,250,300,350,400,500,600,700,800,900,1000,1300,1600,1900,2200,2500,3000,3500,4000,4500,5000};
   
    String[] months = {"JAN","FEB","MAR","APR","JUN","JUL","AUG","SEP","OCT","NOV","DEC"};

    public Board(ArrayList<Sale> Sales, ArrayList<String> Dates, ArrayList<Integer> N_sales, ArrayList<Product> Pro_list, Invoice Inv, String option) {

        days = true;
        this.Sales = Sales;
        this.Dates = Dates;
		this.N_sales = N_sales;
        this.Pro_list = Pro_list;
        this.Inv = Inv;

        switch(option){

        case "days":

        this.addMouseListener(new MouseInputAdapter(){
            public void mousePressed(MouseEvent e){

                for(int a = 1; a <= Dates.size(); a++){

                    for(int c = 0; c < 35; c++){

			            if(N_sales.get(a-1) < aug_scale[c+1] && N_sales.get(a-1) >= aug_scale[c]){

                            double y = (10/(aug_scale[c+1]-aug_scale[c]));

                            double z = (N_sales.get(a-1));

                            if((e.getX() >= (50 + (a * (320/Dates.size()))) && e.getX() <= ((50 + (a * (320/Dates.size()))) + 14)) && (e.getY() >= (370 - (10*(c+1)) - (int)(y * z)) && e.getY() <= (370 - (10*(c+1)) - (int)(y * z) + 7))){

                                open_modal(Dates.get(a-1), N_sales.get(a-1));
                            }

                            }
                    }
                }
            }
        });

        break;

        }
    }
    
    public Board(ArrayList<Sale> Sales, ArrayList<String> Dates, ArrayList<Product> Pro_list, ArrayList<Float> Means_values, ArrayList<String> Means_from, ArrayList<Integer>  Means_index_from, ArrayList<String> Means_to, ArrayList<Integer> Means_index_to, ArrayList<Integer> Means_sales){
    
        days = false;
        this.Sales = Sales;
        this.Dates = Dates;
        this.Pro_list = Pro_list;
        this.Means_values = Means_values;
        this.Means_from = Means_from;
        this.Means_index_from = Means_index_from;
        this.Means_to = Means_to;
        this.Means_index_to = Means_index_to;
        this.Means_sales = Means_sales;
    
        this.addMouseListener(new MouseInputAdapter(){
            public void mousePressed(MouseEvent e){

                for(int a = 1; a <= Means_values.size(); a++){

                    for(int c = 0; c < 35; c++){

			            if(Means_values.get(a-1) < aug_scale[c+1] && Means_values.get(a-1) >= aug_scale[c]){

                            double y = (10/(aug_scale[c+1]-aug_scale[c]));

                            double z = (Means_values.get(a-1));

                            if((e.getX() >= (50 + (a * (320/Means_values.size()))) && e.getX() <= ((50 + (a * (320/Means_values.size()))) + 14)) && (e.getY() >= (370 - (10*(c+1)) - (int)(y * z)) && e.getY() <= (370 - (10*(c+1)) - (int)(y * z) + 7))){
                                
                                for(int into = Means_index_from.get(a-1); into < Means_index_to.get(a-1); into++){
                                
                                    Pre_dates.add(Dates.get(into));
                                }
                                
                                open_means_modal(Means_sales.get(a-1));
                                Pre_dates = new ArrayList<String>();
                            }

                            }
                    }
                }
            }
        });
    }


    public Dimension getPreferredSize() {
        return new Dimension(400, 400);
    }
    
    public void paintComponent(Graphics g) {
    
        if(days){

        super.paintComponent(g);

        setForeground(Color.DARK_GRAY);

        g.drawString(("Total Sales from " + Dates.get(0) + " to " + Dates.get(Dates.size()-1) + " by VndOS App"),24,20);

        

        g.drawLine(50, 40, 50, 360);

        g.drawLine(50, 360, 370, 360);

        //draw y axis
        for(int a = 0; a < 8; a++){

            g.drawLine(46, 40 + (a * 40), 54, 40 + (a * 40));
            g.drawString(Integer.toString(scale[8-a]),10,47 + (a * 40));
        }

        int b = 0;

        //draw x axis
        for(int a = 1; a <= Dates.size(); a++){

            if(b == 36){

                b = 0;
            }

            //this procedure its OK for ovals 
            g.drawLine((50 + (a * (320/Dates.size()))), 356, (50 + (a * (320/Dates.size()))), 364);

            for(int c = 0; c < 35; c++){

			    if(N_sales.get(a-1) < aug_scale[c+1] && N_sales.get(a-1) >= aug_scale[c]){

                    double y = (10/(aug_scale[c+1]-aug_scale[c]));

                    double z = (N_sales.get(a-1));

                    g.setColor(Color.BLUE);    
                    g.fillOval((50 + (a * (320/Dates.size()))),370 - (10*(c+1)) - (int)(y * z), 14, 7);
                    g.setColor(Color.DARK_GRAY);

                    Xline.add((50 + (a * (320/Dates.size()))));
                    Yline.add(370 - (10*(c+1)) - (int)(y * z));
                }
            }  

            String[] date_arr = Dates.get(a-1).split("-");


            g.drawString((months[Integer.parseInt(date_arr[1]) - 1] + " " + date_arr[2]),(50 + (a * (320/Dates.size()))) - ((320/Dates.size())/2),377 + b);
            b += 12;
        }

        for(int a = 0; a < (Dates.size()-1); a++){

            g.drawLine((Xline.get(a)+5), (Yline.get(a)+3), (Xline.get(a+1)+5), (Yline.get(a+1)+3)); 
        }
        
        }else{
        
        
        super.paintComponent(g);

        setForeground(Color.DARK_GRAY);

        g.drawString(("Total Sales from " + Means_from.get(0) + " to " + Means_to.get(Means_values.size()-1) + " by VndOS App"),24,20);

        

        g.drawLine(50, 40, 50, 360);

        g.drawLine(50, 360, 370, 360);

        //draw y axis
        for(int a = 0; a < 8; a++){

            g.drawLine(46, 40 + (a * 40), 54, 40 + (a * 40));
            g.drawString(Integer.toString(scale[8-a]),10,47 + (a * 40));
        }

        int b = 0;

        //draw x axis
        for(int a = 1; a <= Means_values.size(); a++){

            if(b == 36){

                b = 0;
            }

            //this procedure its OK for ovals 
            g.drawLine((50 + (a * (320/Means_values.size()))), 356, (50 + (a * (320/Means_values.size()))), 364);

            for(int c = 0; c < 35; c++){

			    if(Means_values.get(a-1) < aug_scale[c+1] && Means_values.get(a-1) >= aug_scale[c]){

                    double y = (10/(aug_scale[c+1]-aug_scale[c]));

                    double z = (Means_values.get(a-1));

                    g.setColor(Color.BLUE);    
                    g.fillOval((50 + (a * (320/Means_values.size()))),370 - (10*(c+1)) - (int)(y * z), 14, 7);
                    g.setColor(Color.DARK_GRAY);

                    Xline.add((50 + (a * (320/Means_values.size()))));
                    Yline.add(370 - (10*(c+1)) - (int)(y * z));
                }
            }

            String[] date_arr = Means_to.get(a-1).split("-");

            g.drawString((months[Integer.parseInt(date_arr[1]) - 1] + " " + date_arr[2]),(50 + (a * (320/Means_values.size()))) - ((320/Means_values.size())/2),377 + b);
            b += 12;
        }
        
        g.drawLine(60, (Yline.get(0)+3), (Xline.get(0)+5), (Yline.get(0)+3));

        for(int a = 0; a < (Means_values.size()-1); a++){

            g.drawLine((Xline.get(a)+5), (Yline.get(a+1)+3), (Xline.get(a+1)+5), (Yline.get(a+1)+3)); 
        }
        }
    }

    public void open_modal(String date, int n_sales){

        Integer zero = 0;
        ArrayList<String> Vnd_names = new ArrayList<String>();
        ArrayList<Float> Vnd_amts = new ArrayList<Float>();
        ArrayList<String> Prod_names = new ArrayList<String>();
        ArrayList<Float> Prod_amts = new ArrayList<Float>();
        ArrayList<Integer> Prod_qts = new ArrayList<Integer>();
        ArrayList<String> City_names = new ArrayList<String>();
        ArrayList<Float> City_amts = new ArrayList<Float>();
        ArrayList<Sale> Day_sales = new ArrayList<Sale>();
        JPanel M_panel = new JPanel();
        JButton R_button1;
        M_panel.setLayout(new BoxLayout(M_panel, BoxLayout.Y_AXIS));    
        float acum_amount = 0;
        int acum_items = 0;
        JLabel Label1, Label2, Label3, Label4, Label5, Label6, Label7, Label8, Label9, Label10; 
        
        for(Sale Sal: Sales){

            if(Sal.get_date().equals(date)){

                Day_sales.add(Sal);

                ArrayList<Integer> Qts = Sal.get_qts();
			    ArrayList<Payment> Pays = Sal.get_pay_list();
                ArrayList<String> Codes = Sal.get_codes();
                ArrayList<String> Names = new ArrayList<String>();
                ArrayList<Float> Prices = new ArrayList<Float>();

                for(String code: Codes){

                    for(Product Pro: Pro_list){

                        if(Pro.get_code().equals(code)){

                            Prices.add(Pro.get_price());
                            Names.add(Pro.get_name());
                        }
                    }
                }

                boolean flag1 = false;
                boolean flag3 = false;

                for(String vnd_name: Vnd_names){

                    if(vnd_name.equals(Sal.get_vendor())){

                        flag1 = true;
                    }
                }

                if(!flag1){

                    Vnd_names.add(Sal.get_vendor());
                    Vnd_amts.add(zero.floatValue());
                }

                for(String city_name: City_names){

                    if(city_name.equals(Sal.get_custom().get_address())){

                        flag3 = true;
                    }
                }

                if(!flag3){

                    City_names.add(Sal.get_custom().get_address());
                    City_amts.add(zero.floatValue());
                }
            
                int count1 = 0;

                for(int qt: Qts){
                    
                    boolean flag2 = false;

                    acum_items += qt;

                    for(String prod_name: Prod_names){

                        if(prod_name.equals(Names.get(count1))){

                            flag2 = true;
                        }
                    }

                    if(!flag2){

                        Prod_names.add(Names.get(count1));
                        Prod_amts.add(zero.floatValue());
                        Prod_qts.add(0);
                    }

                    count1++;
                }

                for(Payment Pay: Pays){

                    acum_amount += Pay.get_amount();
                }
            }
        }

        for(Sale Sal: Sales){

                if(Sal.get_date().equals(date)){

                ArrayList<Integer> Qts = Sal.get_qts();
			    ArrayList<Payment> Pays = Sal.get_pay_list();
                ArrayList<String> Codes = Sal.get_codes();
                ArrayList<String> Names = new ArrayList<String>();
                ArrayList<Float> Prices = new ArrayList<Float>();

                for(String code: Codes){

                    for(Product Pro: Pro_list){

                        if(Pro.get_code().equals(code)){

                            Prices.add(Pro.get_price());
                            Names.add(Pro.get_name());
                        }
                    }
                }

                    int count1 = 0;

                    for(String vnd_name: Vnd_names){

                        if(vnd_name.equals(Sal.get_vendor())){

                            float old_amt = Vnd_amts.get(count1);
                            
                            for(Payment Pay: Pays){

                                old_amt += Pay.get_amount();
                            }

                            Vnd_amts.set(count1, old_amt);
                        }
                        count1++;
                    }

                    count1 = 0;

                    for(String city_name: City_names){

                        if(city_name.equals(Sal.get_custom().get_address())){

                            float old_amt = City_amts.get(count1);
                            
                            for(Payment Pay: Pays){

                                old_amt += Pay.get_amount();
                            }

                            City_amts.set(count1, old_amt);
                        }
                        count1++;
                    }

                    count1 = 0;

                    for(int qt: Qts){

                        int count2 = 0;

                        for(String prod_name: Prod_names){

                            if(prod_name.equals(Names.get(count1))){

                                float old_amt = Prod_amts.get(count2);
                                old_amt += (qt * Prices.get(count1));
                                Prod_amts.set(count2, old_amt);

                                int old_qt = Prod_qts.get(count2);
                                old_qt += qt;
                                Prod_qts.set(count2, old_qt);
                            }

                            count2++;
                        }

                        count1++;
                    }
                }
        }

        R_button1 = new JButton("open Report Manager for this day");
        R_button1.setAlignmentX(this.CENTER_ALIGNMENT);

		R_button1.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                    int count1 = 0;
                    String data[][] = new String[Day_sales.size()][7];

                    for(Sale Sal: Day_sales){

                        Integer inv_no = Integer.valueOf(Sal.get_inv_no());

                        float amount = 0;

                        for(Payment Pay: Sal.get_pay_list()){

                            amount += Pay.get_amount();
                        }

                        data[count1][0] =  inv_no.toString();
                        data[count1][1] =  Sal.get_custom().get_name();
                        data[count1][2] =  Float.toString(amount);
                        data[count1][3] =  "click here ...";
                        data[count1][4] =  Sal.get_time();
                        data[count1][5] =  Sal.get_custom().get_address();
                        data[count1][6] =  Sal.get_vendor();

                        count1++;
                    }

                    String columns[]={"Sale ID","Customer","Amount","Invoice","Time","City","Vendor"};

                    JTable R_table = new JTable(data, columns);
                    TableColumnModel Column_model = R_table.getColumnModel();
                    Column_model.getColumn(0).setPreferredWidth(60);
                    Column_model.getColumn(1).setPreferredWidth(140);
                    Column_model.getColumn(2).setPreferredWidth(80);
                    Column_model.getColumn(3).setPreferredWidth(80);
                    Column_model.getColumn(4).setPreferredWidth(60);
                    Column_model.getColumn(5).setPreferredWidth(120);
                    Column_model.getColumn(6).setPreferredWidth(100);

                    R_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
                    R_table.setCellSelectionEnabled(true); 
                    ListSelectionModel Select = R_table.getSelectionModel();  
                    Select.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

                    Select.addListSelectionListener(new ListSelectionListener() {  
                        public void valueChanged(ListSelectionEvent e) {

                            if(!e.getValueIsAdjusting()){

                            int[] rows = R_table.getSelectedRows();
                            int[] columns = R_table.getSelectedColumns();

                            if(columns[0] == 3){
        
                                int column = columns[0] - 3;

                                String data = (String)R_table.getValueAt(rows[0], column);

                                for(Sale Sal: Day_sales){

                                    Integer inv_no = Integer.valueOf(Sal.get_inv_no());

                                    if(data.equals(inv_no.toString())){

                                        String cus_name = Sal.get_custom().get_name();
                                        String cus_code = Sal.get_custom().get_code();
                                        String cus_address = Sal.get_custom().get_address();
                                        String cus_phone = Sal.get_custom().get_contact();
                                        String currency = Inv.get_currency();
                                        String date = Sal.get_date();
                                        String time = Sal.get_time();
                                        String inv_no2 = data;
                                        String vendor = Sal.get_vendor();

                                        int count2 = 0;

                                        String prod_names[] = new String[Sal.get_codes().size()];
                                        float prod_prices[] = new float[Sal.get_codes().size()];
                                        int prod_qts[] = new int[Sal.get_codes().size()];

                                        for(String code: Sal.get_codes()){

                                                for(Product Pro: Pro_list){

                                                        if(Pro.get_code().equals(code)){

                                                            prod_names[count2] = Pro.get_name();
                                                            prod_prices[count2] = Pro.get_price();
                                                            prod_qts[count2] = Sal.get_qts().get(count2);
                                                        }
                                                }
                                            count2++;
                                        }

	                                    float payments[] = new float[Sal.get_pay_list().size()];
	                                    String types[] = new String[Sal.get_pay_list().size()];
	                                    String refs[] = new String[Sal.get_pay_list().size()];

                                        count2 = 0;        
    
                                        for(Payment Pay: Sal.get_pay_list()){
                                            
                                            payments[count2] = Pay.get_amount();
                                            types[count2] = Pay.get_type();
                                            refs[count2] = Pay.get_ref();
                                            count2++;
                                        }

                                        try{

                                            Inv.new_invoice(date, time, inv_no2, vendor, cus_name, cus_code, cus_address, cus_phone, currency, prod_names, prod_prices, prod_qts, payments, types, refs);

                                        }catch(IOException Ioe){
    
                                            System.out.println("An error has occurred, try again");
                                        }
                                    }
                                }
                            }

                            }
                        }
                    });

                    JScrollPane Rs_pane = new JScrollPane(R_table);
                    JFrame R_frame = new JFrame(date + " Report");
                    R_frame.add(Rs_pane);
                    R_frame.setSize(400, 600);
                    R_frame.setLocationRelativeTo(null);
                    R_frame.setVisible(true);
                }
        });

        Label1 = new JLabel("Total sales: . . . " + n_sales);
        Label1.setAlignmentX(this.CENTER_ALIGNMENT);
        Label2 = new JLabel("Total items: . . . " + acum_items);
        Label2.setAlignmentX(this.CENTER_ALIGNMENT);
        Label3 = new JLabel("Total amount: . . . " + acum_amount);
        Label3.setAlignmentX(this.CENTER_ALIGNMENT);

        
        Label8 = new JLabel("Vendors");
        Label9 = new JLabel("Products");
        Label10 = new JLabel("Areas");  

        M_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        M_panel.add(R_button1);
        M_panel.add(Box.createRigidArea(new Dimension(0, 10)));
        M_panel.add(Label1);
        M_panel.add(Label2);
        M_panel.add(Label3);

        
        JLabel[] Vnd_labels = new JLabel[Vnd_names.size()];
		JLabel[] Prod_labels = new JLabel[Prod_names.size()];
		JLabel[] City_labels = new JLabel[City_names.size()];

        int count = 0;

        M_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        M_panel.add(Label8);
        Label8.setAlignmentX(M_panel.CENTER_ALIGNMENT);
		M_panel.add(Box.createRigidArea(new Dimension(0, 10)));

        for(String vnd: Vnd_names){

            Vnd_labels[count] = new JLabel(vnd + " . . . " + Vnd_amts.get(count) + " . . . " + (Vnd_amts.get(count)/acum_amount)*100 + " % ");
            M_panel.add(Vnd_labels[count]);
            Vnd_labels[count].setAlignmentX(M_panel.CENTER_ALIGNMENT);
            count++;
        }
        
        M_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        M_panel.add(Label9);
        Label9.setAlignmentX(M_panel.CENTER_ALIGNMENT);
		M_panel.add(Box.createRigidArea(new Dimension(0, 10)));

		count = 0;

        for(String prod: Prod_names){

            Prod_labels[count] = new JLabel(prod + " . . . " + Prod_amts.get(count) + " . . . " + (Prod_amts.get(count)/acum_amount)*100 + " % . . . " + Prod_qts.get(count) + " U");
            M_panel.add(Prod_labels[count]);
            Prod_labels[count].setAlignmentX(M_panel.CENTER_ALIGNMENT);
            count++;
        }

		M_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        M_panel.add(Label10);
        Label10.setAlignmentX(M_panel.CENTER_ALIGNMENT);
		M_panel.add(Box.createRigidArea(new Dimension(0, 10)));

		count = 0;

        for(String city: City_names){

            City_labels[count] = new JLabel(city + " . . . " + City_amts.get(count) + " . . . " + (City_amts.get(count)/acum_amount)*100 + " %");
            M_panel.add(City_labels[count]);
            City_labels[count].setAlignmentX(M_panel.CENTER_ALIGNMENT);
            count++;
        }

		M_panel.add(Box.createRigidArea(new Dimension(0, 20)));

        JScrollPane S_pane = new JScrollPane(M_panel);
    
        String[] date_arr = date.split("-");

        JFrame M_frame = new JFrame(months[Integer.parseInt(date_arr[1])-1] + " " + date_arr[2] + " " + date_arr[0]);
        M_frame.add(S_pane);        


        M_frame.setSize(400, 600);
        M_frame.setLocationRelativeTo(null);
        M_frame.setVisible(true);
    }
    
    public void open_means_modal(int n_sales){

        Integer zero = 0;
        ArrayList<String> Vnd_names = new ArrayList<String>();
        ArrayList<Float> Vnd_amts = new ArrayList<Float>();
        ArrayList<String> Prod_names = new ArrayList<String>();
        ArrayList<Float> Prod_amts = new ArrayList<Float>();
        ArrayList<Integer> Prod_qts = new ArrayList<Integer>();
        ArrayList<String> City_names = new ArrayList<String>();
        ArrayList<Float> City_amts = new ArrayList<Float>();
        JPanel M_panel = new JPanel();
        M_panel.setLayout(new BoxLayout(M_panel, BoxLayout.Y_AXIS));    
        float acum_amount = 0;
        int acum_items = 0;
        JLabel Label1, Label2, Label3, Label4, Label5, Label6, Label7, Label8, Label9, Label10; 
        
        
        for(Sale Sal: Sales){
        
            for(String date: Pre_dates){

            if(Sal.get_date().equals(date)){
            
                ArrayList<Integer> Qts = Sal.get_qts();
		        ArrayList<Payment> Pays = Sal.get_pay_list();
                ArrayList<String> Codes = Sal.get_codes();
                ArrayList<String> Names = new ArrayList<String>();
                ArrayList<Float> Prices = new ArrayList<Float>();
            
                for(String code: Codes){

                    for(Product Pro: Pro_list){

                        if(Pro.get_code().equals(code)){

                            Prices.add(Pro.get_price());
                            Names.add(Pro.get_name());
                        }
                    }
                }

                boolean flag1 = false;
                boolean flag3 = false;

                for(String vnd_name: Vnd_names){

                    if(vnd_name.equals(Sal.get_vendor())){

                        flag1 = true;
                    }
                }

                if(!flag1){

                    Vnd_names.add(Sal.get_vendor());
                    Vnd_amts.add(zero.floatValue());
                }

                for(String city_name: City_names){

                    if(city_name.equals(Sal.get_custom().get_address())){

                        flag3 = true;
                    }
                }

                if(!flag3){

                    City_names.add(Sal.get_custom().get_address());
                    City_amts.add(zero.floatValue());
                }
            
                int count1 = 0;

                for(int qt: Qts){
                    
                    boolean flag2 = false;

                    acum_items += qt;

                    for(String prod_name: Prod_names){

                        if(prod_name.equals(Names.get(count1))){

                            flag2 = true;
                        }
                    }

                    if(!flag2){

                        Prod_names.add(Names.get(count1));
                        Prod_amts.add(zero.floatValue());
                        Prod_qts.add(0);
                    }

                    count1++;
                }

                for(Payment Pay: Pays){

                    acum_amount += Pay.get_amount();
                }
            }
            
            }
        }

        for(Sale Sal: Sales){
        
                for(String date: Pre_dates){

                if(Sal.get_date().equals(date)){

                ArrayList<Integer> Qts = Sal.get_qts();
			    ArrayList<Payment> Pays = Sal.get_pay_list();
                ArrayList<String> Codes = Sal.get_codes();
                ArrayList<String> Names = new ArrayList<String>();
                ArrayList<Float> Prices = new ArrayList<Float>();

                for(String code: Codes){

                    for(Product Pro: Pro_list){

                        if(Pro.get_code().equals(code)){

                            Prices.add(Pro.get_price());
                            Names.add(Pro.get_name());
                        }
                    }
                }

                    int count1 = 0;

                    for(String vnd_name: Vnd_names){

                        if(vnd_name.equals(Sal.get_vendor())){

                            float old_amt = Vnd_amts.get(count1);
                            
                            for(Payment Pay: Pays){

                                old_amt += Pay.get_amount();
                            }

                            Vnd_amts.set(count1, old_amt);
                        }
                        count1++;
                    }

                    count1 = 0;

                    for(String city_name: City_names){

                        if(city_name.equals(Sal.get_custom().get_address())){

                            float old_amt = City_amts.get(count1);
                            
                            for(Payment Pay: Pays){

                                old_amt += Pay.get_amount();
                            }

                            City_amts.set(count1, old_amt);
                        }
                        count1++;
                    }

                    count1 = 0;

                    for(int qt: Qts){

                        int count2 = 0;

                        for(String prod_name: Prod_names){

                            if(prod_name.equals(Names.get(count1))){

                                float old_amt = Prod_amts.get(count2);
                                old_amt += (qt * Prices.get(count1));
                                Prod_amts.set(count2, old_amt);

                                int old_qt = Prod_qts.get(count2);
                                old_qt += qt;
                                Prod_qts.set(count2, old_qt);
                            }

                            count2++;
                        }

                        count1++;
                    }
                }
                
                }
        }

        Label1 = new JLabel("Total sales: . . . " + n_sales);
        Label1.setAlignmentX(this.CENTER_ALIGNMENT);
        Label2 = new JLabel("Total items: . . . " + acum_items);
        Label2.setAlignmentX(this.CENTER_ALIGNMENT);
        Label3 = new JLabel("Total amount: . . . " + acum_amount);
        Label3.setAlignmentX(this.CENTER_ALIGNMENT);

        
        Label8 = new JLabel("Vendors");
        Label9 = new JLabel("Products");
        Label10 = new JLabel("Areas");  

        M_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        M_panel.add(Label1);
        M_panel.add(Label2);
        M_panel.add(Label3);

        
        JLabel[] Vnd_labels = new JLabel[Vnd_names.size()];
		JLabel[] Prod_labels = new JLabel[Prod_names.size()];
		JLabel[] City_labels = new JLabel[City_names.size()];

        int count = 0;

        M_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        M_panel.add(Label8);
        Label8.setAlignmentX(M_panel.CENTER_ALIGNMENT);
		M_panel.add(Box.createRigidArea(new Dimension(0, 10)));

        for(String vnd: Vnd_names){

            Vnd_labels[count] = new JLabel(vnd + " . . . " + Vnd_amts.get(count) + " . . . " + (Vnd_amts.get(count)/acum_amount)*100 + " % ");
            M_panel.add(Vnd_labels[count]);
            Vnd_labels[count].setAlignmentX(M_panel.CENTER_ALIGNMENT);
            count++;
        }
        
        M_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        M_panel.add(Label9);
        Label9.setAlignmentX(M_panel.CENTER_ALIGNMENT);
		M_panel.add(Box.createRigidArea(new Dimension(0, 10)));

		count = 0;

        for(String prod: Prod_names){

            Prod_labels[count] = new JLabel(prod + " . . . " + Prod_amts.get(count) + " . . . " + (Prod_amts.get(count)/acum_amount)*100 + " % . . . " + Prod_qts.get(count) + " U");
            M_panel.add(Prod_labels[count]);
            Prod_labels[count].setAlignmentX(M_panel.CENTER_ALIGNMENT);
            count++;
        }

		M_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        M_panel.add(Label10);
        Label10.setAlignmentX(M_panel.CENTER_ALIGNMENT);
		M_panel.add(Box.createRigidArea(new Dimension(0, 10)));

		count = 0;

        for(String city: City_names){

            City_labels[count] = new JLabel(city + " . . . " + City_amts.get(count) + " . . . " + (City_amts.get(count)/acum_amount)*100 + " %");
            M_panel.add(City_labels[count]);
            City_labels[count].setAlignmentX(M_panel.CENTER_ALIGNMENT);
            count++;
        }

		M_panel.add(Box.createRigidArea(new Dimension(0, 20)));

        JScrollPane S_pane = new JScrollPane(M_panel);
    
        String[] date_arr1 = Pre_dates.get(0).split("-");
        String[] date_arr2 = Pre_dates.get(Pre_dates.size()-1).split("-");

        JFrame M_frame = new JFrame("from " + months[Integer.parseInt(date_arr1[1])-1] + " " + date_arr1[2] + " " + date_arr1[0] + " to " + months[Integer.parseInt(date_arr2[1])-1] + " " + date_arr2[2] + " " + date_arr2[0]);
        
        M_frame.add(S_pane);
        M_frame.setSize(400, 600);
        M_frame.setLocationRelativeTo(null);
        M_frame.setVisible(true);
    }        
}

class Analytics_panel extends Tab_panel{

    JLabel C_label = new JLabel();
    JLabel Label1, Label2, Label3, Label4, Label5, Label6, Label7, Label8, Label9, Label10, Label5p, Label6p, Label7p;
    JButton Button5, Button1, Button2, Button3;
    ArrayList<Sale> Sales = new ArrayList<Sale>();
	ArrayList<Integer>  N_sales = new ArrayList<Integer>();
    ArrayList<String> Dates_sales = new ArrayList<String>();
    ArrayList<String> Vnd_names = new ArrayList<String>();
    ArrayList<Float> Vnd_amts = new ArrayList<Float>();
    ArrayList<String> Prod_names = new ArrayList<String>();
    ArrayList<Float> Prod_amts = new ArrayList<Float>();
    ArrayList<Integer> Prod_qts = new ArrayList<Integer>();
    ArrayList<String> City_names = new ArrayList<String>();
    ArrayList<Float> City_amts = new ArrayList<Float>();
    ArrayList<String> Dates = new ArrayList<String>();
    ArrayList<String> Years = new ArrayList<String>();
    ArrayList<String> Months = new ArrayList<String>();
    ArrayList<String> Days = new ArrayList<String>();
    ArrayList<Float> Means_values = new ArrayList<Float>();
    ArrayList<String> Means_from = new ArrayList<String>();
    ArrayList<String> Means_to = new ArrayList<String>();
    ArrayList<Integer> Means_index_from = new ArrayList<Integer>();
    ArrayList<Integer> Means_index_to = new ArrayList<Integer>();
    ArrayList<Integer> Means_sales = new ArrayList<Integer>();
    Board Iboard;  
    String[] dates;
	String[] months = {"JAN","FEB","MAR","APR","JUN","JUL","AUG","SEP","OCT","NOV","DEC"};
    JPanel E_panel = new JPanel();
    JPanel E_partial_panel = new JPanel();

	Analytics_panel(){

		super();
		
		System.out.println(Comp.get_role());
		
        setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
        C_label.setText(Current_company.getText());
        
        ArrayList<String> Check_dates = new ArrayList<String>();
        boolean initial_flag = false;
        Sales = Comp.get_sales();
        
        for(Sale Sal: Sales){
        
            initial_flag = false;
        
            for(String date: Check_dates){
            
                if(date.equals(Sal.get_date())){
                
                    initial_flag = true;
                }
            }
            
            if(!initial_flag){
            
                Check_dates.add(Sal.get_date());
            }
        }

        

        if(Sales.size() > 1 && Check_dates.size() > 1){

            board_init();
			embed_init();
	    
        

		Button1 = new JButton("Select range");
		Button1.setAlignmentX(this.CENTER_ALIGNMENT);

		Button1.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){
                
                    JFrame P_frame = new JFrame("Select range");  
                    JPanel P_panel = new JPanel();
                    JLabel Label1 = new JLabel("From");
        			JLabel Label2 = new JLabel("To");
					
					final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();
					final DefaultComboBoxModel<String> Pre_combo2 = new DefaultComboBoxModel<String>();
					
					Pre_combo1.addElement(Dates.get(0));
            		Pre_combo2.addElement(Dates.get(Dates.size()-1));
        
        			for(String date: Dates_sales){

            			Pre_combo1.addElement(date);
            			Pre_combo2.addElement(date);
        			}
        			
        			final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);
        			final JComboBox<String> Com_box2 = new JComboBox<String>(Pre_combo2);

					JButton Button1 = new JButton("OK");

					Button1.addActionListener(new ActionListener(){  
                		public void actionPerformed(ActionEvent e){
                		
                		    int index_from = 0, index_to = 0, count1 = 0;
                		
                		    String date_from = Com_box1.getSelectedItem().toString();
                		    String date_to = Com_box2.getSelectedItem().toString();

							for(String date: Dates_sales){

								if(date.equals(date_from)){

									index_from = count1;
									break;
								}

								count1++;
							}

							count1 = 0;

							for(String date: Dates_sales){

								if(date.equals(date_to)){

									index_to = count1;
									break;
								}

								count1++;
							}

							

							if(index_from > index_to || (index_from == index_to) || (index_to - index_from < 2)){

								JFrame A_frame = new JFrame("alert");  
                   				JPanel A_panel = new JPanel();
								JLabel A_label1 = new JLabel("check dates, 3 days minimum, 14 months maximum");

								JButton A_button = new JButton("OK");
								A_button.addActionListener(new ActionListener(){  
                					public void actionPerformed(ActionEvent e){

                    					A_frame.setVisible(false);
									}
								});

								A_panel.add(A_label1);
								A_panel.add(A_button);

								A_frame.add(A_panel);
								A_frame.setSize(370, 100);  
                    			A_frame.setLocationRelativeTo(null);
                    			A_frame.setVisible(true);
							}else{
							
                                Dates = new ArrayList<String>();
                                N_sales = new ArrayList<Integer>();
                                int diff = index_to - index_from;
                                boolean flag1 = false;

                                for(int a = index_from; a < index_to; a++){

                                    for(String date: Dates){

                                        if(date.equals(Dates_sales.get(a))){

                                            flag1 = true;
                                        }
                                    }

                                    if(!flag1){

                                        Dates.add(Dates_sales.get(a));
                                    }

                                    flag1 = false;
                                }
                                
                                for(String date: Dates){
                                
                                    N_sales.add(0);
                                }

                                for(Sale Sal: Sales){
                                
                                    int count = 0;
                                
                                    for(String date: Dates){
                                    
                                        if(date.equals(Sal.get_date())){
                                        
                                            int old_count = N_sales.get(count);
                                            old_count++;
                                            N_sales.set(count, old_count);
                                        }
                                        
                                        count++;
                                    }
                                }

                                
                            Vnd_names = new ArrayList<String>();
                            Vnd_amts = new ArrayList<Float>();
                            Prod_names = new ArrayList<String>();
                            Prod_amts = new ArrayList<Float>();
                            Prod_qts = new ArrayList<Integer>();
                            City_names = new ArrayList<String>();
                            City_amts = new ArrayList<Float>();
                                
                                if(diff < 15){
                                
                                    Iboard = new Board(Sales, Dates, N_sales, Comp.get_pro_list(), Comp.get_invoice(), "days");
                                    E_panel.removeAll();
                                    E_partial_panel.removeAll();
                                    embed_init();
                                }else if(diff > 14 && diff < 91){
                                
                                    int count1a = 0;
                                    int count2a = 0;
                                    int acum = 0;
                                    
                                    for(String date: Dates){
                                    
                                        acum += N_sales.get(count1a);
                                    
                                        if(count2a == 0){
                                        
                                            Means_from.add(Dates.get(count1a));
                                            Means_index_from.add(count1a);
                                        }else if(count2a == 6){
                                        
                                            Integer acumi = Integer.valueOf(acum);
                                        
                                            Means_to.add(Dates.get(count1a));
                                            Means_index_to.add(count1a);
                                            Means_values.add(acumi.floatValue()/7);
                                            Means_sales.add(acum);
                                            acum = 0;
                                        }
                                        
                                        count1a++;
                                        
                                        if(count2a == 6){
                                        
                                            count2a = 0;
                                        }else{
                                        
                                            count2a++;
                                        }
                                    }
                                    
                                    Iboard = new Board(Sales, Dates, Comp.get_pro_list(), Means_values, Means_from, Means_index_from, Means_to, Means_index_to, Means_sales);
                                    
                                    
                                    Means_values = new ArrayList<Float>();
                                    Means_from = new ArrayList<String>();
                                    Means_to = new ArrayList<String>();
                                    Means_index_from = new ArrayList<Integer>();
                                    Means_index_to = new ArrayList<Integer>();
                                    Means_sales = new ArrayList<Integer>();
                                }else{

                                    int count1a = 0;
                                    int count2a = 0;
                                    int acum = 0;
                                    
                                    for(String date: Dates){
                                    
                                        acum += N_sales.get(count1a);
                                    
                                        if(count2a == 0){
                                        
                                            Means_from.add(Dates.get(count1a));
                                            Means_index_from.add(count1a);
                                        }else if(count2a == 29){
                                        
                                            Integer acumi = Integer.valueOf(acum);
                                        
                                            Means_to.add(Dates.get(count1a));
                                            Means_index_to.add(count1a);
                                            Means_values.add(acumi.floatValue()/30);
                                            Means_sales.add(acum);
                                            acum = 0;
                                        }
                                        
                                        count1a++;
                                        
                                        if(count2a == 29){
                                        
                                            count2a = 0;
                                        }else{
                                        
                                            count2a++;
                                        }
                                    }
                                    
                                    Iboard = new Board(Sales, Dates, Comp.get_pro_list(), Means_values, Means_from, Means_index_from, Means_to, Means_index_to, Means_sales);
                                    
                                    
                                    Means_values = new ArrayList<Float>();
                                    Means_from = new ArrayList<String>();
                                    Means_to = new ArrayList<String>();
                                    Means_index_from = new ArrayList<Integer>();
                                    Means_index_to = new ArrayList<Integer>();
                                    Means_sales = new ArrayList<Integer>();

                                }
                                
                                add_all();

                    			P_frame.setVisible(false);
							}								
						}
					});
					
					P_panel.add(Label1);
					Label1.setAlignmentX(P_panel.CENTER_ALIGNMENT);
        			P_panel.add(Com_box1);
					Com_box1.setAlignmentX(P_panel.CENTER_ALIGNMENT);
        			P_panel.add(Label2);
					Label2.setAlignmentX(P_panel.CENTER_ALIGNMENT);
        			P_panel.add(Com_box2);
					Com_box2.setAlignmentX(P_panel.CENTER_ALIGNMENT);
        			P_panel.add(Button1);
					Button1.setAlignmentX(P_panel.CENTER_ALIGNMENT);

                    P_frame.add(P_panel);
                    P_frame.setSize(150, 125);  
                    P_frame.setLocationRelativeTo(null);
                    P_frame.setVisible(true);
				}
		});

        Button2 = new JButton("Search");
		Button2.setAlignmentX(this.CENTER_ALIGNMENT);

		Button2.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                    JFrame S_frame = new JFrame("Sales Search");
                    JPanel S_panel = new JPanel();
                    JTextField S_field = new JTextField("");
                    S_field.setColumns(15);
                    JLabel S_label = new JLabel("Search for");

                    final DefaultComboBoxModel<String> Ps_combo = new DefaultComboBoxModel<String>();                   
                    Ps_combo.addElement("customer");
                    Ps_combo.addElement("vendor");
                    Ps_combo.addElement("product name");
                    Ps_combo.addElement("city");                    
                    Ps_combo.addElement("date");
                    Ps_combo.addElement("time");

                    final JComboBox<String> Scom_box = new JComboBox<String>(Ps_combo);

                    JButton S_button = new JButton("Search");
                    S_button.addActionListener(new ActionListener(){  
                        public void actionPerformed(ActionEvent e){
    
                            String hint = S_field.getText().toLowerCase();
                            String where = Scom_box.getSelectedItem().toString();
                            ArrayList<Sale> Filtered_sales = new ArrayList<Sale>();

                            switch(where){

                                case "customer":

                                    for(Sale Sal: Sales){

                                        if(Sal.get_custom().get_name().toLowerCase().contains(hint)){

                                            Filtered_sales.add(Sal);
                                        }
                                    }

                                break;

                                case "vendor":

                                    for(Sale Sal: Sales){

                                        if(Sal.get_vendor().toLowerCase().contains(hint)){

                                            Filtered_sales.add(Sal);
                                        }
                                    }

                                break;

                                case "product name":

                                    for(Sale Sal: Sales){

                                        ArrayList<String> Prod_names = new ArrayList<String>();

                                        for(String code: Sal.get_codes()){

                                            for(Product Pro: Comp.get_pro_list()){

                                                if(Pro.get_code().equals(code)){

                                                    Prod_names.add(Pro.get_name());
                                                }
                                            }
                                        }

                                        for(String name: Prod_names){

                                            if(name.toLowerCase().contains(hint)){

                                                Filtered_sales.add(Sal);
                                            }
                                        }
                                    }

                                break;

                                case "city":

                                    for(Sale Sal: Sales){

                                        if(Sal.get_custom().get_address().toLowerCase().contains(hint)){

                                            Filtered_sales.add(Sal);
                                        }
                                    }

                                break;

                                case "date":

                                    for(Sale Sal: Sales){

                                        if(Sal.get_date().toLowerCase().equals(hint)){

                                            Filtered_sales.add(Sal);
                                        }
                                    }

                                break;

                                case "time":

                                    for(Sale Sal: Sales){

                                        if(Sal.get_time().toLowerCase().equals(hint)){

                                            Filtered_sales.add(Sal);
                                        }
                                    }

                                break;
                            }

                            int count1 = 0;
                            String data[][] = new String[Filtered_sales.size()][7];

                            for(Sale Sal: Filtered_sales){

                                Integer inv_no = Integer.valueOf(Sal.get_inv_no());

                                float amount = 0;

                                for(Payment Pay: Sal.get_pay_list()){

                                    amount += Pay.get_amount();
                                }

                                data[count1][0] =  inv_no.toString();
                                data[count1][1] =  Sal.get_custom().get_name();
                                data[count1][2] =  Float.toString(amount);
                                data[count1][3] =  "click here ...";
                                data[count1][4] =  Sal.get_time();
                                data[count1][5] =  Sal.get_custom().get_address();
                                data[count1][6] =  Sal.get_vendor();

                                count1++;
                            }

                            String columns[]={"ID","Customer","Amount","Invoice","Time","City","Vendor"};

                            JTable R_table = new JTable(data, columns);
                            TableColumnModel Column_model = R_table.getColumnModel();
                            Column_model.getColumn(0).setPreferredWidth(60);
                            Column_model.getColumn(1).setPreferredWidth(140);
                            Column_model.getColumn(2).setPreferredWidth(80);
                            Column_model.getColumn(3).setPreferredWidth(80);
                            Column_model.getColumn(4).setPreferredWidth(60);
                            Column_model.getColumn(5).setPreferredWidth(120);
                            Column_model.getColumn(6).setPreferredWidth(100);

                            R_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
                            R_table.setCellSelectionEnabled(true); 
                            ListSelectionModel Select = R_table.getSelectionModel();  
                            Select.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

                            Select.addListSelectionListener(new ListSelectionListener() {  
                                public void valueChanged(ListSelectionEvent e) {

                                    if(!e.getValueIsAdjusting()){

                                    int[] rows = R_table.getSelectedRows();
                                    int[] columns = R_table.getSelectedColumns();

                                    if(columns[0] == 3){
        
                                        int column = columns[0] - 3;

                                        String data = (String)R_table.getValueAt(rows[0], column);

                                        for(Sale Sal: Filtered_sales){

                                            Integer inv_no = Integer.valueOf(Sal.get_inv_no());

                                            if(data.equals(inv_no.toString())){

                                                String cus_name = Sal.get_custom().get_name();
                                                String cus_code = Sal.get_custom().get_code();
                                                String cus_address = Sal.get_custom().get_address();
                                                String cus_phone = Sal.get_custom().get_contact();
                                                String currency = Comp.get_invoice().get_currency();
                                                String date = Sal.get_date();
                                                String time = Sal.get_time();
                                                String inv_no2 = data;
                                                String vendor = Sal.get_vendor();

                                                int count2 = 0;

                                                String prod_names[] = new String[Sal.get_codes().size()];
                                                float prod_prices[] = new float[Sal.get_codes().size()];
                                                int prod_qts[] = new int[Sal.get_codes().size()];

                                                for(String code: Sal.get_codes()){

                                                        for(Product Pro: Comp.get_pro_list()){

                                                                if(Pro.get_code().equals(code)){

                                                                    prod_names[count2] = Pro.get_name();
                                                                    prod_prices[count2] = Pro.get_price();
                                                                    prod_qts[count2] = Sal.get_qts().get(count2);
                                                                }
                                                        }
                                                    count2++;
                                                }

	                                            float payments[] = new float[Sal.get_pay_list().size()];
	                                            String types[] = new String[Sal.get_pay_list().size()];
	                                            String refs[] = new String[Sal.get_pay_list().size()];

                                                count2 = 0;        
    
                                                for(Payment Pay: Sal.get_pay_list()){
                                            
                                                    payments[count2] = Pay.get_amount();
                                                    types[count2] = Pay.get_type();
                                                    refs[count2] = Pay.get_ref();
                                                    count2++;
                                                }

                                                try{

                                                    Comp.get_invoice().new_invoice(date, time, inv_no2, vendor, cus_name, cus_code, cus_address, cus_phone, currency, prod_names, prod_prices, prod_qts, payments, types, refs);

                                                }catch(IOException Ioe){
    
                                                    System.out.println("An error has occurred, try again");
                                                }
                                            }
                                        }
                                    }

                            }
                        }
                    });

                    JScrollPane Rs_pane = new JScrollPane(R_table);
                    JFrame R_frame = new JFrame("Custom Report");
                    R_frame.add(Rs_pane);
                    R_frame.setSize(400, 600);
                    R_frame.setLocationRelativeTo(null);
                    R_frame.setVisible(true);
                        }
                    });

                    S_panel.add(S_field);
                    S_panel.add(S_label);
                    S_panel.add(Scom_box);
                    S_panel.add(S_button);
                    S_frame.add(S_panel);

                    S_frame.setSize(205, 140);  
                    S_frame.setLocationRelativeTo(null);
                    S_frame.setVisible(true);
                }
        });
        	
        	
        C_label.setAlignmentX(this.CENTER_ALIGNMENT);
        add(C_label);
        add(Box.createRigidArea(new Dimension(0, 20)));
        Button1.setAlignmentX(this.CENTER_ALIGNMENT);
        add(Button1);
        add(Button2);
        add(Box.createRigidArea(new Dimension(0, 10)));

        if(!Sales.isEmpty()){

            add(Iboard);
        }

        Button3 = new JButton("View full Highlights for this Period");
		Button3.setAlignmentX(E_partial_panel.CENTER_ALIGNMENT);

		Button3.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                    JFrame E_frame = new JFrame(Label4.getText());
		            JScrollPane Js_pane = new JScrollPane(E_panel);
                    E_frame.add(Js_pane);
                    E_frame.setSize(400, 600);  
                    E_frame.setLocationRelativeTo(null);
                    E_frame.setVisible(true);
                }
        });
        
        E_partial_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        E_partial_panel.add(Button3);
        JScrollPane Js_pane = new JScrollPane(E_partial_panel);
        add(Js_pane);
        
        }
        //end conditional IF Sales object has more than 2 sales otherwise it cannot plot graphics and metrics
	}

    public void board_init(){

        for(int a = 0; a < Sales.size(); a++){
    
            boolean flag1 = false;

            for(String date: Dates_sales){

                if(Sales.get(a).get_date().equals(date)){

                    flag1 = true;
                }
            }

            if(!flag1){

                Dates_sales.add(Sales.get(a).get_date());
            }
        }

        if(Dates_sales.size() > 15){

            for(int a = (Dates_sales.size() - 16); a < Dates_sales.size(); a++){

                Dates.add(Dates_sales.get(a));
		
				int count1 = 0;

				for(Sale Isale: Sales){

					if(Isale.get_date().equals(Dates_sales.get(a))){

						count1++;
					}
				}

				N_sales.add(count1);

			}
        }else{

            for(int a = 0; a < Dates_sales.size(); a++){

                Dates.add(Dates_sales.get(a));

				int count1 = 0;

				for(Sale Isale: Sales){

					if(Isale.get_date().equals(Dates_sales.get(a))){

						count1++;
					}
				}

					N_sales.add(count1);
            	}

		}

        Iboard = new Board(Sales, Dates, N_sales, Comp.get_pro_list(), Comp.get_invoice(), "days");
    }

	public void embed_init(){
	
		Integer zero = 0;
		String date_from = "", date_to = "";
		int acum_sales = 0, acum_items = 0;
		float acum_amount = 0;
		ArrayList<Product> Pro_list = Comp.get_pro_list();

           for(int a = 0; a < Dates.size(); a++){

			 	if(a == 0){

					date_from = Dates.get(a);
				}else if(a == (Dates.size()-1)){

					date_to = Dates.get(a);
				}
		     } 

		for(int num: N_sales){

			acum_sales += num;
		}

		for(int j = Sales.size()-acum_sales; j < Sales.size(); j++){

            boolean flag1 = false;
			boolean flag3 = false;

			ArrayList<Integer> Qts = Sales.get(j).get_qts();
			ArrayList<Payment> Pays = Sales.get(j).get_pay_list();			
			ArrayList<String> Codes = Sales.get(j).get_codes();

			for(int qt: Qts){

				acum_items += qt;
			}

			for(Payment Pay: Pays){

				acum_amount += Pay.get_amount();
			}

            for(String Vnd: Vnd_names){

                if(Sales.get(j).get_vendor().equals(Vnd)){

                    flag1 = true;
                }
            }

			for(String city: City_names){

                if(Sales.get(j).get_custom().get_address().equals(city)){

                    flag3 = true;
                }
            }

			int count2 = 0;

			for(String code: Codes){

				String name = "";

				for(Product Pro: Pro_list){

					if(Pro.get_code().equals(code)){

						name = Pro.get_name();
					}
				}

				boolean flag2 = false;

				for(String prod_name: Prod_names){

					if(prod_name.equals(name)){

						flag2 = true;
					}
				}

				if(!flag2){

                	Prod_names.add(name);
                	Prod_amts.add(zero.floatValue());
					Prod_qts.add(0);
            	}
			}

            if(!flag1){

                Vnd_names.add(Sales.get(j).get_vendor());
                Vnd_amts.add(zero.floatValue());
            }

			if(!flag3){

                City_names.add(Sales.get(j).get_custom().get_address());
                City_amts.add(zero.floatValue());
            }
		}

        for(int j = Sales.size()-acum_sales; j < Sales.size(); j++){

            int count = 0;

			ArrayList<Float> Prices = new ArrayList<Float>();
			ArrayList<String> Names = new ArrayList<String>();  
			ArrayList<Payment> Pays = Sales.get(j).get_pay_list();
			ArrayList<Integer> Qts = Sales.get(j).get_qts();		
			ArrayList<String> Codes = Sales.get(j).get_codes();

            for(String vnd: Vnd_names){

                if(Sales.get(j).get_vendor().equals(vnd)){

                    float old_amt = Vnd_amts.get(count);

                    for(Payment Pay: Pays){

				        old_amt += Pay.get_amount();
			        }

                    Vnd_amts.set(count, old_amt);
                }

                count++;
            }

			count = 0;

			for(String city: City_names){

                if(Sales.get(j).get_custom().get_address().equals(city)){

                    float old_amt = City_amts.get(count);

                    for(Payment Pay: Pays){

				        old_amt += Pay.get_amount();
			        }

                    City_amts.set(count, old_amt);
                }

                count++;
            }

			count = 0;

			for(String code: Codes){

				for(Product Pro: Pro_list){

					if(Pro.get_code().equals(code)){

						Prices.add(Pro.get_price());
						Names.add(Pro.get_name());
					}
				}
			}

			for(String name: Prod_names){

				int count2 = 0;

				for(String name_qt: Names){

					if(name_qt.equals(name)){

						float old_amt = Prod_amts.get(count);
						old_amt += (Prices.get(count2) * Qts.get(count2));
						Prod_amts.set(count, old_amt);

						int old_count = Prod_qts.get(count);
						old_count += Qts.get(count2);
						Prod_qts.set(count, old_count);
					}
					count2++;
				}

				count++;
			}
		}

		String[] split1 = date_from.split("-");
		String[] split2 = date_to.split("-");

		Label4 = new JLabel("From " + months[Integer.parseInt(split1[1]) - 1] + " " + split1[2] + " " + split1[0] + " To " + months[Integer.parseInt(split2[1]) - 1] + " " + split2[2] + " " + split2[0]);

		Label5 = new JLabel("Total sales . . . " + acum_sales); 
        Label5p = new JLabel(Label5.getText());
		Label6 = new JLabel("Total items . . . " + acum_items); 
        Label6p = new JLabel(Label6.getText());
		Label7 = new JLabel("Total amount . . . " + acum_amount); 
        Label7p = new JLabel(Label7.getText());
        Label8 = new JLabel("Vendors");
        Label9 = new JLabel("Products");
        Label10 = new JLabel("Areas");   

        E_panel.setLayout(new BoxLayout(E_panel, BoxLayout.Y_AXIS));
        E_partial_panel.setLayout(new BoxLayout(E_partial_panel, BoxLayout.Y_AXIS)); 
        E_partial_panel.add(Label4);
        E_panel.add(Box.createRigidArea(new Dimension(0, 10)));
        E_partial_panel.add(Box.createRigidArea(new Dimension(0, 10)));
        Label4.setAlignmentX(E_panel.CENTER_ALIGNMENT);
        E_panel.add(Label5);
        E_partial_panel.add(Label5p);
        Label5.setAlignmentX(E_panel.CENTER_ALIGNMENT);
        Label5p.setAlignmentX(E_partial_panel.CENTER_ALIGNMENT);
        E_panel.add(Label6);
        E_partial_panel.add(Label6p);
        Label6.setAlignmentX(E_panel.CENTER_ALIGNMENT);
        Label6p.setAlignmentX(E_partial_panel.CENTER_ALIGNMENT);
        E_panel.add(Label7);
        E_partial_panel.add(Label7p);
        Label7.setAlignmentX(E_panel.CENTER_ALIGNMENT);
        Label7p.setAlignmentX(E_partial_panel.CENTER_ALIGNMENT);
        E_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        E_panel.add(Label8);
        Label8.setAlignmentX(E_panel.CENTER_ALIGNMENT);
        E_panel.add(Box.createRigidArea(new Dimension(0, 10)));

        JLabel[] Vnd_labels = new JLabel[Vnd_names.size()];
		JLabel[] Prod_labels = new JLabel[Prod_names.size()];
		JLabel[] City_labels = new JLabel[City_names.size()];

        int count = 0;

        for(String vnd: Vnd_names){

            Vnd_labels[count] = new JLabel(vnd + " . . . " + Vnd_amts.get(count) + " . . . " + (Vnd_amts.get(count)/acum_amount)*100 + " % ");
            E_panel.add(Vnd_labels[count]);
            Vnd_labels[count].setAlignmentX(E_panel.CENTER_ALIGNMENT);
            count++;
        }
        
        E_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        E_panel.add(Label9);
        Label9.setAlignmentX(E_panel.CENTER_ALIGNMENT);
		E_panel.add(Box.createRigidArea(new Dimension(0, 10)));

		count = 0;

        for(String prod: Prod_names){

            Prod_labels[count] = new JLabel(prod + " . . . " + Prod_amts.get(count) + " . . . " + (Prod_amts.get(count)/acum_amount)*100 + " % . . . " + Prod_qts.get(count) + " U");
            E_panel.add(Prod_labels[count]);
            Prod_labels[count].setAlignmentX(E_panel.CENTER_ALIGNMENT);
            count++;
        }

		E_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        E_panel.add(Label10);
        Label10.setAlignmentX(E_panel.CENTER_ALIGNMENT);
		E_panel.add(Box.createRigidArea(new Dimension(0, 10)));

		count = 0;

        for(String city: City_names){

            City_labels[count] = new JLabel(city + " . . . " + City_amts.get(count) + " . . . " + (City_amts.get(count)/acum_amount)*100 + " %");
            E_panel.add(City_labels[count]);
            City_labels[count].setAlignmentX(E_panel.CENTER_ALIGNMENT);
            count++;
        }

		E_panel.add(Box.createRigidArea(new Dimension(0, 20)));
	}

    public void add_all(){

        removeAll();
        E_panel.removeAll();
        E_partial_panel.removeAll();
        add(C_label);
        add(Box.createRigidArea(new Dimension(0, 20)));
        add(Button1);
        add(Button2);
        add(Box.createRigidArea(new Dimension(0, 10)));
        add(Iboard);
        embed_init();
        E_partial_panel.add(Box.createRigidArea(new Dimension(0, 20)));
        E_partial_panel.add(Button3);
        JScrollPane Js_pane = new JScrollPane(E_partial_panel);
        add(Js_pane);
    }
}

class Vending_panel extends Tab_panel{

    JLabel C_label = new JLabel();
	ArrayList<String> Codes;
    ArrayList<Integer> Qts;
    ArrayList<Payment> Current_pays;
	JLabel Label1, Label2;
	JButton Button1, Button2, Button3, Button4, Button5;
	JTable Pro_table, Cus_table, Pay_table;
	ListSelectionModel Select, Select2, Select3;
	float total_acum, pay_acum, balance;

    Vending_panel(){

        super();
        setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
        C_label.setText(Current_company.getText());
        C_label.setAlignmentX(this.CENTER_ALIGNMENT);
        
        Codes = Comp.get_codes();
        Qts = Comp.get_qts();

        Current_pays = Comp.get_current_pays();

        ArrayList<Sale> Sales = Comp.get_sales();

        Button5 = new JButton("Discard Sale");
        Button5.setAlignmentX(this.CENTER_ALIGNMENT);
        
        Button5.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                    Comp.set_codes(new ArrayList<String>());
                    Comp.set_qts(new ArrayList<Integer>());

                    Comp.set_current_pays(new ArrayList<Payment>());

                    Comp.set_current_custom("");

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                    add_all();
                }
        });
        

		Button1 = new JButton("Add Product");
		Button1.setAlignmentX(this.CENTER_ALIGNMENT);

		Button1.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                    JFrame P_frame = new JFrame("Add Product");  
                    JPanel P_panel = new JPanel();

                    JLabel P_label1 = new JLabel("enter Code");
                    JTextField P_field1 = new JTextField("");
                    P_field1.setColumns(20);    
                    JLabel P_label2 = new JLabel("enter Quantity");
                    JTextField P_field2 = new JTextField("");
                    P_field2.setColumns(20); 

                    JButton P_button1 = new JButton("Add to Sale");

                    P_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                    if(!P_field1.getText().equals("") && !P_field2.getText().equals("")){

                                        boolean exists_prod = false;
                                        int count1 = 0;

                                        for(String code: Codes){
        
                                            if(code.toLowerCase().equals(P_field1.getText().toLowerCase())){
                
                                                int qt = Qts.get(count1);
                                                qt += Integer.parseInt(P_field2.getText());
                                                Qts.set(count1, qt);
                                                exists_prod = true;
                                                break;
                                            } 

                                            count1++;    
                                        }

                                        if(!exists_prod){

                                            Codes.add(P_field1.getText().toLowerCase());
                                            Qts.add(Integer.parseInt(P_field2.getText()));
                                        }

                                        Comp.set_codes(Codes);
                                        Comp.set_qts(Qts);
                                    }

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    add_all();
                                    P_frame.setVisible(false);
                            }
                    });    
        

                    JButton P_button2 = new JButton("Cancel");

                    P_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                add_all();
                                P_frame.setVisible(false);
                            }
                    });


                    P_panel.setLayout(new FlowLayout());
					P_panel.add(P_label1);
                    P_panel.add(P_field1);
                    P_panel.add(P_label2);
                    P_panel.add(P_field2);

                    P_panel.add(P_button1);
                    P_panel.add(P_button2);

                    P_frame.add(P_panel);
                    P_frame.setSize(250, 150);  
                    P_frame.setLocationRelativeTo(null);
                    P_frame.setVisible(true);
				}
		});
		

		String data[][] = new String[Codes.size()][5];

        for(int a = 0; a < Codes.size(); a++){

            for(Product Pro: Comp.get_pro_list()){

                if(Codes.get(a).equals(Pro.get_code().toLowerCase())){

					data[a][0] = Pro.get_name();
					data[a][1] = Pro.get_code().toLowerCase();
					data[a][2] = Qts.get(a).toString();
					data[a][3] = Float.toString(Pro.get_price()*Integer.parseInt(Qts.get(a).toString()));
					data[a][4] = "click here...";
                }
			}
        }

		String columns[]={"Product","Code","Qty","Amount","Remove"};

		Pro_table = new JTable(data, columns);
        TableColumnModel Column_model = Pro_table.getColumnModel();
        Column_model.getColumn(0).setPreferredWidth(180);
        Column_model.getColumn(1).setPreferredWidth(70);
        Column_model.getColumn(2).setPreferredWidth(40);
        Column_model.getColumn(3).setPreferredWidth(90);
        Column_model.getColumn(4).setPreferredWidth(80);

		Pro_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

		Pro_table.setCellSelectionEnabled(true); 
        Select = Pro_table.getSelectionModel();  
        Select.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  
        Select.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Pro_table.getSelectedRows();
                    int[] columns = Pro_table.getSelectedColumns();
                    int column = columns[0] - 3;

                    //remove product from table
                    if(columns[0] == 4){

					int remove_index = 0;
					int count1 = 0;
                    boolean flag1 = false;

						for(String code: Codes){

							if((Pro_table.getValueAt(rows[0], column)).equals(code)){
								
								remove_index = count1;
                                flag1 = true;
								break;
							}

						count1++;
						}

                    if(flag1){

					    Codes.remove(remove_index);
                        Qts.remove(remove_index);
                    }

					Comp.set_codes(Codes);
                    Comp.set_qts(Qts);
					
					try{

                    	C_list = read_companies("Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("could not read file, try again");
                    }catch(ClassNotFoundException cnfe){

                    	System.out.println("non companies were found, try again");
                    }

                    C_list.set(comp_index, Comp);

                    try{

                    	save_companies(C_list, "Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("cannot write record, try again");
                    }
					}

				add_all();
			  }
			}
		});

		total_acum = 0;

		int count1 = 0;

		for(String code: Codes){

			for(Product Pro: Comp.get_pro_list()){

				if(code.equals(Pro.get_code())){

					total_acum += Pro.get_price() * Integer.parseInt(Qts.get(count1).toString());
				}
			}

			count1++;
		}

		Label1 = new JLabel("Total . . . . . . " + total_acum);
		Label1.setAlignmentX(this.CENTER_ALIGNMENT);

		Button2 = new JButton("Add Payment");
		Button2.setAlignmentX(this.CENTER_ALIGNMENT);

		Button2.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                    JFrame P_frame = new JFrame("Add Payment");  
                    JPanel P_panel = new JPanel();

                    JLabel P_label1 = new JLabel("enter Amount");
                    JTextField P_field1 = new JTextField("");
                    P_field1.setColumns(20); 
   
                    JLabel P_label2 = new JLabel("enter Reference");
                    JTextField P_field2 = new JTextField("");
                    P_field2.setColumns(20);
    
                    JLabel P_label3 = new JLabel("select Type");
                    final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                    Pre_combo1.addElement("cash");
                    Pre_combo1.addElement("digital");
                    Pre_combo1.addElement("other");

                    final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);
                    JScrollPane Combo_panel1 = new JScrollPane(Com_box1); 


                    JButton P_button1 = new JButton("Add to Sale");

                    P_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                    Current_pays.add(new Payment(P_field2.getText(), Float.parseFloat(P_field1.getText()), Com_box1.getSelectedItem().toString()));

                                    Comp.set_current_pays(Current_pays);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    add_all();
                                    P_frame.setVisible(false);
                            }
                    });    
        

                    JButton P_button2 = new JButton("Cancel");

                    P_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                add_all();
                                P_frame.setVisible(false);
                            }
                    });


                    P_panel.setLayout(new FlowLayout());
					P_panel.add(P_label1);
                    P_panel.add(P_field1);
                    P_panel.add(P_label2);
                    P_panel.add(P_field2);
                    
                    P_panel.add(P_label3);
                    P_panel.add(Combo_panel1);

                    P_panel.add(P_button1);
                    P_panel.add(P_button2);

                    P_frame.add(P_panel);
                    P_frame.setSize(250, 200);  
                    P_frame.setLocationRelativeTo(null);
                    P_frame.setVisible(true);
				}
		});
		

		String data2[][] = new String[Comp.get_current_pays().size()][4];


            int count2 = 0;

            for(Payment Pay: Comp.get_current_pays()){

					data2[count2][0] = Pay.get_ref();
					data2[count2][1] = Pay.get_type();
					data2[count2][2] = Float.toString(Pay.get_amount());
					data2[count2][3] = "click here...";

                count2++;
			}

		String columns2[]={"Reference","Type","Amount","Remove"};

		Pay_table = new JTable(data2, columns2);
        TableColumnModel Column_model2 = Pay_table.getColumnModel();
        Column_model2.getColumn(0).setPreferredWidth(180);
        Column_model2.getColumn(1).setPreferredWidth(80);
        Column_model2.getColumn(2).setPreferredWidth(90);
        Column_model2.getColumn(3).setPreferredWidth(80);

		Pay_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

		Pay_table.setCellSelectionEnabled(true); 
        Select2 = Pay_table.getSelectionModel();  
        Select2.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  
        Select2.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Pay_table.getSelectedRows();
                    int[] columns = Pay_table.getSelectedColumns();

					int column = columns[0] - 1;

                    //remove payment from table
                    if(columns[0] == 3){

                        Current_pays = Comp.get_current_pays();
						int remove_index = 0;

						for(Payment Pay: Comp.get_current_pays()){

							if(Pay_table.getValueAt(rows[0], column).equals(Float.toString(Pay.get_amount()))){
								
								break;
							}

							remove_index++;
						}

					Current_pays.remove(remove_index);

                    Comp.set_current_pays(Current_pays);
					
					try{

                    	C_list = read_companies("Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("could not read file, try again");
                    }catch(ClassNotFoundException cnfe){

                    	System.out.println("non companies were found, try again");
                    }

                    C_list.set(comp_index, Comp);

                    try{

                    	save_companies(C_list, "Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("cannot write record, try again");
                    }
					}

				add_all();
			  }
			}
		});

        pay_acum = 0;

        for(Payment Pay: Comp.get_current_pays()){

            pay_acum += Pay.get_amount();
        }

        balance = pay_acum - total_acum;

        Label2 = new JLabel("Balance . . . . . . " + balance);
		Label2.setAlignmentX(this.CENTER_ALIGNMENT);
		
		Button3 = new JButton("Add Customer");
		Button3.setAlignmentX(this.CENTER_ALIGNMENT);

		Button3.addActionListener(new ActionListener(){  
              public void actionPerformed(ActionEvent e){

					JFrame P_frame = new JFrame("Add Customer");  
                    JPanel P_panel = new JPanel();

                    JLabel P_label1 = new JLabel("enter Code");
                    JTextField P_field1 = new JTextField("");
                    P_field1.setColumns(20);

                    JButton P_button1 = new JButton("Add to Sale");

                    P_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                            for(Customer custom: Comp.get_cus_list()){
            
                                if(custom.get_code().toLowerCase().equals(P_field1.getText().toLowerCase())){

                                    Comp.set_current_custom(custom.get_code());
                                }
                            }
                    
                            add_all();
                            P_frame.setVisible(false);
                        }
                    });
                    
                    JButton P_button2 = new JButton("Cancel");

                    P_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                            P_frame.setVisible(false);
                        }
                    });

                    P_panel.add(P_label1);
                    P_panel.add(P_field1);
                    P_panel.add(P_button1);
                    P_panel.add(P_button2);
                    P_frame.add(P_panel);
                    P_frame.setSize(250, 130);  
                    P_frame.setLocationRelativeTo(null);
                    P_frame.setVisible(true);
			  }
		});

		String data3[][] = new String[1][3];

            for(Customer Cus: Comp.get_cus_list()){

				if(Cus.get_code().equals(Comp.get_current_custom())){

					data3[0][0] = Cus.get_name();
					data3[0][1] = Cus.get_code();
					data3[0][2] = "click here...";
				}
			}

		String columns3[]={"Customer","Code","Remove"};

		Cus_table = new JTable(data3, columns3);
        TableColumnModel Column_model3 = Cus_table.getColumnModel();
        Column_model3.getColumn(0).setPreferredWidth(200);
        Column_model3.getColumn(1).setPreferredWidth(100);
        Column_model3.getColumn(2).setPreferredWidth(100);

		Cus_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

		Cus_table.setCellSelectionEnabled(true); 
        Select3 = Cus_table.getSelectionModel();  
        Select3.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  
        Select3.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Cus_table.getSelectedRows();
                    int[] columns = Cus_table.getSelectedColumns();
                    int column = columns[0] - 1;

                    //remove customer from sale
                    if(columns[0] == 2){

					Comp.set_current_custom("");
					
					try{

                    	C_list = read_companies("Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("could not read file, try again");
                    }catch(ClassNotFoundException cnfe){

                    	System.out.println("non companies were found, try again");
                    }

                    C_list.set(comp_index, Comp);

                    try{

                    	save_companies(C_list, "Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("cannot write record, try again");
                    }
					}

				add_all();
			  }
			}
		});
		
		Button4 = new JButton("Process this Sale as " + Comp.get_vendor());
		Button4.setAlignmentX(this.CENTER_ALIGNMENT);  

		Button4.addActionListener(new ActionListener(){  
              public void actionPerformed(ActionEvent e){

                   if(balance < -0.1 || balance > 0.1){

						JFrame P_frame = new JFrame("Warning");  
                    	JPanel P_panel = new JPanel();
						Label P_label = new Label("balance must be on 0");
					    JButton P_button1 = new JButton("OK");

						P_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
			
								P_frame.setVisible(false);
							}
						});

						P_panel.add(P_label);
						P_panel.add(P_button1);
						P_frame.add(P_panel);

						P_frame.setVisible(true);
						P_frame.setSize(250, 50);  
                    	P_frame.setLocationRelativeTo(null);
					}

                    if(!Comp.get_current_custom().equals("") && Comp.get_codes().size() != 0 && Comp.get_current_pays().size() != 0 && balance >= -0.1 && balance <= 0.1){

                    int sales_count = Comp.get_sales().size();
                    int count1 = 0;

					int count = 0;
                    String[] prod_names = new String[Comp.get_codes().size()];
                    float[] prod_prices = new float[Comp.get_codes().size()];
                    int[] prod_qts = new int[Comp.get_codes().size()];
                    float[] payments = new float[Comp.get_current_pays().size()];
                    String[] types = new String[Comp.get_current_pays().size()];
                    String[] refs = new String[Comp.get_current_pays().size()];

                    for(String code: Comp.get_codes()){

                        for(Product Pro: Comp.get_pro_list()){

                            if(Pro.get_code().equals(code)){

                                prod_names[count] = Pro.get_name();
                                prod_prices[count] = Pro.get_price();
                                prod_qts[count] = Comp.get_qts().get(count);
                            }
                        }

                        count++;
                    }

                    count = 0;            

                    for(Payment Pay: Comp.get_current_pays()){

                        payments[count] = Pay.get_amount();
                        types[count] = Pay.get_type();
                        refs[count] = Pay.get_ref();

                        count++;
                    }

					ArrayList<Sale> Sales = Comp.get_sales();
                    Customer Cus = null;

                    for(Customer Custom: Comp.get_cus_list()){

                        if(Custom.get_code().equals(Comp.get_current_custom())){

                            Cus = Custom;
                        }
                    }

                    sales_count += 1;

                    DateTimeFormatter dtf = DateTimeFormatter.ofPattern("dd-MM-yyyy hh:mm:ss a");

                    Sale New_sale = new Sale(sales_count, Comp.get_vendor(), Cus, Comp.get_current_pays(), java.time.LocalDate.now().toString(), java.time.LocalTime.now().toString().substring(0,5), Comp.get_codes(), Comp.get_qts());

                    Sales.add(new Sale(sales_count, Comp.get_vendor(), Cus, Comp.get_current_pays(), java.time.LocalDate.now().toString(), java.time.LocalTime.now().toString().substring(0,5), Comp.get_codes(), Comp.get_qts()));

                    

                     try{

                        Comp.get_invoice().new_invoice(New_sale.get_date(), New_sale.get_time(), Integer.toString(New_sale.get_inv_no()), New_sale.get_vendor(), Cus.get_name(), Comp.get_current_custom(), Cus.get_address(), Cus.get_contact(), Comp.get_invoice().get_currency(), prod_names, prod_prices, prod_qts, payments, types, refs);

                    }catch(IOException Ioe){
    
                        System.out.println("An error has occurred, try again");
                    }

                    Comp.set_sales_count(sales_count);
                    Comp.set_sales(Sales);

                    Comp.set_codes(new ArrayList<String>());
                    Comp.set_qts(new ArrayList<Integer>());
                    Comp.set_current_pays(new ArrayList<Payment>());
                    Comp.set_current_custom("");

                    }

                    try{

                    	C_list = read_companies("Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("could not read file, try again");
                    }catch(ClassNotFoundException cnfe){

                    	System.out.println("non companies were found, try again");
                    }

                    C_list.set(comp_index, Comp);

                    try{

                    	save_companies(C_list, "Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("cannot write record, try again");
                    }

				add_all();      
            }
		});

		add(C_label);	
		add(Box.createRigidArea(new Dimension(0, 30)));
        add(Button5);	
		add(Box.createRigidArea(new Dimension(0, 20)));
		add(Button1);
		add(Box.createRigidArea(new Dimension(0, 10)));
        JScrollPane Pro_panel = new JScrollPane(Pro_table);
		add(Pro_panel);
		add(Label1);
		add(Box.createRigidArea(new Dimension(0, 20)));
		add(Button2);
		add(Box.createRigidArea(new Dimension(0, 10)));
		JScrollPane Pay_panel = new JScrollPane(Pay_table);
		add(Pay_panel);
		add(Label2);
		add(Box.createRigidArea(new Dimension(0, 20)));
		add(Button3);
		add(Box.createRigidArea(new Dimension(0, 10)));
		JScrollPane Cus_panel = new JScrollPane(Cus_table);
		add(Cus_panel);
		add(Box.createRigidArea(new Dimension(0, 20)));
		add(Button4);
    }

    public void add_all(){

        removeAll();

        Codes = Comp.get_codes();
        Qts = Comp.get_qts();
        Current_pays = Comp.get_current_pays();
        ArrayList<Sale> Sales = Comp.get_sales();

        String data[][] = new String[Codes.size()][5];

        for(int a = 0; a < Codes.size(); a++){

            for(Product Pro: Comp.get_pro_list()){

                if(Codes.get(a).equals(Pro.get_code().toLowerCase())){

					data[a][0] = Pro.get_name();
					data[a][1] = Pro.get_code().toLowerCase();
					data[a][2] = Qts.get(a).toString();
					data[a][3] = Float.toString(Pro.get_price()*Integer.parseInt(Qts.get(a).toString()));
					data[a][4] = "click here...";
                }
			}
        }

		String columns[]={"Product","Code","Qty","Amount","Remove"};

		Pro_table = new JTable(data, columns);
        TableColumnModel Column_model = Pro_table.getColumnModel();
        Column_model.getColumn(0).setPreferredWidth(180);
        Column_model.getColumn(1).setPreferredWidth(70);
        Column_model.getColumn(2).setPreferredWidth(40);
        Column_model.getColumn(3).setPreferredWidth(90);
        Column_model.getColumn(4).setPreferredWidth(80);

		Pro_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

		Pro_table.setCellSelectionEnabled(true); 
        Select = Pro_table.getSelectionModel();  
        Select.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  
        Select.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Pro_table.getSelectedRows();
                    int[] columns = Pro_table.getSelectedColumns();
                    int column = columns[0] - 3;

                    //remove product from table
                    if(columns[0] == 4){

					int remove_index = 0;
					int count1 = 0;
                    boolean flag1 = false;

						for(String code: Codes){

							if((Pro_table.getValueAt(rows[0], column)).equals(code)){
								
								remove_index = count1;
                                flag1 = true;
								break;
							}

						count1++;
						}

                    if(flag1){

					    Codes.remove(remove_index);
                        Qts.remove(remove_index);
                    }

					Comp.set_codes(Codes);
                    Comp.set_qts(Qts);
					
					try{

                    	C_list = read_companies("Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("could not read file, try again");
                    }catch(ClassNotFoundException cnfe){

                    	System.out.println("non companies were found, try again");
                    }

                    C_list.set(comp_index, Comp);

                    try{

                    	save_companies(C_list, "Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("cannot write record, try again");
                    }
					}

				add_all();
			  }
			}
		});

        total_acum = 0;

		int count1 = 0;

		for(String code: Codes){

			for(Product Pro: Comp.get_pro_list()){

				if(code.equals(Pro.get_code())){

					total_acum += Pro.get_price() * Integer.parseInt(Qts.get(count1).toString());
				}
			}

			count1++;
		}

		Label1 = new JLabel("Total . . . . . . " + total_acum);
		Label1.setAlignmentX(this.CENTER_ALIGNMENT);

		Button2 = new JButton("Add Payment");
		Button2.setAlignmentX(this.CENTER_ALIGNMENT);

		Button2.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                    JFrame P_frame = new JFrame("Add Payment");  
                    JPanel P_panel = new JPanel();

                    JLabel P_label1 = new JLabel("enter Amount");
                    JTextField P_field1 = new JTextField("");
                    P_field1.setColumns(20); 
   
                    JLabel P_label2 = new JLabel("enter Reference");
                    JTextField P_field2 = new JTextField("");
                    P_field2.setColumns(20);
    
                    JLabel P_label3 = new JLabel("select Type");
                    final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                    Pre_combo1.addElement("cash");
                    Pre_combo1.addElement("digital");
                    Pre_combo1.addElement("other");

                    final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);
                    JScrollPane Combo_panel1 = new JScrollPane(Com_box1); 


                    JButton P_button1 = new JButton("Add to Sale");

                    P_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                    Current_pays.add(new Payment(P_field2.getText(), Float.parseFloat(P_field1.getText()), Com_box1.getSelectedItem().toString()));

                                    Comp.set_current_pays(Current_pays);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    add_all();
                                    P_frame.setVisible(false);
                            }
                    });    
        

                    JButton P_button2 = new JButton("Cancel");

                    P_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                add_all();
                                P_frame.setVisible(false);
                            }
                    });


                    P_panel.setLayout(new FlowLayout());
					P_panel.add(P_label1);
                    P_panel.add(P_field1);
                    P_panel.add(P_label2);
                    P_panel.add(P_field2);
                    
                    P_panel.add(P_label3);
                    P_panel.add(Combo_panel1);

                    P_panel.add(P_button1);
                    P_panel.add(P_button2);

                    P_frame.add(P_panel);
                    P_frame.setSize(250, 200);  
                    P_frame.setLocationRelativeTo(null);
                    P_frame.setVisible(true);
				}
		});
		

		String data2[][] = new String[Comp.get_current_pays().size()][4];


            int count2 = 0;

            for(Payment Pay: Comp.get_current_pays()){

					data2[count2][0] = Pay.get_ref();
					data2[count2][1] = Pay.get_type();
					data2[count2][2] = Float.toString(Pay.get_amount());
					data2[count2][3] = "click here...";

                count2++;
			}

		String columns2[]={"Reference","Type","Amount","Remove"};

		Pay_table = new JTable(data2, columns2);
        TableColumnModel Column_model2 = Pay_table.getColumnModel();
        Column_model2.getColumn(0).setPreferredWidth(180);
        Column_model2.getColumn(1).setPreferredWidth(80);
        Column_model2.getColumn(2).setPreferredWidth(90);
        Column_model2.getColumn(3).setPreferredWidth(80);

		Pay_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

		Pay_table.setCellSelectionEnabled(true); 
        Select2 = Pay_table.getSelectionModel();  
        Select2.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  
        Select2.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Pay_table.getSelectedRows();
                    int[] columns = Pay_table.getSelectedColumns();

					int column = columns[0] - 1;

                    //remove payment from table
                    if(columns[0] == 3){

                       Current_pays = Comp.get_current_pays();
						int remove_index = 0;

						for(Payment Pay: Comp.get_current_pays()){

							if(Pay_table.getValueAt(rows[0], column).equals(Float.toString(Pay.get_amount()))){
								
								break;
							}

							remove_index++;
						}

					Current_pays.remove(remove_index);

                    Comp.set_current_pays(Current_pays);
					
					try{

                    	C_list = read_companies("Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("could not read file, try again");
                    }catch(ClassNotFoundException cnfe){

                    	System.out.println("non companies were found, try again");
                    }

                    C_list.set(comp_index, Comp);

                    try{

                    	save_companies(C_list, "Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("cannot write record, try again");
                    }
					}

				add_all();
			  }
			}
		});

        pay_acum = 0;

        for(Payment Pay: Comp.get_current_pays()){

            pay_acum += Pay.get_amount();
        }

        balance = pay_acum - total_acum;

        Label2 = new JLabel("Balance . . . . . . " + balance);
		Label2.setAlignmentX(this.CENTER_ALIGNMENT);
		
		Button3 = new JButton("Add Customer");
		Button3.setAlignmentX(this.CENTER_ALIGNMENT);

		Button3.addActionListener(new ActionListener(){  
              public void actionPerformed(ActionEvent e){

					JFrame P_frame = new JFrame("Add Customer");  
                    JPanel P_panel = new JPanel();

                    JLabel P_label1 = new JLabel("enter Code");
                    JTextField P_field1 = new JTextField("");
                    P_field1.setColumns(20);

                    JButton P_button1 = new JButton("Add to Sale");

                    P_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                            for(Customer custom: Comp.get_cus_list()){
            
                                if(custom.get_code().toLowerCase().equals(P_field1.getText().toLowerCase())){

                                    Comp.set_current_custom(custom.get_code());
                                }
                            }
                    
                            add_all();
                            P_frame.setVisible(false);
                        }
                    });
                    
                    JButton P_button2 = new JButton("Cancel");

                    P_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                            P_frame.setVisible(false);
                        }
                    });

                    P_panel.add(P_label1);
                    P_panel.add(P_field1);
                    P_panel.add(P_button1);
                    P_panel.add(P_button2);
                    P_frame.add(P_panel);
                    P_frame.setSize(250, 130);  
                    P_frame.setLocationRelativeTo(null);
                    P_frame.setVisible(true);
			  }
		});

		String data3[][] = new String[1][3];

            for(Customer Cus: Comp.get_cus_list()){

				if(Cus.get_code().equals(Comp.get_current_custom())){

					data3[0][0] = Cus.get_name();
					data3[0][1] = Cus.get_code();
					data3[0][2] = "click here...";
				}
			}

		String columns3[]={"Customer","Code","Remove"};

		Cus_table = new JTable(data3, columns3);
        TableColumnModel Column_model3 = Cus_table.getColumnModel();
        Column_model3.getColumn(0).setPreferredWidth(200);
        Column_model3.getColumn(1).setPreferredWidth(100);
        Column_model3.getColumn(2).setPreferredWidth(100);

		Cus_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

		Cus_table.setCellSelectionEnabled(true); 
        Select3 = Cus_table.getSelectionModel();  
        Select3.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  
        Select3.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Cus_table.getSelectedRows();
                    int[] columns = Cus_table.getSelectedColumns();
                    int column = columns[0] - 1;

                    //remove customer from sale
                    if(columns[0] == 2){

					Comp.set_current_custom("");
					
					try{

                    	C_list = read_companies("Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("could not read file, try again");
                    }catch(ClassNotFoundException cnfe){

                    	System.out.println("non companies were found, try again");
                    }

                    C_list.set(comp_index, Comp);

                    try{

                    	save_companies(C_list, "Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("cannot write record, try again");
                    }
					}

				add_all();
			  }
			}
		});
		
		Button4 = new JButton("Process this Sale as " + Comp.get_vendor());
		Button4.setAlignmentX(this.CENTER_ALIGNMENT);  

		Button4.addActionListener(new ActionListener(){  
              public void actionPerformed(ActionEvent e){

					if(balance < -0.1 || balance > 0.1){

						JFrame P_frame = new JFrame("Warning");  
                    	JPanel P_panel = new JPanel();
						Label P_label = new Label("balance must be on 0");
					    JButton P_button1 = new JButton("OK");

						P_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
			
								P_frame.setVisible(false);
							}
						});

						P_panel.add(P_label);
						P_panel.add(P_button1);
						P_frame.add(P_panel);

						P_frame.setVisible(true);
						P_frame.setSize(250, 50);  
                    	P_frame.setLocationRelativeTo(null);
					}

                    if(!Comp.get_current_custom().equals("") && Comp.get_codes().size() != 0 && Comp.get_current_pays().size() != 0 && balance >= -0.1 && balance <= 0.1){

                    int sales_count = Comp.get_sales().size();
                    int count1 = 0;


                    int count = 0;
                    String[] prod_names = new String[Comp.get_codes().size()];
                    float[] prod_prices = new float[Comp.get_codes().size()];
                    int[] prod_qts = new int[Comp.get_codes().size()];
                    float[] payments = new float[Comp.get_current_pays().size()];
                    String[] types = new String[Comp.get_current_pays().size()];
                    String[] refs = new String[Comp.get_current_pays().size()];

                    for(String code: Comp.get_codes()){

                        for(Product Pro: Comp.get_pro_list()){

                            if(Pro.get_code().equals(code)){

                                prod_names[count] = Pro.get_name();
                                prod_prices[count] = Pro.get_price();
                                prod_qts[count] = Comp.get_qts().get(count);
                            }
                        }

                        count++;
                    }

                    count = 0;            

                    for(Payment Pay: Comp.get_current_pays()){

                        payments[count] = Pay.get_amount();
                        types[count] = Pay.get_type();
                        refs[count] = Pay.get_ref();

                        count++;
                    }

					ArrayList<Sale> Sales = Comp.get_sales();
                    Customer Cus = null;

                    for(Customer Custom: Comp.get_cus_list()){

                        if(Custom.get_code().equals(Comp.get_current_custom())){

                            Cus = Custom;
                        }
                    }

                    sales_count += 1;

                    DateTimeFormatter dtf = DateTimeFormatter.ofPattern("dd-MM-yyyy hh:mm:ss a");

                    Sale New_sale = new Sale(sales_count, Comp.get_vendor(), Cus, Comp.get_current_pays(), java.time.LocalDate.now().toString(), java.time.LocalTime.now().toString().substring(0,5), Comp.get_codes(), Comp.get_qts());

                    Sales.add(new Sale(sales_count, Comp.get_vendor(), Cus, Comp.get_current_pays(), java.time.LocalDate.now().toString(), java.time.LocalTime.now().toString().substring(0,5), Comp.get_codes(), Comp.get_qts()));

                    

                     try{

                        Comp.get_invoice().new_invoice(New_sale.get_date(), New_sale.get_time(), Integer.toString(New_sale.get_inv_no()), New_sale.get_vendor(), Cus.get_name(), Comp.get_current_custom(), Cus.get_address(), Cus.get_contact(), Comp.get_invoice().get_currency(), prod_names, prod_prices, prod_qts, payments, types, refs);

                    }catch(IOException Ioe){
    
                        System.out.println("An error has occurred, try again");
                    }

                    Comp.set_sales_count(sales_count);
                    Comp.set_sales(Sales);

                    Comp.set_codes(new ArrayList<String>());
                    Comp.set_qts(new ArrayList<Integer>());
                    Comp.set_current_pays(new ArrayList<Payment>());
                    Comp.set_current_custom("");

                    }

                    try{

                    	C_list = read_companies("Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("could not read file, try again");
                    }catch(ClassNotFoundException cnfe){

                    	System.out.println("non companies were found, try again");
                    }

                    C_list.set(comp_index, Comp);

                    try{

                    	save_companies(C_list, "Vndos_record");                                
                    }catch(IOException ioe){

                    	System.out.println("cannot write record, try again");
                    }

				add_all();      
            }
		});

        add(C_label);	
		add(Box.createRigidArea(new Dimension(0, 30)));
        add(Button5);	
		add(Box.createRigidArea(new Dimension(0, 20)));
		add(Button1);
		add(Box.createRigidArea(new Dimension(0, 10)));
        JScrollPane Pro_panel = new JScrollPane(Pro_table);
		add(Pro_panel);
		add(Label1);
		add(Box.createRigidArea(new Dimension(0, 20)));
		add(Button2);
		add(Box.createRigidArea(new Dimension(0, 10)));
		JScrollPane Pay_panel = new JScrollPane(Pay_table);
		add(Pay_panel);
		add(Label2);
		add(Box.createRigidArea(new Dimension(0, 20)));
		add(Button3);
		add(Box.createRigidArea(new Dimension(0, 10)));
		JScrollPane Cus_panel = new JScrollPane(Cus_table);
		add(Cus_panel);
		add(Box.createRigidArea(new Dimension(0, 20)));
		add(Button4);
    }
}

class Invoice_panel extends Tab_panel{

    JLabel C_label = new JLabel();
    Icon Img_icon = new ImageIcon(this.getClass().getResource("images/pos.gif"));;
    Invoice Inv;
	JButton Button1, Button2;

    Invoice_panel(){

        super();

        Inv = Comp.get_invoice();

        setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
        C_label.setText(Current_company.getText());
        C_label.setAlignmentX(this.CENTER_ALIGNMENT);
        add(C_label);

        JLabel Label_img = new JLabel(Img_icon);
        Label_img.setAlignmentX(this.CENTER_ALIGNMENT);

        JScrollPane Inv_panel = new JScrollPane(Label_img);

        add(Box.createRigidArea(new Dimension(0, 20)));

		Button1 = new JButton("Edit");
        Button1.setAlignmentX(this.CENTER_ALIGNMENT);

		Button1.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        JFrame C_frame = new JFrame("Edit Invoice");  
                        JPanel C_panel2 = new JPanel();
                        C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                        JLabel Label1 = new JLabel("Business Name");
                        JLabel Label2 = new JLabel("Business Address");                
                        JLabel Label3 = new JLabel("Province");
                        JLabel Label4 = new JLabel("Country");
                        JLabel Label5 = new JLabel("Phone");
                        JLabel Label6 = new JLabel("Email");
                        JLabel Label7 = new JLabel("Currency");
                        JLabel Label8 = new JLabel("TAX rate %");

                        Label1.setAlignmentX(Component.CENTER_ALIGNMENT);

						JTextField C_field1 = new JTextField(Comp.Inv.get_bus_name());
                        JTextField C_field2 = new JTextField(Comp.Inv.get_bus_add());
                        JTextField C_field3 = new JTextField(Comp.Inv.get_bus_prov());
                        JTextField C_field4 = new JTextField(Comp.Inv.get_bus_country());
                        JTextField C_field5 = new JTextField(Comp.Inv.get_bus_phone());
                        JTextField C_field6 = new JTextField(Comp.Inv.get_bus_email());
                        JTextField C_field7 = new JTextField(Comp.Inv.get_currency());
                        JTextField C_field8 = new JTextField(Float.toString(Comp.Inv.get_tax()));

						C_field1.setColumns(20);
                        C_field2.setColumns(20);
                        C_field3.setColumns(20);
                        C_field4.setColumns(20);
                        C_field5.setColumns(20);
                        C_field6.setColumns(20);
                        C_field7.setColumns(20);
                        C_field8.setColumns(20);

						JButton C_button = new JButton();
                        C_button.setText("Update");

						C_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
								
								Comp.Inv.set_bus_name(C_field1.getText());
								Comp.Inv.set_bus_add(C_field2.getText());
								Comp.Inv.set_bus_prov(C_field3.getText());
								Comp.Inv.set_bus_country(C_field4.getText());
								Comp.Inv.set_bus_phone(C_field5.getText());
								Comp.Inv.set_bus_email(C_field6.getText());
								Comp.Inv.set_currency(C_field7.getText());
								Comp.Inv.set_tax(Float.parseFloat(C_field8.getText()));

								try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

									C_frame.setVisible(false);
                                }
						});

						C_panel2.add(Label1);
                        C_panel2.add(C_field1);
                        C_panel2.add(Label2);
                        C_panel2.add(C_field2);
                        C_panel2.add(Label3);
                        C_panel2.add(C_field3);
                        C_panel2.add(Label4);
                        C_panel2.add(C_field4);
                        C_panel2.add(Label5);
                        C_panel2.add(C_field5);
                        C_panel2.add(Label6);
                        C_panel2.add(C_field6);
                        C_panel2.add(Label7);
                        C_panel2.add(C_field7);
                        C_panel2.add(Label8);
                        C_panel2.add(C_field8);
                        C_panel2.add(C_button);
                        C_frame.add(C_panel2);
                        C_frame.setSize(270, 450);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
    			}
			});
			
	    if(Comp.get_role().equals("admin")){

		    add(Button1);
		    add(Box.createRigidArea(new Dimension(0, 20)));
		}

        Button2 = new JButton("View Invoice Demo");

        Button2.setAlignmentX(this.CENTER_ALIGNMENT);

        Button2.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){
    
                    String cus_name = "Customer Name";
                    String cus_code = "Customer Code";
                    String cus_address = "Customer Address";
                    String cus_phone = "0000000000";
                    String currency = "USD";
                    String date = "DD/MM/YYYY";
                    String time = "HH:MM:SS AM/PM";
                    String inv_no = "DEMO";
                    String vendor = "admin";

                    String prod_names[] = {"prod one", "prod two", "prod three"};
                    float prod_prices[] = {(float)123.456, (float)789.012, (float)345.678};
                    int prod_qts[] = {1, 2, 3};

	                float payments[] = {(float)1000, (float)1000, (float)738.514};
	                String types[] = {"cash", "digital", "other"};
	                String refs[] = {"ref01", "ref02", "ref03"};

                    try{

                        Comp.Inv.new_invoice(date, time, inv_no, vendor, cus_name, cus_code, cus_address, cus_phone, currency, prod_names, prod_prices, prod_qts, payments, types, refs);

                    }catch(IOException Ioe){
    
                        System.out.println("An error has occurred, try again");
                    }
                }
        });

        add(Button2);

        add(Box.createRigidArea(new Dimension(0, 20)));

        add(Inv_panel);
	}
}

class Customers_panel extends Tab_panel{

        JLabel C_label = new JLabel();
        JButton Button1, Button2, Button3;
        ArrayList<Customer> Cus_list;

        Customers_panel(){

            super();

            Cus_list = Comp.get_cus_list();

            setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
            C_label.setText(Current_company.getText());
            C_label.setAlignmentX(this.CENTER_ALIGNMENT);
            add(C_label);

            add(Box.createRigidArea(new Dimension(0, 40)));

            Button1 = new JButton("Register Customer");
            Button1.setAlignmentX(this.CENTER_ALIGNMENT);

            //new Product form
            Button1.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        JFrame C_frame = new JFrame("new Customer");  
                        JPanel C_panel2 = new JPanel();
                        C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                        JLabel Label = new JLabel("Customer Name");
                        JLabel Label2 = new JLabel("Customer Code");                
                        JLabel Label3 = new JLabel("Customer Email");
                        JLabel Label4 = new JLabel("Contact Numbers");
                        JLabel Label5 = new JLabel("City");

                        Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                        JTextField C_field = new JTextField("");
                        JTextField C_field2 = new JTextField("");
                        JTextField C_field3 = new JTextField("");
                        JTextField C_field4 = new JTextField("");
                        JTextField C_field5 = new JTextField("");

                        C_field.setColumns(15);
                        C_field2.setColumns(15);
                        C_field3.setColumns(15);
                        C_field4.setColumns(15);
                        C_field5.setColumns(15);
  
                        JButton C_button = new JButton();
                        C_button.setText("Register"); 
 
                        //this listener creates new Product Object
                        C_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                boolean detect_duplicate = false;

                                for(Customer Cus: Cus_list){

                                    if(C_field2.getText().toLowerCase().equals(Cus.get_code().toLowerCase())){

                                        detect_duplicate = true;
                                    }
                                }

                                if(!detect_duplicate && !C_field.getText().equals("") && !C_field2.getText().equals("")){

                                Customer Cus = new Customer(C_field.getText(), C_field2.getText(), C_field3.getText(), C_field4.getText(), C_field5.getText());

                                    Cus_list.add(Cus);


                                    Comp.set_cus_list(Cus_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                }

                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                        });

                        C_panel2.add(Label);
                        C_panel2.add(C_field);
                        C_panel2.add(Label2);
                        C_panel2.add(C_field2);
                        C_panel2.add(Label3);
                        C_panel2.add(C_field3);
                        C_panel2.add(Label4);
                        C_panel2.add(C_field4);
                        C_panel2.add(Label5);
                        C_panel2.add(C_field5);
                        C_panel2.add(C_button);
                        C_frame.add(C_panel2);
                        C_frame.setSize(200, 300);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
                }
            });
            
            if(Comp.get_role().equals("admin")){

                add(Button1);
                add(Box.createRigidArea(new Dimension(0, 20)));
            }

            Button2 = new JButton("Search Customers");
            Button2.setAlignmentX(this.CENTER_ALIGNMENT);

            Button2.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        JFrame S_frame = new JFrame("search Customer");  
                        JPanel S_panel2 = new JPanel();
                        S_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                        JLabel Label = new JLabel("Enter hint");
                        JLabel Label2 = new JLabel("Search in");

                        Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                        JTextField S_field = new JTextField("");
                        S_field.setColumns(15);

                        final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                        Pre_combo1.addElement("anywhere");
                        Pre_combo1.addElement("name");
                        Pre_combo1.addElement("code");
                        Pre_combo1.addElement("address");
                        Pre_combo1.addElement("contact");
                        Pre_combo1.addElement("email");

                        final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);
                        JScrollPane Combo_panel1 = new JScrollPane(Com_box1);

                        JButton S_button = new JButton();
                        S_button.setText("Search"); 
 
                        //this listener search the hint product
                        S_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                String where = Com_box1.getSelectedItem().toString();

                                if(!S_field.getText().equals("")){

                                    String hint = S_field.getText();
                                    add_all(true, hint, where);
                                    update();
                                }

                                S_frame.setVisible(false);
                            }
                        });

                        S_panel2.add(Label);
                        S_panel2.add(S_field);
                        S_panel2.add(Label2);
                        S_panel2.add(Combo_panel1);
                        S_panel2.add(S_button);
                        S_frame.add(S_panel2);
                        S_frame.setSize(180, 160);  
                        S_frame.setLocationRelativeTo(null);
                        S_frame.setVisible(true);
                }
            });

            add(Button2);

            add(Box.createRigidArea(new Dimension(0, 20)));

            Button3 = new JButton("Refresh");
            Button3.setAlignmentX(this.CENTER_ALIGNMENT);

            Button3.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){
            
                    add_all(false, "", "");
                    update();
                }
            });

            add(Button3);

            add(Box.createRigidArea(new Dimension(0, 40)));

            String data[][] = new String[Cus_list.size()][7];

            int a = 0;
            int b = 0;

            for(Customer Cus: Cus_list){

                data[a][0] = Cus.get_name();
                data[a][1] = Cus.get_code();
                data[a][2] = Cus.get_address();
                data[a][3] = Cus.get_contact();
                data[a][4] = Cus.get_email();
                data[a][5] = "click here...";
                data[a][6] = "click here...";

                a++;
            }

            String columns[]={"Name","Code","City","Contact Numbers","Email","Edit","Delete"};    

            JTable Cus_table = new JTable(data, columns);
            TableColumnModel Column_model = Cus_table.getColumnModel();
            Column_model.getColumn(0).setPreferredWidth(200);
            Column_model.getColumn(1).setPreferredWidth(120);
            Column_model.getColumn(2).setPreferredWidth(200);
            Column_model.getColumn(3).setPreferredWidth(200);
            Column_model.getColumn(4).setPreferredWidth(200);
            Column_model.getColumn(5).setPreferredWidth(90);        
            Column_model.getColumn(6).setPreferredWidth(90);

            Cus_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

            Cus_table.setCellSelectionEnabled(true); 
            ListSelectionModel Select = Cus_table.getSelectionModel();  
            Select.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

            Select.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Cus_table.getSelectedRows();
                    int[] columns = Cus_table.getSelectedColumns();
                    
                    //trigger customer display from table
                    if(columns[0] == 5 && Comp.get_role().equals("admin")){

                            int column = columns[0] - 4;

                            String data = (String)Cus_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("Update");  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                            JLabel Label = new JLabel("Customer Name");
                            JLabel Label2 = new JLabel("Customer Code");
                            JLabel Label3 = new JLabel("City");
                            JLabel Label4 = new JLabel("Contact Numbers");
                            JLabel Label5 = new JLabel("Customer Email");

                            Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                            JTextField C_field = new JTextField("");
                            JTextField C_field2 = new JTextField("");
                            JTextField C_field3 = new JTextField("");
                            JTextField C_field4 = new JTextField("");
                            JTextField C_field5 = new JTextField("");

                            C_field.setColumns(15);
                            C_field2.setColumns(15);
                            C_field3.setColumns(15);
                            C_field4.setColumns(15);
                            C_field5.setColumns(15);

                             for(Customer Cus: Cus_list){

                                    if(Cus.get_code().equals(data)){

                                        C_field.setText(Cus.get_name());
                                        C_field2.setText(Cus.get_code());
                                        C_field3.setText(Cus.get_address());
                                        C_field4.setText(Cus.get_contact());
                                        C_field5.setText(Cus.get_email());
                                    }
                            }

                            JButton C_button = new JButton();
                            C_button.setText("Update");

                            //this listener update the selected product Object
                            C_button.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                    boolean detect_duplicate = false;

                                    for(Customer Cus: Cus_list){

                                        if(Cus.get_code().toLowerCase().equals(C_field2.getText().toLowerCase()) && !Cus.get_code().equals(data)){
                                                    
                                            detect_duplicate = true;
                                        }
                                    }

                                    for(Customer Cus: Cus_list){

                                        if(Cus.get_code().equals(data) && !detect_duplicate){

                                            Cus.set_name(C_field.getText());
                                            Cus.set_code(C_field2.getText());
                                            Cus.set_address(C_field3.getText());
                                            Cus.set_contact(C_field4.getText());
                                            Cus.set_email(C_field5.getText());
                                            }
                                    }

                                Comp.set_cus_list(Cus_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                            });

                        JButton C_button2 = new JButton();
                        C_button2.setText("Cancel");

                        C_button2.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){
                            
                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                        });

                        C_panel2.add(Label);
                        C_panel2.add(C_field);
                        C_panel2.add(Label2);
                        C_panel2.add(C_field2);
                        C_panel2.add(Label3);
                        C_panel2.add(C_field3);
                        C_panel2.add(Label4);
                        C_panel2.add(C_field4);
                        C_panel2.add(Label5);
                        C_panel2.add(C_field5);
                        C_panel2.add(C_button);
                        C_panel2.add(C_button2);
                        C_frame.add(C_panel2);
                        C_frame.setSize(200, 300);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
 
                        }else if(columns[0] == 6 && Comp.get_role().equals("admin")){
                            
                            int column = columns[0] - 5;

                            String data = (String)Cus_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("confirm");  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER));

                            JLabel Label = new JLabel(data);

                            JButton C_button1 = new JButton();
                            C_button1.setText("Delete");

                            C_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                    
                                int delete_index = 0;

                                for(Customer Cus: Cus_list){

                                    if(Cus.get_code().equals(data)){

                                        break;
                                    }

                                    delete_index++;
                                }

                                Cus_list.remove(delete_index);

                                Comp.set_cus_list(Cus_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                                }
                            });

                            JButton C_button2 = new JButton();
                            C_button2.setText("Cancel");

                            C_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                
                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                            });

                            C_panel2.add(Label);
                            C_panel2.add(C_button1);
                            C_panel2.add(C_button2);
                            C_frame.add(C_panel2);
                            C_frame.setSize(200, 110);  
                            C_frame.setLocationRelativeTo(null);
                            C_frame.setVisible(true);

                        }else if(columns[0] == 1){

                            int column = columns[0];

                            String data = (String)Cus_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame(data);
  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER));

                            JButton C_button1 = new JButton("Add to Current Sale");

                            C_button1.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){
    
                                    Comp.set_current_custom(data);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
									add_ve_panel();
                                }
                            }); 

                            JButton C_button2 = new JButton("Cancel");

                            C_button2.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                }
                            }); 

                            C_panel2.add(C_button1);
                            C_panel2.add(C_button2);
                            C_frame.add(C_panel2);
                            C_frame.setSize(250, 100);  
                            C_frame.setLocationRelativeTo(null);
                            C_frame.setVisible(true);
                        }//else if

                    rows = null;
                    columns = null;
                    
                    }//if 
                }      
            });//ActionListener  

            JScrollPane Cus_panel = new JScrollPane(Cus_table);

            add(Cus_panel);
        }

        public void add_all(boolean search, String hint, String where){
			
			removeAll();
			add(C_label);
			add(Box.createRigidArea(new Dimension(0, 40)));
			
			if(Comp.get_role().equals("admin")){
			
			    add(Button1);
			    add(Box.createRigidArea(new Dimension(0, 20)));
			
			}
			
			add(Button2);
			add(Box.createRigidArea(new Dimension(0, 20)));
			add(Button3);
			add(Box.createRigidArea(new Dimension(0, 40)));

			String data[][] = new String[Cus_list.size()][7];

            int a = 0;
            int b = 0;

			if(search){

				hint = hint.toLowerCase();

				switch(where){

                    case "anywhere":

                    for(Customer Cus: Cus_list){

                                if(Cus.get_name().toLowerCase().contains(hint) || Cus.get_code().toLowerCase().contains(hint) || Cus.get_address().toLowerCase().contains(hint) || Cus.get_contact().toLowerCase().contains(hint) || Cus.get_email().toLowerCase().contains(hint)){

                                    data[a][0] = Cus.get_name();
                                    data[a][1] = Cus.get_code();
                                    data[a][2] = Cus.get_address();
                                    data[a][3] = Cus.get_contact();
                                    data[a][4] = Cus.get_email();
                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                    a++;

                                }
                            }

                    break;

					case "name":

                    for(Customer Cus: Cus_list){

                                if(Cus.get_name().toLowerCase().contains(hint)){

                                    data[a][0] = Cus.get_name();
                                    data[a][1] = Cus.get_code();
                                    data[a][2] = Cus.get_address();
                                    data[a][3] = Cus.get_contact();
                                    data[a][4] = Cus.get_email();
                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                    a++;

                                }
                            }

                    break;

					case "code":

                    for(Customer Cus: Cus_list){

                                if(Cus.get_code().toLowerCase().contains(hint)){

                                    data[a][0] = Cus.get_name();
                                    data[a][1] = Cus.get_code();
                                    data[a][2] = Cus.get_address();
                                    data[a][3] = Cus.get_contact();
                                    data[a][4] = Cus.get_email();
                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                    a++;

                                }
                            }

                    break;

					case "address":

                    for(Customer Cus: Cus_list){

                                if(Cus.get_address().toLowerCase().contains(hint)){

                                    data[a][0] = Cus.get_name();
                                    data[a][1] = Cus.get_code();
                                    data[a][2] = Cus.get_address();
                                    data[a][3] = Cus.get_contact();
                                    data[a][4] = Cus.get_email();
                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                    a++;

                                }
                            }

                    break;

					case "contact":

                    for(Customer Cus: Cus_list){

                                if(Cus.get_contact().toLowerCase().contains(hint)){

                                    data[a][0] = Cus.get_name();
                                    data[a][1] = Cus.get_code();
                                    data[a][2] = Cus.get_address();
                                    data[a][3] = Cus.get_contact();
                                    data[a][4] = Cus.get_email();
                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                    a++;

                                }
                            }

                    break;

					case "email":

                    for(Customer Cus: Cus_list){

                                if(Cus.get_email().toLowerCase().contains(hint)){

                                    data[a][0] = Cus.get_name();
                                    data[a][1] = Cus.get_code();
                                    data[a][2] = Cus.get_address();
                                    data[a][3] = Cus.get_contact();
                                    data[a][4] = Cus.get_email();
                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                    a++;

                                }
                            }

                    break;

				}//switch

			}else{

            	for(Customer Cus: Cus_list){

                	data[a][0] = Cus.get_name();
                	data[a][1] = Cus.get_code();
                	data[a][2] = Cus.get_address();
                	data[a][3] = Cus.get_contact();
                	data[a][4] = Cus.get_email();
                	data[a][5] = "click here...";
                	data[a][6] = "click here...";

                	a++;
            	}
			}

            String columns[]={"Name","Code","City","Contact Numbers","Email","Edit","Delete"};    

            JTable Cus_table = new JTable(data, columns);
            TableColumnModel Column_model = Cus_table.getColumnModel();
            Column_model.getColumn(0).setPreferredWidth(200);
            Column_model.getColumn(1).setPreferredWidth(120);
            Column_model.getColumn(2).setPreferredWidth(200);
            Column_model.getColumn(3).setPreferredWidth(200);
            Column_model.getColumn(4).setPreferredWidth(200);
            Column_model.getColumn(5).setPreferredWidth(90);        
            Column_model.getColumn(6).setPreferredWidth(90);

            Cus_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

            Cus_table.setCellSelectionEnabled(true); 
            ListSelectionModel Select = Cus_table.getSelectionModel();  
            Select.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

            Select.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Cus_table.getSelectedRows();
                    int[] columns = Cus_table.getSelectedColumns();
                    
                    //trigger customer display from table
                    if(columns[0] == 5 && Comp.get_role().equals("admin")){

                            int column = columns[0] - 4;

                            String data = (String)Cus_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("Update");  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                            JLabel Label = new JLabel("Customer Name");
                            JLabel Label2 = new JLabel("Customer Code");
                            JLabel Label3 = new JLabel("City");
                            JLabel Label4 = new JLabel("Contact Numbers");
                            JLabel Label5 = new JLabel("Customer Email");

                            Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                            JTextField C_field = new JTextField("");
                            JTextField C_field2 = new JTextField("");
                            JTextField C_field3 = new JTextField("");
                            JTextField C_field4 = new JTextField("");
                            JTextField C_field5 = new JTextField("");

                            C_field.setColumns(15);
                            C_field2.setColumns(15);
                            C_field3.setColumns(15);
                            C_field4.setColumns(15);
                            C_field5.setColumns(15);

                             for(Customer Cus: Cus_list){

                                    if(Cus.get_code().equals(data)){

                                        C_field.setText(Cus.get_name());
                                        C_field2.setText(Cus.get_code());
                                        C_field3.setText(Cus.get_address());
                                        C_field4.setText(Cus.get_contact());
                                        C_field5.setText(Cus.get_email());
                                    }
                            }

                            JButton C_button = new JButton();
                            C_button.setText("Update");

                            //this listener update the selected product Object
                            C_button.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                    boolean detect_duplicate = false;

                                    for(Customer Cus: Cus_list){

                                        if(Cus.get_code().toLowerCase().equals(C_field2.getText().toLowerCase()) && !Cus.get_code().equals(data)){
                                                    
                                            detect_duplicate = true;
                                        }
                                    }

                                    for(Customer Cus: Cus_list){

                                        if(Cus.get_code().equals(data) && !detect_duplicate){

                                            Cus.set_name(C_field.getText());
                                            Cus.set_code(C_field2.getText());
                                            Cus.set_address(C_field3.getText());
                                            Cus.set_contact(C_field4.getText());
                                            Cus.set_email(C_field5.getText());
                                            }
                                    }

                                Comp.set_cus_list(Cus_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                            });

                        JButton C_button2 = new JButton();
                        C_button2.setText("Cancel");

                        C_button2.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){
                            
                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                        });

                        C_panel2.add(Label);
                        C_panel2.add(C_field);
                        C_panel2.add(Label2);
                        C_panel2.add(C_field2);
                        C_panel2.add(Label3);
                        C_panel2.add(C_field3);
                        C_panel2.add(Label4);
                        C_panel2.add(C_field4);
                        C_panel2.add(Label5);
                        C_panel2.add(C_field5);
                        C_panel2.add(C_button);
                        C_panel2.add(C_button2);
                        C_frame.add(C_panel2);
                        C_frame.setSize(200, 300);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
 
                        }else if(columns[0] == 6 && Comp.get_role().equals("admin")){
                            
                            int column = columns[0] - 5;

                            String data = (String)Cus_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("confirm");  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER));

                            JLabel Label = new JLabel(data);

                            JButton C_button1 = new JButton();
                            C_button1.setText("Delete");

                            C_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                    
                                int delete_index = 0;

                                for(Customer Cus: Cus_list){

                                    if(Cus.get_code().equals(data)){

                                        break;
                                    }

                                    delete_index++;
                                }

                                Cus_list.remove(delete_index);

                                Comp.set_cus_list(Cus_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                                }
                            });

                            JButton C_button2 = new JButton();
                            C_button2.setText("Cancel");

                            C_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                
                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                            });

                            C_panel2.add(Label);
                            C_panel2.add(C_button1);
                            C_panel2.add(C_button2);
                            C_frame.add(C_panel2);
                            C_frame.setSize(200, 110);  
                            C_frame.setLocationRelativeTo(null);
                            C_frame.setVisible(true);

                        }else if(columns[0] == 1){

                            int column = columns[0];

                            String data = (String)Cus_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame(data);
  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER));

                            JButton C_button1 = new JButton("Add to Current Sale");

                            C_button1.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                    Comp.set_current_custom(data);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
									add_ve_panel();
                                }
                            }); 

                            JButton C_button2 = new JButton("Cancel");

                            C_button2.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                }
                            }); 

                            C_panel2.add(C_button1);
                            C_panel2.add(C_button2);
                            C_frame.add(C_panel2);
                            C_frame.setSize(250, 100);  
                            C_frame.setLocationRelativeTo(null);
                            C_frame.setVisible(true);
                        }//else if

                    rows = null;
                    columns = null;
                    
                    }//if 
                }      
            });//ActionListener  

            JScrollPane Cus_panel = new JScrollPane(Cus_table);

            add(Cus_panel);
        }

		public void add_ve_panel(){

			Vndos_suite Win = (Vndos_suite)SwingUtilities.windowForComponent(this);
       	    Win.add_ve_panel(2);
		}
}

class Vendors_panel extends Tab_panel{

        JLabel C_label = new JLabel();
        JButton Button1, Button2, Button3;
        ArrayList<Vendor> Ven_list;

        Vendors_panel(){

            super();

            Ven_list = Comp.get_ven_list();
            setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
            C_label.setText(Current_company.getText());
            C_label.setAlignmentX(this.CENTER_ALIGNMENT);
            add(C_label);

            add(Box.createRigidArea(new Dimension(0, 40)));

            Button1 = new JButton("Register Vendor");
            Button1.setAlignmentX(this.CENTER_ALIGNMENT);

            //new Product form
            Button1.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        JFrame C_frame = new JFrame("new Vendor");  
                        JPanel C_panel2 = new JPanel();
                        C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                        JLabel Label = new JLabel("Vendor Name");
                        JLabel Label2 = new JLabel("Vendor Email");
                        JLabel Label3 = new JLabel("Contact Numbers");
                        JLabel Label4 = new JLabel("Address");
                        JLabel Label5 = new JLabel("Status");

                        Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                        JTextField C_field = new JTextField("");
                        JTextField C_field2 = new JTextField("");
                        JTextField C_field3 = new JTextField("");
                        JTextField C_field4 = new JTextField("");

                        C_field.setColumns(15);
                        C_field2.setColumns(15);
                        C_field3.setColumns(15);
                        C_field4.setColumns(15);

                        final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                        Pre_combo1.addElement("active");

                        Pre_combo1.addElement("non active");

                        final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);

                        JScrollPane Combo_panel1 = new JScrollPane(Com_box1);
  
                        JButton C_button = new JButton();
                        C_button.setText("Register"); 
 
                        //this listener creates new Product Object
                        C_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                boolean detect_duplicate = false;

                                for(Vendor Ven: Ven_list){

                                    if(C_field2.getText().toLowerCase().equals(Ven.get_email().toLowerCase())){

                                        detect_duplicate = true;
                                    }
                                }

                                if(!detect_duplicate && !C_field.getText().equals("") && !C_field2.getText().equals("") && !C_field3.getText().equals("") && !C_field4.getText().equals("")){

                                    boolean status = true;

                                    if(Com_box1.getSelectedItem().toString().equals("non active")){

                                        status = false;
                                    }

                                Vendor Ven = new Vendor(C_field.getText(), C_field2.getText(), C_field3.getText(), C_field4.getText(), status);

                                    Ven_list.add(Ven);


                                    Comp.set_ven_list(Ven_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                }

                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                        });

                        C_panel2.add(Label);
                        C_panel2.add(C_field);
                        C_panel2.add(Label2);
                        C_panel2.add(C_field2);
                        C_panel2.add(Label3);
                        C_panel2.add(C_field3);
                        C_panel2.add(Label4);
                        C_panel2.add(C_field4);
                        C_panel2.add(Label5);
                        C_panel2.add(Combo_panel1);
                        C_panel2.add(C_button);
                        C_frame.add(C_panel2);
                        C_frame.setSize(200, 300);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
                }
            });

            if(Comp.get_role().equals("admin")){

                add(Button1);
                add(Box.createRigidArea(new Dimension(0, 20)));
                
            }

            Button2 = new JButton("Search Vendors");
            Button2.setAlignmentX(this.CENTER_ALIGNMENT);

            Button2.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        JFrame S_frame = new JFrame("search Vendor");  
                        JPanel S_panel2 = new JPanel();
                        S_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                        JLabel Label = new JLabel("Enter hint");
                        JLabel Label2 = new JLabel("Search in");

                        Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                        JTextField S_field = new JTextField("");
                        S_field.setColumns(15);
                        S_field.setToolTipText("let this blank for active or non active search");

                        final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                        Pre_combo1.addElement("anywhere");
                        Pre_combo1.addElement("name");
                        Pre_combo1.addElement("email");
                        Pre_combo1.addElement("contact");
                        Pre_combo1.addElement("address");
                        Pre_combo1.addElement("active");
                        Pre_combo1.addElement("non active");

                        final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);
                        JScrollPane Combo_panel1 = new JScrollPane(Com_box1);

                        JButton S_button = new JButton();
                        S_button.setText("Search"); 
 
                        //this listener search the hint product
                        S_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                String where = Com_box1.getSelectedItem().toString();

                                if(!S_field.getText().equals("")){

                                    String hint = S_field.getText();
                                    add_all(true, hint, where);
                                    update();

                                }else if(where.equals("active") || where.equals("non active")){

                                    String hint = S_field.getText();
                                    add_all(true, hint, where);
                                    update();
                                }

                                S_frame.setVisible(false);
                            }
                        });

                        S_panel2.add(Label);
                        S_panel2.add(S_field);
                        S_panel2.add(Label2);
                        S_panel2.add(Combo_panel1);
                        S_panel2.add(S_button);
                        S_frame.add(S_panel2);
                        S_frame.setSize(180, 160);  
                        S_frame.setLocationRelativeTo(null);
                        S_frame.setVisible(true);
                }
            });

            add(Button2);

            add(Box.createRigidArea(new Dimension(0, 20)));

            Button3 = new JButton("Refresh");
            Button3.setAlignmentX(this.CENTER_ALIGNMENT);

            Button3.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){
            
                    add_all(false, "", "");
                    update();
                }
            });

            add(Button3);

            add(Box.createRigidArea(new Dimension(0, 40)));

            String data[][] = new String[Ven_list.size()][7];

            int a = 0;
            int b = 0;

            for(Vendor Ven: Ven_list){

                data[a][0] = Ven.get_name();
                data[a][1] = Ven.get_email();
                data[a][2] = Ven.get_contact();
                data[a][3] = Ven.get_address();

                String status = "active";

                if(!Ven.get_active()){

                    status = "non active";
                }

                data[a][4] = status;
                data[a][5] = "click here...";
                data[a][6] = "click here...";

                a++;
            }
    
            String columns[]={"Name","Email","Contact Numbers","Address","Status","Edit","Delete"};    

            JTable Ven_table = new JTable(data, columns);
            TableColumnModel Column_model = Ven_table.getColumnModel();
            Column_model.getColumn(0).setPreferredWidth(200);
            Column_model.getColumn(1).setPreferredWidth(200);
            Column_model.getColumn(2).setPreferredWidth(200);
            Column_model.getColumn(3).setPreferredWidth(120);
            Column_model.getColumn(4).setPreferredWidth(90);
            Column_model.getColumn(5).setPreferredWidth(90);        
            Column_model.getColumn(6).setPreferredWidth(90);

            Ven_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

            Ven_table.setCellSelectionEnabled(true); 
            ListSelectionModel Select = Ven_table.getSelectionModel();  
            Select.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  
            Select.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Ven_table.getSelectedRows();
                    int[] columns = Ven_table.getSelectedColumns();
                    
                    //trigger vendor display from table
                    if(columns[0] == 5 && Comp.get_role().equals("admin")){

                            int column = columns[0] - 4;

                            String data = (String)Ven_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("Update");  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                            JLabel Label = new JLabel("Vendor Name");
                            JLabel Label2 = new JLabel("Vendor Email");
                            JLabel Label3 = new JLabel("Contact Numbers");
                            JLabel Label4 = new JLabel("Address");
                            JLabel Label5 = new JLabel("Active");

                            Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                            JTextField C_field = new JTextField("");
                            JTextField C_field2 = new JTextField("");
                            JTextField C_field3 = new JTextField("");
                            JTextField C_field4 = new JTextField("");

                            C_field.setColumns(15);
                            C_field2.setColumns(15);
                            C_field3.setColumns(15);
                            C_field4.setColumns(15);

                            final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                            for(Vendor Ven: Ven_list){

                                    if(Ven.get_email().equals(data)){

                                        C_field.setText(Ven.get_name());
                                        C_field2.setText(Ven.get_email());
                                        C_field3.setText(Ven.get_contact());
                                        C_field4.setText(Ven.get_address());

                                        String status = "active";
                                        String non_status = "non active";

                                        if(!Ven.get_active()){

                                            status = "non active";
                                            non_status = "active";
                                        }

                                        Pre_combo1.addElement(status);
                                        Pre_combo1.addElement(non_status);
                                    }
                            }

                            final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);

                            JScrollPane Combo_panel1 = new JScrollPane(Com_box1);

                            JButton C_button = new JButton();
                            C_button.setText("Update");

                            //this listener update the selected product Object
                            C_button.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                    boolean status = true;
                                    boolean detect_duplicate = false;

                                    if(Com_box1.getSelectedItem().toString().equals("non active")){

                                        status = false;
                                    }

                                    for(Vendor Ven: Ven_list){

                                        if(!Ven.get_email().equals(data) && C_field2.getText().toLowerCase().equals(Ven.get_email().toLowerCase())){

                                            detect_duplicate = true;
                                        }
                                    }

                                    for(Vendor Ven: Ven_list){

                                        if(Ven.get_email().equals(data) && !detect_duplicate){

                                            Ven.set_name(C_field.getText());
                                            Ven.set_email(C_field2.getText());
                                            Ven.set_contact(C_field3.getText());
                                            Ven.set_address(C_field4.getText());
                                            Ven.set_active(status);
                                            }
                                    }

                                Comp.set_ven_list(Ven_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                            });

                        JButton C_button2 = new JButton();
                        C_button2.setText("Cancel");

                        C_button2.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){
                            
                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                        });

                        C_panel2.add(Label);
                        C_panel2.add(C_field);
                        C_panel2.add(Label2);
                        C_panel2.add(C_field2);
                        C_panel2.add(Label3);
                        C_panel2.add(C_field3);
                        C_panel2.add(Label4);
                        C_panel2.add(C_field4);
                        C_panel2.add(Label5);
                        C_panel2.add(Combo_panel1);
                        C_panel2.add(C_button);
                        C_panel2.add(C_button2);
                        C_frame.add(C_panel2);
                        C_frame.setSize(200, 300);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
 
                        }else if(columns[0] == 6 && Comp.get_role().equals("admin")){
                            
                            int column = columns[0] - 5;

                            String data = (String)Ven_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("confirm");  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER));

                            JLabel Label = new JLabel(data);

                            JButton C_button1 = new JButton();
                            C_button1.setText("Delete");

                            C_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                    
                                int delete_index = 0;

                                for(Vendor Ven: Ven_list){

                                    if(Ven.get_email().equals(data)){

                                        break;
                                    }

                                    delete_index++;
                                }

                                Ven_list.remove(delete_index);

                                Comp.set_ven_list(Ven_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                                }
                            });

                            JButton C_button2 = new JButton();
                            C_button2.setText("Cancel");

                            C_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                
                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                            });

                            C_panel2.add(Label);
                            C_panel2.add(C_button1);
                            C_panel2.add(C_button2);
                            C_frame.add(C_panel2);
                            C_frame.setSize(200, 110);  
                            C_frame.setLocationRelativeTo(null);
                            C_frame.setVisible(true);

                        }//else if

                    rows = null;
                    columns = null;
                    
                    }//if 
                }      
            });//ActionListener  

            JScrollPane Ven_panel = new JScrollPane(Ven_table);

            add(Ven_panel); 
        }

        public void add_all(boolean search, String hint, String where){

            removeAll();

            add(C_label);
            add(Box.createRigidArea(new Dimension(0, 40)));
            
            if(Comp.get_role().equals("admin")){
            
                add(Button1);
                add(Box.createRigidArea(new Dimension(0, 20)));
                
            }
            
            add(Button2);
            add(Box.createRigidArea(new Dimension(0, 20)));
            add(Button3);
            add(Box.createRigidArea(new Dimension(0, 40)));

            String data[][] = new String[Ven_list.size()][7];

            int a = 0;
            int b = 0;

            //if a search is requested trough the search button
            if(search){

                hint = hint.toLowerCase();

                switch(where){

                    case "anywhere":

                    for(Vendor Ven: Ven_list){

                                if(Ven.get_name().toLowerCase().contains(hint) || Ven.get_email().toLowerCase().contains(hint) || Ven.get_contact().toLowerCase().contains(hint) || Ven.get_address().toLowerCase().contains(hint)){

                                    data[a][0] = Ven.get_name();
                                    data[a][1] = Ven.get_email();
                                    data[a][2] = Ven.get_contact();
                                    data[a][3] = Ven.get_address();

                                    String status = "active";

                                    if(!Ven.get_active()){

                                        status = "non active";
                                    }

                                    data[a][4] = status;

                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                    a++;

                                }
                            }

                    break;

                    case "name":

                        for(Vendor Ven: Ven_list){

                                if(Ven.get_name().toLowerCase().contains(hint)){

                                    data[a][0] = Ven.get_name();
                                    data[a][1] = Ven.get_email();
                                    data[a][2] = Ven.get_contact();
                                    data[a][3] = Ven.get_address();

                                    String status = "active";

                                    if(!Ven.get_active()){

                                        status = "non active";
                                    }

                                    data[a][4] = status;

                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                a++;

                                }
                       }

                    break;

                    case "email":

                        for(Vendor Ven: Ven_list){

                                if(Ven.get_email().toLowerCase().contains(hint)){

                                    data[a][0] = Ven.get_name();
                                    data[a][1] = Ven.get_email();
                                    data[a][2] = Ven.get_contact();
                                    data[a][3] = Ven.get_address();

                                    String status = "active";

                                    if(!Ven.get_active()){

                                        status = "non active";
                                    }

                                    data[a][4] = status;

                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                a++;

                                }
                       }

                    break;

                    case "contact":

                        for(Vendor Ven: Ven_list){

                                if(Ven.get_contact().toLowerCase().contains(hint)){

                                    data[a][0] = Ven.get_name();
                                    data[a][1] = Ven.get_email();
                                    data[a][2] = Ven.get_contact();
                                    data[a][3] = Ven.get_address();

                                    String status = "active";

                                    if(!Ven.get_active()){

                                        status = "non active";
                                    }

                                    data[a][4] = status;

                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                a++;

                                }
                       }

                    break;

                    case "address":

                        for(Vendor Ven: Ven_list){

                                if(Ven.get_address().toLowerCase().contains(hint)){

                                    data[a][0] = Ven.get_name();
                                    data[a][1] = Ven.get_email();
                                    data[a][2] = Ven.get_contact();
                                    data[a][3] = Ven.get_address();

                                    String status = "active";

                                    if(!Ven.get_active()){

                                        status = "non active";
                                    }

                                    data[a][4] = status;

                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                a++;

                                }
                       }

                    break;

                    case "active":

                        for(Vendor Ven: Ven_list){

                                if(Ven.get_active()){

                                    data[a][0] = Ven.get_name();
                                    data[a][1] = Ven.get_email();
                                    data[a][2] = Ven.get_contact();
                                    data[a][3] = Ven.get_address();

                                    String status = "active";

                                    if(!Ven.get_active()){

                                        status = "non active";
                                    }

                                    data[a][4] = status;

                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                a++;

                                }
                       }

                    break;

                    case "non active":

                        for(Vendor Ven: Ven_list){

                                if(!Ven.get_active()){

                                    data[a][0] = Ven.get_name();
                                    data[a][1] = Ven.get_email();
                                    data[a][2] = Ven.get_contact();
                                    data[a][3] = Ven.get_address();

                                    String status = "active";

                                    if(!Ven.get_active()){

                                        status = "non active";
                                    }

                                    data[a][4] = status;

                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                a++;

                                }
                       }

                    break;

                    }//switch

                }else{

                    for(Vendor Ven: Ven_list){

                                    data[a][0] = Ven.get_name();
                                    data[a][1] = Ven.get_email();
                                    data[a][2] = Ven.get_contact();
                                    data[a][3] = Ven.get_address();

                                    String status = "active";

                                    if(!Ven.get_active()){

                                        status = "non active";
                                    }

                                    data[a][4] = status;

                                    data[a][5] = "click here...";
                                    data[a][6] = "click here...";

                                a++;
                   }
                }

            String columns[]={"Name","Email","Contact Numbers","Address","Status","Edit","Delete"};    

            JTable Ven_table = new JTable(data, columns);
            TableColumnModel Column_model = Ven_table.getColumnModel();
            Column_model.getColumn(0).setPreferredWidth(200);
            Column_model.getColumn(1).setPreferredWidth(200);
            Column_model.getColumn(2).setPreferredWidth(200);
            Column_model.getColumn(3).setPreferredWidth(120);
            Column_model.getColumn(4).setPreferredWidth(90);
            Column_model.getColumn(5).setPreferredWidth(90);        
            Column_model.getColumn(6).setPreferredWidth(90);

            Ven_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

            Ven_table.setCellSelectionEnabled(true); 
            ListSelectionModel Select = Ven_table.getSelectionModel();  
            Select.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  
            Select.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Ven_table.getSelectedRows();
                    int[] columns = Ven_table.getSelectedColumns();
                    
                    //trigger vendor display from table
                    if(columns[0] == 5 && Comp.get_role().equals("admin")){

                            int column = columns[0] - 4;

                            String data = (String)Ven_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("Update");  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                            JLabel Label = new JLabel("Vendor Name");
                            JLabel Label2 = new JLabel("Vendor Email");
                            JLabel Label3 = new JLabel("Contact Numbers");
                            JLabel Label4 = new JLabel("Address");
                            JLabel Label5 = new JLabel("Active");

                            Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                            JTextField C_field = new JTextField("");
                            JTextField C_field2 = new JTextField("");
                            JTextField C_field3 = new JTextField("");
                            JTextField C_field4 = new JTextField("");

                            C_field.setColumns(15);
                            C_field2.setColumns(15);
                            C_field3.setColumns(15);
                            C_field4.setColumns(15);

                            final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                            for(Vendor Ven: Ven_list){

                                    if(Ven.get_email().equals(data)){

                                        C_field.setText(Ven.get_name());
                                        C_field2.setText(Ven.get_email());
                                        C_field3.setText(Ven.get_contact());
                                        C_field4.setText(Ven.get_address());

                                        String status = "active";
                                        String non_status = "non active";

                                        if(!Ven.get_active()){

                                            status = "non active";
                                            non_status = "active";
                                        }

                                        Pre_combo1.addElement(status);
                                        Pre_combo1.addElement(non_status);
                                    }
                            }

                            final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);

                            JScrollPane Combo_panel1 = new JScrollPane(Com_box1);

                            JButton C_button = new JButton();
                            C_button.setText("Update");

                            //this listener update the selected product Object
                            C_button.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                   boolean status = true;
                                   boolean detect_duplicate = false;
                                

                                    if(Com_box1.getSelectedItem().toString().equals("non active")){

                                        status = false;
                                    }

                                    for(Vendor Ven: Ven_list){

                                        if(!Ven.get_email().equals(data) && C_field2.getText().toLowerCase().equals(Ven.get_email().toLowerCase())){

                                            detect_duplicate = true;
                                        }
                                    }

                                    for(Vendor Ven: Ven_list){

                                        if(Ven.get_email().equals(data) && !detect_duplicate){

                                            Ven.set_name(C_field.getText());
                                            Ven.set_email(C_field2.getText());
                                            Ven.set_contact(C_field3.getText());
                                            Ven.set_address(C_field4.getText());
                                            Ven.set_active(status);
                                            }
                                    }

                                Comp.set_ven_list(Ven_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                            });

                        JButton C_button2 = new JButton();
                        C_button2.setText("Cancel");

                        C_button2.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){
                            
                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                        });

                        C_panel2.add(Label);
                        C_panel2.add(C_field);
                        C_panel2.add(Label2);
                        C_panel2.add(C_field2);
                        C_panel2.add(Label3);
                        C_panel2.add(C_field3);
                        C_panel2.add(Label4);
                        C_panel2.add(C_field4);
                        C_panel2.add(Label5);
                        C_panel2.add(Combo_panel1);
                        C_panel2.add(C_button);
                        C_panel2.add(C_button2);
                        C_frame.add(C_panel2);
                        C_frame.setSize(200, 300);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
 
                        }else if(columns[0] == 6 && Comp.get_role().equals("admin")){
                            
                            int column = columns[0] - 5;

                            String data = (String)Ven_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("confirm");  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER));

                            JLabel Label = new JLabel(data);

                            JButton C_button1 = new JButton();
                            C_button1.setText("Delete");

                            C_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                    
                                int delete_index = 0;

                                for(Vendor Ven: Ven_list){

                                    if(Ven.get_email().equals(data)){

                                        break;
                                    }

                                    delete_index++;
                                }

                                Ven_list.remove(delete_index);

                                Comp.set_ven_list(Ven_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                                }
                            });

                            JButton C_button2 = new JButton();
                            C_button2.setText("Cancel");

                            C_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                
                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                            });

                            C_panel2.add(Label);
                            C_panel2.add(C_button1);
                            C_panel2.add(C_button2);
                            C_frame.add(C_panel2);
                            C_frame.setSize(200, 110);  
                            C_frame.setLocationRelativeTo(null);
                            C_frame.setVisible(true);

                        }//else if

                    rows = null;
                    columns = null;
                    
                    }//if 
                }      
            });//ActionListener  

            JScrollPane Ven_panel = new JScrollPane(Ven_table);

            add(Ven_panel); 
        }
}

            

class Products_panel extends Tab_panel{

        JLabel C_label = new JLabel();
        JButton Button1, Button2, Button3;
        ArrayList<Product> Pro_list;

        Products_panel(){

            super();

            Pro_list = Comp.get_pro_list();
            setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
            C_label.setText(Current_company.getText());
            C_label.setAlignmentX(this.CENTER_ALIGNMENT);
            add(C_label);

            add(Box.createRigidArea(new Dimension(0, 40)));

            Button1 = new JButton("Add Product");
            Button1.setAlignmentX(this.CENTER_ALIGNMENT);

            //new Product form
            Button1.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        JFrame C_frame = new JFrame("new Product");  
                        JPanel C_panel2 = new JPanel();
                        C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                        JLabel Label = new JLabel("Product Name");
                        JLabel Label2 = new JLabel("Product Code");
                        JLabel Label3 = new JLabel("Product Price");
                        JLabel Label4 = new JLabel("Warranty days");
                        JLabel Label5 = new JLabel("Description");

                        Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                        JTextField C_field = new JTextField("");
                        JTextField C_field2 = new JTextField("");
                        JTextField C_field3 = new JTextField("");
                        JTextField C_field4 = new JTextField("0");
                        JTextArea C_field5 = new JTextArea(15,4);
                        C_field5.setText("description");

                        C_field5.setRows(4);
                        JScrollPane C_field5_pane = new JScrollPane(C_field5, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

                        C_field.setColumns(15);
                        C_field2.setColumns(15);
                        C_field3.setColumns(15);
                        C_field4.setColumns(15);
                        C_field5.setColumns(15);

                        final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                        Pre_combo1.addElement("select category");

                        for(Category Cat: Comp.get_cat_list()){

                            Pre_combo1.addElement(Cat.get_name());
                        }

                        final DefaultComboBoxModel<String> Pre_combo2 = new DefaultComboBoxModel<String>();

                        Pre_combo2.addElement("select brand");

                        for(Brand Bra: Comp.get_bra_list()){

                            Pre_combo2.addElement(Bra.get_name());
                        }

                        final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);

                        JScrollPane Combo_panel1 = new JScrollPane(Com_box1);

                        final JComboBox<String> Com_box2 = new JComboBox<String>(Pre_combo2);

                        JScrollPane Combo_panel2 = new JScrollPane(Com_box2);
  
                        JButton C_button = new JButton();
                        C_button.setText("Register"); 
 
                        //this listener creates new Product Object
                        C_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                boolean detect_duplicate = false;

                                for(Product Pro: Pro_list){

                                    if(C_field.getText().toLowerCase().equals(Pro.get_name().toLowerCase()) || C_field2.getText().toLowerCase().equals(Pro.get_code().toLowerCase())){

                                    detect_duplicate = true;
                                    }
                                }

                                if(!detect_duplicate && !C_field.getText().equals("") && !C_field2.getText().equals("") && !C_field3.getText().equals("") && !C_field4.getText().equals("") && !Com_box1.getSelectedItem().toString().equals("") && !Com_box2.getSelectedItem().toString().equals("") && !C_field5.getText().equals("")){

                                Product Pro = new Product(C_field.getText(), C_field2.getText(), Float.parseFloat(C_field3.getText()), Integer.parseInt(C_field4.getText()), Com_box1.getSelectedItem().toString(), Com_box2.getSelectedItem().toString(), C_field5.getText());

                                    Pro_list.add(Pro);


                                    Comp.set_pro_list(Pro_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                }

                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                        });

                        C_panel2.add(Label);
                        C_panel2.add(C_field);
                        C_panel2.add(Label2);
                        C_panel2.add(C_field2);
                        C_panel2.add(Label3);
                        C_panel2.add(C_field3);
                        C_panel2.add(Label4);
                        C_panel2.add(C_field4);
                        C_panel2.add(Label5);
                        C_panel2.add(C_field5_pane);
                        C_panel2.add(Combo_panel1);
                        C_panel2.add(Combo_panel2);
                        C_panel2.add(C_button);
                        C_frame.add(C_panel2);
                        C_frame.setSize(210, 400);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
                }
            });
            
            if(Comp.get_role().equals("admin")){

                add(Button1);
                add(Box.createRigidArea(new Dimension(0, 20)));
            
            }
            

            Button2 = new JButton("Search Products");
            Button2.setAlignmentX(this.CENTER_ALIGNMENT);

            Button2.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        JFrame S_frame = new JFrame("search Product");  
                        JPanel S_panel2 = new JPanel();
                        S_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                        JLabel Label = new JLabel("Enter hint");
                        JLabel Label2 = new JLabel("Search in");

                        Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                        JTextField S_field = new JTextField("");
                        S_field.setColumns(15);

                        final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                        Pre_combo1.addElement("anywhere");
                        Pre_combo1.addElement("name");
                        Pre_combo1.addElement("code");
                        Pre_combo1.addElement("category");
                        Pre_combo1.addElement("brand");
                        Pre_combo1.addElement("description");

                        final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);
                        JScrollPane Combo_panel1 = new JScrollPane(Com_box1);

                        JButton S_button = new JButton();
                        S_button.setText("Search"); 
 
                        //this listener search the hint product
                        S_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                if(!S_field.getText().equals("")){

                                    String hint = S_field.getText();
                                    String where = Com_box1.getSelectedItem().toString();
                                    add_all(true, hint, where);
                                    update();

                                }

                                S_frame.setVisible(false);
                            }
                        });

                        S_panel2.add(Label);
                        S_panel2.add(S_field);
                        S_panel2.add(Label2);
                        S_panel2.add(Combo_panel1);
                        S_panel2.add(S_button);
                        S_frame.add(S_panel2);
                        S_frame.setSize(180, 160);  
                        S_frame.setLocationRelativeTo(null);
                        S_frame.setVisible(true);
                }
            });

            add(Button2);

            add(Box.createRigidArea(new Dimension(0, 20)));

            Button3 = new JButton("Refresh");
            Button3.setAlignmentX(this.CENTER_ALIGNMENT);

            Button3.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){
            
                    add_all(false, "", "");
                    update();
                }
            });

            add(Button3);

            add(Box.createRigidArea(new Dimension(0, 40)));

            String data[][] = new String[Pro_list.size()][9];

            int a = 0;
            int b = 0;

            for(Product Pro: Pro_list){

                data[a][0] = Pro.get_name();
                data[a][1] = Pro.get_code();
                data[a][2] = Float.toString(Pro.get_price());
                data[a][3] = Integer.toString(Pro.get_warranty());
                data[a][4] = Pro.get_category();
                data[a][5] = Pro.get_brand();
                data[a][6] = "click here...";
                data[a][7] = "click here...";
                data[a][8] = "click here...";

                a++;
            }
    
            String columns[]={"Name","Code","Price","warranty days","Category","Brand","Description","Delete","Edit"};    

            JTable Pro_table = new JTable(data, columns);
            TableColumnModel Column_model = Pro_table.getColumnModel();
            Column_model.getColumn(0).setPreferredWidth(200);
            Column_model.getColumn(1).setPreferredWidth(75);
            Column_model.getColumn(2).setPreferredWidth(100);
            Column_model.getColumn(3).setPreferredWidth(60);
            Column_model.getColumn(4).setPreferredWidth(120);
            Column_model.getColumn(5).setPreferredWidth(120);
            Column_model.getColumn(6).setPreferredWidth(90);
            Column_model.getColumn(7).setPreferredWidth(90);        
            Column_model.getColumn(8).setPreferredWidth(90);

            Pro_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

            Pro_table.setCellSelectionEnabled(true); 
            ListSelectionModel Select = Pro_table.getSelectionModel();  
            Select.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  
            Select.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){

                    int[] rows = Pro_table.getSelectedRows();
                    int[] columns = Pro_table.getSelectedColumns();
                    
                    //trigger product display from table
                    if(columns[0] == 6){

                        String data = null;  
                        String description = null;
                        String code = null;

                        int column = columns[0] - 6;

                        data = (String)Pro_table.getValueAt(rows[0], column);

                        for(Product Pro: Pro_list){

                            if(Pro.get_name().equals(data)){

                                description = Pro.get_description();
                                code = Pro.get_code();
                            }
                        }

                        JFrame D_frame = new JFrame("description");
                        JPanel D_panel = new JPanel();
                        D_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
                        JLabel Label = new JLabel(code);
                        Label.setAlignmentX(Component.CENTER_ALIGNMENT);
                        JTextArea D_textarea = new JTextArea(description, 15, 5);
                        D_textarea.setColumns(15);
                        D_textarea.setRows(5);  
                        JScrollPane Scroll_d = new JScrollPane(D_textarea, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                        JButton D_button = new JButton("OK");

                        D_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                        
                                D_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                        });

                        D_panel.add(Label);
                        D_panel.add(Scroll_d);
                        D_panel.add(D_button);
                        D_frame.add(D_panel);
                        D_frame.setSize(210, 180);  
                        D_frame.setLocationRelativeTo(null);
                        D_frame.setVisible(true);
                        
                        //trigger product delete from table
                        }else if(columns[0] == 7){
                            
                            int column = columns[0] - 6;

                            String data = (String)Pro_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("confirm");  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER));

                            JLabel Label = new JLabel(data);

                            JButton C_button1 = new JButton();
                            C_button1.setText("Delete");

                            C_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                    
                                int delete_index = 0;

                                for(Product Pro: Pro_list){

                                    if(Pro.get_code().equals(data)){

                                        break;
                                    }

                                    delete_index++;
                                }

                                Pro_list.remove(delete_index);

                                Comp.set_pro_list(Pro_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                                }
                            });

                            JButton C_button2 = new JButton();
                            C_button2.setText("Cancel");

                            C_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                
                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                            });

                            C_panel2.add(Label);
                            C_panel2.add(C_button1);
                            C_panel2.add(C_button2);
                            C_frame.add(C_panel2);
                            C_frame.setSize(110, 110);  
                            C_frame.setLocationRelativeTo(null);
                            C_frame.setVisible(true);

                        //trigger product update from table
                        }else if(columns[0] == 8){

                            int column = columns[0] - 7;

                            String data = (String)Pro_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("update Product");
  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                            JLabel Label = new JLabel("Product Name");
                            JLabel Label2 = new JLabel("Product Code");
                            JLabel Label3 = new JLabel("Product Price");
                            JLabel Label4 = new JLabel("Warranty days");
                            JLabel Label5 = new JLabel("Description");

                            Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                            JTextField C_field = new JTextField("");
                            JTextField C_field2 = new JTextField("");
                            JTextField C_field3 = new JTextField("");
                            JTextField C_field4 = new JTextField("0");
                            JTextArea C_field5 = new JTextArea(15,4);

                            C_field5.setRows(4);
                            JScrollPane C_field5_pane = new JScrollPane(C_field5, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);


                            C_field.setColumns(15);
                            C_field2.setColumns(15);
                            C_field3.setColumns(15);
                            C_field4.setColumns(15);
                            C_field5.setColumns(15);

                            final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                            final DefaultComboBoxModel<String> Pre_combo2 = new DefaultComboBoxModel<String>();

                            for(Product Pro: Pro_list){

                                    if(Pro.get_code().equals(data)){

                                        C_field.setText(Pro.get_name());
                                        C_field2.setText(Pro.get_code());
                                        C_field3.setText(Float.toString(Pro.get_price()));
                                        C_field4.setText(Integer.toString(Pro.get_warranty()));
                                        C_field5.setText(Pro.get_description());
                                        Pre_combo1.addElement(Pro.get_category());
                                        Pre_combo2.addElement(Pro.get_brand());
                                    }
                            }    

                            for(Category Cat: Comp.get_cat_list()){

                                Pre_combo1.addElement(Cat.get_name());
                            }

                            for(Brand Bra: Comp.get_bra_list()){

                                Pre_combo2.addElement(Bra.get_name());
                            }
    
                            final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);

                            JScrollPane Combo_panel1 = new JScrollPane(Com_box1);

                            final JComboBox<String> Com_box2 = new JComboBox<String>(Pre_combo2);

                            JScrollPane Combo_panel2 = new JScrollPane(Com_box2);
    
                            JButton C_button = new JButton();
                            C_button.setText("Update");

                            //this listener update the selected product Object
                            C_button.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                boolean detect_duplicate = false;

                                for(Product Pro: Pro_list){

                                    if(C_field2.getText().toLowerCase().equals(Pro.get_code().toLowerCase()) && !Pro.get_code().equals(data)){

                                            detect_duplicate = true;
                                    }
                                }

                                    for(Product Pro: Pro_list){

                                        if(Pro.get_code().equals(data) && !detect_duplicate){

                                            Pro.set_name(C_field.getText());
                                            Pro.set_code(C_field2.getText());
                                            Pro.set_price(Float.parseFloat(C_field3.getText()));
                                            Pro.set_warranty(Integer.parseInt(C_field4.getText()));
                                            Pro.set_description(C_field5.getText());
                                            Pro.set_category(Com_box1.getSelectedItem().toString());
                                            Pro.set_brand(Com_box2.getSelectedItem().toString());
                                            }
                                    }

                                Comp.set_pro_list(Pro_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                            });

                        JButton C_button2 = new JButton();
                        C_button2.setText("Cancel");

                        C_button2.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){
                            
                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                        });

                        C_panel2.add(Label);
                        C_panel2.add(C_field);
                        C_panel2.add(Label2);
                        C_panel2.add(C_field2);
                        C_panel2.add(Label3);
                        C_panel2.add(C_field3);
                        C_panel2.add(Label4);
                        C_panel2.add(C_field4);
                        C_panel2.add(Label5);
                        C_panel2.add(C_field5_pane);
                        C_panel2.add(Combo_panel1);
                        C_panel2.add(Combo_panel2);
                        C_panel2.add(C_button);
                        C_panel2.add(C_button2);
                        C_frame.add(C_panel2);
                        C_frame.setSize(200, 420);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
 
                        }else if(columns[0] == 1){

                            int column = columns[0];

                            String data = (String)Pro_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame(data);
  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER));

                            JLabel Label = new JLabel("quantity");

                            Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                            JTextField C_field = new JTextField("");

                            C_field.setColumns(10);

                            JButton C_button1 = new JButton("Add to Cart");

                            C_button1.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                    ArrayList<String> Codes = Comp.get_codes();
                                    ArrayList<Integer> Qts = Comp.get_qts();

                                    boolean exists_prod = false;
                                    int count1 = 0;

                                    for(String code: Codes){
        
                                        if(code.equals(data)){
                
                                            int qt = Qts.get(count1);
                                            qt += Integer.parseInt(C_field.getText());
                                            Qts.set(count1, qt);
                                            exists_prod = true;
                                            break;
                                        } 

                                        count1++;    
                                    }

                                    if(!exists_prod){

                                        Codes.add(data);
                                        Qts.add(Integer.parseInt(C_field.getText()));
                                    }

                                    

                                    Comp.set_codes(Codes);
                                    Comp.set_qts(Qts);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");

                                    add_ve_panel();
                                }
                            }); 

                            JButton C_button2 = new JButton("Cancel");

                            
                            C_button2.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                 }
                            });

                            C_panel2.add(Label);
                            C_panel2.add(C_field);
                            C_panel2.add(C_button1);
                            C_panel2.add(C_button2);
                            C_frame.add(C_panel2);
                            C_frame.setSize(220, 100);  
                            C_frame.setLocationRelativeTo(null);
                            C_frame.setVisible(true);
                        }//else if

                    rows = null;
                    columns = null;
                    
                    }//if 
                }      
            });//ActionListener  

            JScrollPane Pro_panel = new JScrollPane(Pro_table);

            add(Pro_panel); 
        }

        public void add_all(boolean search, String hint, String where){

            removeAll();

            add(C_label);
            add(Box.createRigidArea(new Dimension(0, 40)));
            
            if(Comp.get_role().equals("admin")){
            
                add(Button1);
                add(Box.createRigidArea(new Dimension(0, 20)));
            
            }
            
            add(Button2);
            add(Box.createRigidArea(new Dimension(0, 20)));
            add(Button3);
            add(Box.createRigidArea(new Dimension(0, 40)));

            String data[][] = new String[Pro_list.size()][9];

            int a = 0;
            int b = 0;

            //if a search is requested trough the search button
            if(search){

                hint = hint.toLowerCase();

                switch(where){

                    case "anywhere":

                            for(Product Pro: Pro_list){

                                if(Pro.get_name().toLowerCase().contains(hint) || Pro.get_code().toLowerCase().contains(hint) || Pro.get_category().toLowerCase().contains(hint) || Pro.get_brand().toLowerCase().contains(hint)){

                                    data[a][0] = Pro.get_name();
                                    data[a][1] = Pro.get_code();
                                    data[a][2] = Float.toString(Pro.get_price());
                                    data[a][3] = Integer.toString(Pro.get_warranty());
                                    data[a][4] = Pro.get_category();
                                    data[a][5] = Pro.get_brand();
                                    data[a][6] = "click here...";
                                    data[a][7] = "click here...";
                                    data[a][8] = "click here...";

                                    a++;

                                }
                            }

                    break;

                    case "name":

                        for(Product Pro: Pro_list){

                                if(Pro.get_name().toLowerCase().contains(hint)){

                                    data[a][0] = Pro.get_name();
                                    data[a][1] = Pro.get_code();
                                    data[a][2] = Float.toString(Pro.get_price());
                                    data[a][3] = Integer.toString(Pro.get_warranty());
                                    data[a][4] = Pro.get_category();
                                    data[a][5] = Pro.get_brand();
                                    data[a][6] = "click here...";
                                    data[a][7] = "click here...";
                                    data[a][8] = "click here...";

                                a++;

                                }
                       }

                    break;

                    case "code":

                        for(Product Pro: Pro_list){

                                if(Pro.get_code().toLowerCase().contains(hint)){

                                    data[a][0] = Pro.get_name();
                                    data[a][1] = Pro.get_code();
                                    data[a][2] = Float.toString(Pro.get_price());
                                    data[a][3] = Integer.toString(Pro.get_warranty());
                                    data[a][4] = Pro.get_category();
                                    data[a][5] = Pro.get_brand();
                                    data[a][6] = "click here...";
                                    data[a][7] = "click here...";
                                    data[a][8] = "click here...";

                                a++;

                                }
                       }

                    break;

                    case "category":

                        for(Product Pro: Pro_list){

                                if(Pro.get_category().toLowerCase().contains(hint)){

                                    data[a][0] = Pro.get_name();
                                    data[a][1] = Pro.get_code();
                                    data[a][2] = Float.toString(Pro.get_price());
                                    data[a][3] = Integer.toString(Pro.get_warranty());
                                    data[a][4] = Pro.get_category();
                                    data[a][5] = Pro.get_brand();
                                    data[a][6] = "click here...";
                                    data[a][7] = "click here...";
                                    data[a][8] = "click here...";

                                a++;

                                }
                       }

                    break;

                    case "brand":

                        for(Product Pro: Pro_list){

                                if(Pro.get_brand().toLowerCase().contains(hint)){

                                    data[a][0] = Pro.get_name();
                                    data[a][1] = Pro.get_code();
                                    data[a][2] = Float.toString(Pro.get_price());
                                    data[a][3] = Integer.toString(Pro.get_warranty());
                                    data[a][4] = Pro.get_category();
                                    data[a][5] = Pro.get_brand();
                                    data[a][6] = "click here...";
                                    data[a][7] = "click here...";
                                    data[a][8] = "click here...";

                                a++;

                                }
                       }

                    break;

                    case "description":

                        for(Product Pro: Pro_list){

                                if(Pro.get_description().toLowerCase().contains(hint)){

                                    data[a][0] = Pro.get_name();
                                    data[a][1] = Pro.get_code();
                                    data[a][2] = Float.toString(Pro.get_price());
                                    data[a][3] = Integer.toString(Pro.get_warranty());
                                    data[a][4] = Pro.get_category();
                                    data[a][5] = Pro.get_brand();
                                    data[a][6] = "click here...";
                                    data[a][7] = "click here...";
                                    data[a][8] = "click here...";

                                a++;

                                }
                       }

                    break;

                }//switch

            }else{

                for(Product Pro: Pro_list){

                    data[a][0] = Pro.get_name();
                    data[a][1] = Pro.get_code();
                    data[a][2] = Float.toString(Pro.get_price());
                    data[a][3] = Integer.toString(Pro.get_warranty());
                    data[a][4] = Pro.get_category();
                    data[a][5] = Pro.get_brand();
                    data[a][6] = "click here...";
                    data[a][7] = "click here...";
                    data[a][8] = "click here...";

                    a++;
                }

            }

            

            String columns[]={"Name","Code","Price","warranty days","Category","Brand","Description","Delete","Edit"};

            JTable Pro_table = new JTable(data, columns);
            TableColumnModel Column_model = Pro_table.getColumnModel();
            Column_model.getColumn(0).setPreferredWidth(200);
            Column_model.getColumn(1).setPreferredWidth(75);
            Column_model.getColumn(2).setPreferredWidth(100);
            Column_model.getColumn(3).setPreferredWidth(60);
            Column_model.getColumn(4).setPreferredWidth(120);
            Column_model.getColumn(5).setPreferredWidth(120);
            Column_model.getColumn(6).setPreferredWidth(90);
            Column_model.getColumn(7).setPreferredWidth(90);
            Column_model.getColumn(8).setPreferredWidth(90);

            Pro_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

            Pro_table.setCellSelectionEnabled(true); 
            ListSelectionModel Select= Pro_table.getSelectionModel();  
            Select.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  
            Select.addListSelectionListener(new ListSelectionListener() {  
              public void valueChanged(ListSelectionEvent e) {

                if(!e.getValueIsAdjusting()){
          
                    int[] rows = Pro_table.getSelectedRows();
                    int[] columns = Pro_table.getSelectedColumns();

                    //trigger the description display from table
                    if(columns[0] == 6){

                        String data = null;  
                        String description = null;
                        String code = null; 

                        int column = columns[0] - 6;

                        data = (String)Pro_table.getValueAt(rows[0], column);
                

                        for(Product Pro: Pro_list){

                            if(Pro.get_name().equals(data)){

                                description = Pro.get_description();
                                code = Pro.get_code();
                        
                            }
                        }


                        JFrame D_frame = new JFrame("description");
                        JPanel D_panel = new JPanel();
                        D_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
                        JLabel Label = new JLabel(code);
                        Label.setAlignmentX(Component.CENTER_ALIGNMENT);
                        JTextArea D_textarea = new JTextArea(description, 15, 5);
                        D_textarea.setColumns(15);
                        D_textarea.setRows(5);  
                        JScrollPane Scroll_d = new JScrollPane(D_textarea, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                        JButton D_button = new JButton("OK");

                        D_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                        
                                D_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                        });

                        D_panel.add(Label);
                        D_panel.add(Scroll_d);
                        D_panel.add(D_button);
                        D_frame.add(D_panel);
                        D_frame.setSize(210, 180);  
                        D_frame.setLocationRelativeTo(null);
                        D_frame.setVisible(true);

                        //trigger product delete from table
                        }else if(columns[0] == 7){

                            int column = columns[0] - 6;
                            
                            String data = (String)Pro_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("confirm");  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER));

                            JLabel Label = new JLabel(data);
                            JButton C_button1 = new JButton();
                            C_button1.setText("Delete");

                            C_button1.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                        
                                int delete_index = 0;

                                for(Product Pro: Pro_list){

                                    if(Pro.get_code().equals(data)){

                                        break;
                                    }

                                    delete_index++;
                                }

                                Pro_list.remove(delete_index);

                                Comp.set_pro_list(Pro_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                                }
                            });

                            JButton C_button2 = new JButton();
                            C_button2.setText("Cancel");

                            C_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
                                
                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                            });

                            C_panel2.add(Label);
                            C_panel2.add(C_button1);
                            C_panel2.add(C_button2);
                            C_frame.add(C_panel2);
                            C_frame.setSize(110, 110);  
                            C_frame.setLocationRelativeTo(null);
                            C_frame.setVisible(true);

                        //trigger product update from table
                        }else if(columns[0] == 8){

                            int column = columns[0] - 7;

                            String data = (String)Pro_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame("update Product");
  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER)); 
   
                            JLabel Label = new JLabel("Product Name");
                            JLabel Label2 = new JLabel("Product Code");
                            JLabel Label3 = new JLabel("Product Price");
                            JLabel Label4 = new JLabel("Warranty days");
                            JLabel Label5 = new JLabel("Description");

                            Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                            JTextField C_field = new JTextField("");
                            JTextField C_field2 = new JTextField("");
                            JTextField C_field3 = new JTextField("");
                            JTextField C_field4 = new JTextField("0");
                            JTextArea C_field5 = new JTextArea(15,4);

                            C_field5.setRows(4);
                            JScrollPane C_field5_pane = new JScrollPane(C_field5, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);


                            C_field.setColumns(15);
                            C_field2.setColumns(15);
                            C_field3.setColumns(15);
                            C_field4.setColumns(15);
                            C_field5.setColumns(15);

                            final DefaultComboBoxModel<String> Pre_combo1 = new DefaultComboBoxModel<String>();

                            final DefaultComboBoxModel<String> Pre_combo2 = new DefaultComboBoxModel<String>();

                            for(Product Pro: Pro_list){

                                    if(Pro.get_code().equals(data)){

                                        C_field.setText(Pro.get_name());
                                        C_field2.setText(Pro.get_code());
                                        C_field3.setText(Float.toString(Pro.get_price()));
                                        C_field4.setText(Integer.toString(Pro.get_warranty()));
                                        C_field5.setText(Pro.get_description());
                                        Pre_combo1.addElement(Pro.get_category());
                                        Pre_combo2.addElement(Pro.get_brand());
                                    }
                            }    

                            for(Category Cat: Comp.get_cat_list()){

                                Pre_combo1.addElement(Cat.get_name());
                            }

                            for(Brand Bra: Comp.get_bra_list()){

                                Pre_combo2.addElement(Bra.get_name());
                            }
    
                            final JComboBox<String> Com_box1 = new JComboBox<String>(Pre_combo1);

                            JScrollPane Combo_panel1 = new JScrollPane(Com_box1);

                            final JComboBox<String> Com_box2 = new JComboBox<String>(Pre_combo2);

                            JScrollPane Combo_panel2 = new JScrollPane(Com_box2);
    
                            JButton C_button = new JButton();
                            C_button.setText("Update");

                            //this listener update the selected product Object
                            C_button.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                boolean detect_duplicate = false;

                                for(Product Pro: Pro_list){

                                    if(C_field2.getText().toLowerCase().equals(Pro.get_code().toLowerCase()) && !Pro.get_code().equals(data)){

                                            detect_duplicate = true;
                                    }
                                }

                                    for(Product Pro: Pro_list){

                                        if(Pro.get_code().equals(data) && !detect_duplicate){

                                            Pro.set_name(C_field.getText());
                                            Pro.set_code(C_field2.getText());
                                            Pro.set_price(Float.parseFloat(C_field3.getText()));
                                            Pro.set_warranty(Integer.parseInt(C_field4.getText()));
                                            Pro.set_description(C_field5.getText());
                                            Pro.set_category(Com_box1.getSelectedItem().toString());
                                            Pro.set_brand(Com_box2.getSelectedItem().toString());
                                            }
                                    }

                                Comp.set_pro_list(Pro_list);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                    update();
                                }
                            });

                        JButton C_button2 = new JButton();
                        C_button2.setText("Cancel");

                        C_button2.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                C_frame.setVisible(false);
                                add_all(false, "", "");
                                update();
                            }
                        });

                        C_panel2.add(Label);
                        C_panel2.add(C_field);
                        C_panel2.add(Label2);
                        C_panel2.add(C_field2);
                        C_panel2.add(Label3);
                        C_panel2.add(C_field3);
                        C_panel2.add(Label4);
                        C_panel2.add(C_field4);
                        C_panel2.add(Label5);
                        C_panel2.add(C_field5_pane);
                        C_panel2.add(Combo_panel1);
                        C_panel2.add(Combo_panel2);
                        C_panel2.add(C_button);
                        C_panel2.add(C_button2);
                        C_frame.add(C_panel2);
                        C_frame.setSize(200, 420);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);

                        }else if(columns[0] == 1){

                            int column = columns[0];

                            String data = (String)Pro_table.getValueAt(rows[0], column);

                            JFrame C_frame = new JFrame(data);
  
                            JPanel C_panel2 = new JPanel();
                            C_panel2.setLayout(new FlowLayout(FlowLayout.CENTER));

                            JLabel Label = new JLabel("quantity");

                            Label.setAlignmentX(Component.CENTER_ALIGNMENT);

                            JTextField C_field = new JTextField("");

                            C_field.setColumns(10);

                            JButton C_button1 = new JButton("Add to Cart");

                            C_button1.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                    ArrayList<String> Codes = Comp.get_codes();
                                    ArrayList<Integer> Qts = Comp.get_qts();

                                    boolean exists_prod = false;
                                    int count1 = 0;

                                    for(String code: Codes){
        
                                        if(code.equals(data)){
                
                                            int qt = Qts.get(count1);
                                            qt += Integer.parseInt(C_field.getText());
                                            Qts.set(count1, qt);
                                            exists_prod = true;
                                            break;
                                        } 

                                        count1++;    
                                    }

                                    if(!exists_prod){

                                        Codes.add(data);
                                        Qts.add(Integer.parseInt(C_field.getText()));
                                    }

                                    Comp.set_codes(Codes);
                                    Comp.set_qts(Qts);

                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");

                                    add_ve_panel();
                                }
                            }); 

                            JButton C_button2 = new JButton("Cancel");

                            C_button2.addActionListener(new ActionListener(){  
                                public void actionPerformed(ActionEvent e){

                                    C_frame.setVisible(false);
                                    add_all(false, "", "");
                                 }
                            });

                            C_panel2.add(Label);
                            C_panel2.add(C_field);
                            C_panel2.add(C_button1);
                            C_panel2.add(C_button2);
                            C_frame.add(C_panel2);
                            C_frame.setSize(220, 100);  
                            C_frame.setLocationRelativeTo(null);
                            C_frame.setVisible(true);
                        }//else if

                    rows = null;
                    columns = null;
                    }//if 
                }      
            });//ActionListener  

            JScrollPane Pro_panel = new JScrollPane(Pro_table);

            add(Pro_panel);
        }

		public void add_ve_panel(){

			Vndos_suite Win = (Vndos_suite)SwingUtilities.windowForComponent(this);
       	    Win.add_ve_panel(1);
		}
}

class Brands_panel extends Tab_panel{

        JLabel C_label = new JLabel();
        JButton Button1, Button2;
        ArrayList<Brand> Bra_list;
        DefaultListModel<String> List1 = new DefaultListModel<>();
        JList<String> List2;
        JScrollPane List_panel;

        Brands_panel() {

            super();

            Bra_list = Comp.get_bra_list();
            setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
            C_label.setText(Current_company.getText());
            C_label.setAlignmentX(this.CENTER_ALIGNMENT);
            add(C_label);

            add(Box.createRigidArea(new Dimension(0, 40)));

            Button1 = new JButton("Add Brand");
            Button1.setAlignmentX(this.CENTER_ALIGNMENT);

            Button1.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        JFrame C_frame = new JFrame("Create new Brand");  
                        JPanel C_panel2 = new JPanel();  
                        C_panel2.setLayout(new FlowLayout());
                        JTextField C_field = new JTextField("");
                        C_field.setColumns(15);  
                        JButton C_button = new JButton(); 
 
                        C_button.setText("Create"); 
 
                        //this listener creates new Category Object
                        C_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                boolean detect_duplicate = false;

                                for(Brand Bra: Bra_list){

                                    if(Bra.get_name().toLowerCase().equals(C_field.getText().toLowerCase())){

                                        detect_duplicate = true;
                                    }
                                }

                                if(!detect_duplicate){

                                    Brand Bra = new Brand(C_field.getText());
                                    Bra_list.add(Bra);
                                    Comp.set_bra_list(Bra_list);
                                
                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    add_all();

                                }

                                C_frame.setVisible(false);
                            }
                        });

                        C_panel2.add(C_field);  
                        C_panel2.add(C_button);  
                        C_frame.add(C_panel2);  
                        C_frame.setSize(250, 100);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
                }
            });
            
            if(Comp.get_role().equals("admin")){

                add(Button1);
            
            }

            add(Box.createRigidArea(new Dimension(0, 20)));

            Button2 = new JButton("Delete Brand");
            Button2.setAlignmentX(this.CENTER_ALIGNMENT);

            Button2.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        if (List2.getSelectedIndex() != -1) {

                                int remove_index;

                                for(Brand Bra: Bra_list){

                                    if(Bra.get_name().toLowerCase().equals(List2.getSelectedValue().toLowerCase())){

                                        Bra_list.remove(Bra);
                                        break;
                                    }
                                }

                                    Comp.set_bra_list(Bra_list);
                                
                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                            add_all();
                            update();
                        }
                }
            });
            
            if(Comp.get_role().equals("admin")){

                add(Button2);
            }

            add(Box.createRigidArea(new Dimension(0, 40)));

            for(Brand Bra: Bra_list){
            
                List1.addElement(Bra.get_name());  
            }

            List2 = new JList<>(List1);

            List2.setAlignmentX(this.CENTER_ALIGNMENT);
            List2.setFixedCellWidth(150);
            List_panel = new JScrollPane(List2, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

            add(List_panel);
        }

        //this method refresh the current frame
        public void add_all(){

            removeAll();
            add(C_label);
            add(Box.createRigidArea(new Dimension(0, 40)));
            
            if(Comp.get_role().equals("admin")){
            
                add(Button1);
                add(Box.createRigidArea(new Dimension(0, 20)));
                add(Button2);
                add(Box.createRigidArea(new Dimension(0, 40)));
            }

            List1 = new DefaultListModel<>();

            for(Brand Bra: Bra_list){
            
                List1.addElement(Bra.get_name());  
            }

            List2 = new JList<>(List1);
            List2.setFixedCellWidth(150);
            List_panel = new JScrollPane(List2, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

            add(List_panel);
        }
}

class Categories_panel extends Tab_panel{

        JLabel C_label = new JLabel();
        JButton Button1, Button2;
        ArrayList<Category> Cat_list;
        DefaultListModel<String> List1 = new DefaultListModel<>();
        JScrollPane List_panel;
        JList<String> List2;

        Categories_panel() {

            super();

            Cat_list = Comp.get_cat_list();

            setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
            C_label.setText(Current_company.getText());
            C_label.setAlignmentX(this.CENTER_ALIGNMENT);
            add(C_label);

            add(Box.createRigidArea(new Dimension(0, 40)));

            Button1 = new JButton("Add Category");
            Button1.setAlignmentX(this.CENTER_ALIGNMENT);

            Button1.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        JFrame C_frame = new JFrame("Create new Category");  
                        JPanel C_panel2 = new JPanel();  
                        C_panel2.setLayout(new FlowLayout());
                        JTextField C_field = new JTextField("");
                        C_field.setColumns(15);  
                        JButton C_button = new JButton(); 
 
                        C_button.setText("Create"); 
 
                        //this listener creates new Category Object
                        C_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                boolean detect_duplicate = false;

                                for(Category Cat: Cat_list){

                                    if(Cat.get_name().toLowerCase().equals(C_field.getText().toLowerCase())){

                                        detect_duplicate = true;
                                    }
                                }

                                if(!detect_duplicate){

                                    Category Cat = new Category(C_field.getText());
                                    Cat_list.add(Cat);
                                    Comp.set_cat_list(Cat_list);
                                
                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                    add_all();

                                }

                                C_frame.setVisible(false);
                            }
                        });

                        C_panel2.add(C_field);  
                        C_panel2.add(C_button);  
                        C_frame.add(C_panel2);  
                        C_frame.setSize(250, 100);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);
                }
            });

            if(Comp.get_role().equals("admin")){

                add(Button1);
            }

            add(Box.createRigidArea(new Dimension(0, 20)));

            Button2 = new JButton("Delete Category");
            Button2.setAlignmentX(this.CENTER_ALIGNMENT);

            Button2.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        if (List2.getSelectedIndex() != -1) {

                                int remove_index;

                                for(Category Cat: Cat_list){

                                    if(Cat.get_name().toLowerCase().equals(List2.getSelectedValue().toLowerCase())){

                                        Cat_list.remove(Cat);
                                        break;
                                    }
                                }

                                    Comp.set_cat_list(Cat_list);
                                
                                    try{

                                        C_list = read_companies("Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("could not read file, try again");
                                    }catch(ClassNotFoundException cnfe){

                                        System.out.println("non companies were found, try again");
                                    }

                                    C_list.set(comp_index, Comp);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                            add_all();
                            update();
                        }
                }
            });
            
            if(Comp.get_role().equals("admin")){

                add(Button2);
            }

            add(Box.createRigidArea(new Dimension(0, 40)));

            for(Category Cat: Cat_list){
            
                List1.addElement(Cat.get_name());  
            }

            List2 = new JList<>(List1);

            List2.setAlignmentX(this.CENTER_ALIGNMENT);
            List2.setFixedCellWidth(150);
            List_panel = new JScrollPane(List2, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
            add(List_panel);
        }

        //this method refresh the current frame
        public void add_all(){

            removeAll();
            add(C_label);
            add(Box.createRigidArea(new Dimension(0, 40)));
            
            if(Comp.get_role().equals("admin")){
            
                add(Button1);
                add(Box.createRigidArea(new Dimension(0, 20)));
                add(Button2);
                add(Box.createRigidArea(new Dimension(0, 40)));
            }

            List1 = new DefaultListModel<>();

            for(Category Cat: Cat_list){
            
                List1.addElement(Cat.get_name());  
            }

            List2 = new JList<>(List1);
            List2.setFixedCellWidth(150);
            List_panel = new JScrollPane(List2, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
            add(List_panel);
        }
}

class Lobby_panel extends Tab_panel{

        JLabel Label1, Label2;
        JButton Comp_button, Delc_button, Fetch_button;
        JButton[] C_buttons;
        ArrayList<Company> C_list = new ArrayList<Company>();
        int count;

        //this method updates the frame when change company its made
        public void remove_buttons(){

            switch_company("select company");
            Win = (Vndos_suite)SwingUtilities.windowForComponent(this);
            Win.set_company("not defined");
            update();
        }

        Lobby_panel() {

            super();

            setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));

            super.Current_company.setAlignmentX(this.CENTER_ALIGNMENT);
            add(super.Current_company);

            add(Box.createRigidArea(new Dimension(0, 20)));

            Label1 = new JLabel("Select an Option below:");
            Label1.setAlignmentX(this.CENTER_ALIGNMENT);
            add(Label1);

            add(Box.createRigidArea(new Dimension(0, 40)));

            Comp_button = new JButton("New Company");
            Comp_button.setAlignmentX(this.CENTER_ALIGNMENT);

            Comp_button.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){

                        JFrame C_frame = new JFrame("Create new Company");  
                        JPanel C_panel2 = new JPanel();  
                        C_panel2.setLayout(new FlowLayout());
                        JTextField C_field = new JTextField("");
                        C_field.setColumns(15);  
                        JButton C_button = new JButton(); 
 
                        C_button.setText("Create"); 
 
                        // this listener creates new Company Object and appends each one to the Subpanel
                        C_button.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){

                                count = 0;
                                boolean detect_duplicate = false;
                                String entered = C_field.getText();
                                String entered_tolower = entered.toLowerCase();
                                String saved = "";
                                String saved_tolower = "";

                                for(Company comp: C_list){

                                    saved = comp.get_name();
                                    saved_tolower = saved.toLowerCase();

                                    if(entered_tolower.equals(saved_tolower)){
                                        
                                        detect_duplicate = true;
                                    }

                                    remove(C_buttons[count]);
                                    count++;
                                }
  
                                
                                if(!detect_duplicate){

                                    Company Comp1 = new Company(C_field.getText(), "admin", "admin");
                                    C_list.add(Comp1);

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }
                                }

                                //this try-catch block reads it and append each company button to subpanel
                                try{

                                    C_list = read_companies("Vndos_record"); 

                                    count = 0;

                                    C_buttons = new JButton[C_list.size()];

                                    for(Company Comp: C_list){

                                    C_buttons[count] = new JButton(Comp.get_name());

                                    C_buttons[count].addActionListener(new ActionListener(){  
                                         public void actionPerformed(ActionEvent e){

                                                switch_company(Comp);
                                                JButton Button = (JButton)e.getSource();
                                                Win = (Vndos_suite)SwingUtilities.windowForComponent(Button);
                                                Win.set_company("defined");
                                                update();
                                         }
                                    });
            
                                    C_buttons[count].setAlignmentX(CENTER_ALIGNMENT);

                                    add(Box.createRigidArea(new Dimension(0, 20)));
                                    add(C_buttons[count]);
                                    count++;
                                    }

                                update();                               
                                }catch(IOException ioe){

                                    System.out.println("could not read file, try again");
                                }catch(ClassNotFoundException cnfe){

                                    System.out.println("non companies were found, try again");
                                }

                                remove_buttons();
                                C_frame.setVisible(false);
                            }
                        });

                        C_panel2.add(C_field);  
                        C_panel2.add(C_button);  
                        C_frame.add(C_panel2);  
                        C_frame.setSize(250, 100);  
                        C_frame.setLocationRelativeTo(null);
                        C_frame.setVisible(true);  
                }  
            });

            add(Comp_button);
            
            add(Box.createRigidArea(new Dimension(0, 20)));

            Delc_button = new JButton("Delete Company");
            Delc_button.setAlignmentX(this.CENTER_ALIGNMENT); 
 
            // this listener deletes the input Company record
            Delc_button.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){  
                        JFrame C_frame3 = new JFrame("Delete Company");  
                        JPanel C_panel3 = new JPanel();  
                        C_panel3.setLayout(new FlowLayout());
                        JTextField C_field3 = new JTextField("");
                        C_field3.setColumns(15);  
                        JButton C_button3 = new JButton(); 
 
                        C_button3.setText("Delete");

                        C_button3.addActionListener(new ActionListener(){  
                            public void actionPerformed(ActionEvent e){
 
                                String c_delete = C_field3.getText();
                                String c_delete_tolower = c_delete.toLowerCase();
                                String saved3 = "";
                                String saved_tolower3 = "";
                                int count3 = 0, del_index = -1;
                                

                                for(Company Comp: C_list){

                                    saved3 = Comp.get_name();
                                    saved_tolower3 = saved3.toLowerCase();

                                    if(c_delete_tolower.equals(saved_tolower3)){

                                        del_index = count3;
                                    }

                                    count3++;
                                }

                                if(del_index != -1){

                                    C_list.remove(del_index);
                                }

                                    try{

                                        save_companies(C_list, "Vndos_record");                                
                                    }catch(IOException ioe){

                                        System.out.println("cannot write record, try again");
                                    }

                                for(JButton Button: C_buttons){

                                        remove(Button);
                                        count++;
                                }

                                //this try-catch block reads it and append each company button to subpanel
                                try{

                                    C_list = read_companies("Vndos_record"); 

                                    count = 0;

                                    C_buttons = new JButton[C_list.size()];
                                    for(Company Comp: C_list){

                                    C_buttons[count] = new JButton(Comp.get_name());
            
                                    C_buttons[count].setAlignmentX(CENTER_ALIGNMENT);

                                    C_buttons[count].addActionListener(new ActionListener(){  
                                         public void actionPerformed(ActionEvent e){

                                                switch_company(Comp);
                                                JButton Button = (JButton)e.getSource();
                                                Vndos_suite Win = (Vndos_suite)SwingUtilities.windowForComponent(Button);
                                                Win.set_company("defined");
                                                update();
                                         }
                                    });

                                    add(Box.createRigidArea(new Dimension(0, 20)));
                                    add(C_buttons[count]);
                                    count++;
                                    }

                                update();                              
                                }catch(IOException ioe){

                                    System.out.println("could not read file, try again");
                                }catch(ClassNotFoundException cnfe){

                                    System.out.println("non companies were found, try again");
                                }

                                remove_buttons();
                                C_frame3.setVisible(false);
                                }
                        });

                        C_panel3.add(C_field3);  
                        C_panel3.add(C_button3);  
                        C_frame3.add(C_panel3);  
                        C_frame3.setSize(250, 100);  
                        C_frame3.setLocationRelativeTo(null);
                        C_frame3.setVisible(true);
                }  
            });

            add(Delc_button);
            
            add(Box.createRigidArea(new Dimension(0, 20)));
            
            Fetch_button = new JButton("Import a Company from Internet");
            
            Fetch_button.setAlignmentX(this.CENTER_ALIGNMENT); 
 
            // this listener fetch the json data from server
            Fetch_button.addActionListener(new ActionListener(){  
                public void actionPerformed(ActionEvent e){
                
                        JFrame F_frame = new JFrame("Import Data");  
                        JPanel F_panel = new JPanel();  
                        F_panel.setLayout(new FlowLayout());
                        JLabel F_label = new JLabel("Enter Your temporary Key");
                        JTextField F_field = new JTextField("");
                        F_field.setColumns(15);  
                        JButton F_button = new JButton("Import");
                        
                        F_button.addActionListener(new ActionListener(){  
                             public void actionPerformed(ActionEvent e){
                           
                                try{
                                
                                    fetch_data(Integer.parseInt(F_field.getText()));
                                }catch(Exception exc){
                                
                                    System.out.println("an eror has occured, please check your internet connection an try again.");
                                }
                                F_frame.setVisible(false);
                             }
                        });
                        
                        F_panel.add(F_label);
                        F_panel.add(F_field);  
                        F_panel.add(F_button);  
                        F_frame.add(F_panel);  
                        F_frame.setSize(200, 100);  
                        F_frame.setLocationRelativeTo(null);
                        F_frame.setVisible(true);
                }
            });
            
            add(Fetch_button);
            
            add(Box.createRigidArea(new Dimension(0, 60)));

            Label2 = new JLabel("OR, Select Company:");
            Label2.setAlignmentX(this.CENTER_ALIGNMENT);
            add(Label2);

            add(Box.createRigidArea(new Dimension(0, 20)));

                                //this try-catch block reads it and append each company button to subpanel
                                try{

                                    C_list = read_companies("Vndos_record"); 

                                    count = 0;

                                    C_buttons = new JButton[C_list.size()];

                                    for(Company Comp: C_list){

                                    C_buttons[count] = new JButton(Comp.get_name());
            
                                    C_buttons[count].setAlignmentX(CENTER_ALIGNMENT);

                                    C_buttons[count].addActionListener(new ActionListener(){  
                                         public void actionPerformed(ActionEvent e){

                                                switch_company(Comp);
                                                JButton Button = (JButton)e.getSource();
                                                Vndos_suite Win = (Vndos_suite)SwingUtilities.windowForComponent(Button);
                                                Win.set_company("defined");
                                                update();
                                         }
                                    });

                                    add(Box.createRigidArea(new Dimension(0, 20)));
                                    add(C_buttons[count]);
                                    count++;
                                    }

                                update();                                
                                }catch(IOException ioe){

                                    System.out.println("could not read file, try again");
                                }catch(ClassNotFoundException cnfe){

                                    System.out.println("non companies were found, try again");
                                }
        }
        
        void fetch_data(int the_key) throws Exception{
        
            Java_php http = new Java_php();
 
            // Sending get request
            Company Comp1 = http.sendingGetRequest(the_key);
            
            String saved3 = "";
            String saved_tolower3 = "";
            int count3 = 0, del_index = -1;

            for(Company Comp: C_list){

                    if(Comp1.get_name().equals(Comp.get_name())){

                        del_index = count3;
                    }

                count3++;
            }

            if(del_index != -1){

                C_list.remove(del_index);
            }
                                
            C_list.add(Comp1);

            try{

                save_companies(C_list, "Vndos_record");                                
            }catch(IOException ioe){

                System.out.println("cannot write record, try again");
            }
          
            
            remove_buttons();
       }
}

// Main JFrame class 
public class Vndos_suite extends JFrame{

    JTabbedPane T_panel = new JTabbedPane(JTabbedPane.TOP,JTabbedPane.SCROLL_TAB_LAYOUT);
    Lobby_panel L_panel = new Lobby_panel();
    JPanel C_panel = new JPanel();
    JPanel B_panel = new JPanel();
    JPanel P_panel = new JPanel();
    JPanel V_panel = new JPanel();
    JPanel Cu_panel = new JPanel();
    JPanel I_panel = new JPanel();
    JPanel Ve_panel = new JPanel();
    JPanel A_panel = new JPanel();

    public Vndos_suite(){

        super("Vending Operating System - VndOS suite");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        T_panel.addTab("Lobby", L_panel);
        T_panel.addTab("Categories", C_panel);
        T_panel.addTab("Brands", B_panel);
        T_panel.addTab("Products", P_panel);
        T_panel.addTab("Vendors", V_panel);
        T_panel.addTab("Customers", Cu_panel);
        T_panel.addTab("Invoice", I_panel);
        T_panel.addTab("Vending", Ve_panel);
        T_panel.addTab("Analytics", A_panel);
        getContentPane().add(T_panel);
    }

    public void set_company(String case_op){

        if(case_op.equals("defined")){

            C_panel = new Categories_panel();
            B_panel = new Brands_panel();
            P_panel = new Products_panel();
            V_panel = new Vendors_panel();
            Cu_panel = new Customers_panel();
            I_panel = new Invoice_panel();
            Ve_panel = new Vending_panel();
			A_panel = new Analytics_panel();
        }else{
            
            C_panel = new JPanel();
            B_panel = new JPanel();
            P_panel = new JPanel();
            V_panel = new JPanel();
            Cu_panel = new JPanel();
            I_panel = new JPanel();
            Ve_panel = new JPanel();
			A_panel = new JPanel();      
            L_panel = new Lobby_panel();
        }

        T_panel.removeAll();
        T_panel.addTab("Lobby", L_panel);
        T_panel.addTab("Categories", C_panel);
        T_panel.addTab("Brands", B_panel);
        T_panel.addTab("Products", P_panel);
        T_panel.addTab("Vendors", V_panel);
        T_panel.addTab("Customers", Cu_panel);
        T_panel.addTab("Invoice", I_panel);
        T_panel.addTab("Vending", Ve_panel);
        T_panel.addTab("Analytics", A_panel);
        getContentPane().add(T_panel);
    }

    public static void main(String[] args){

        Vndos_suite Frame = new Vndos_suite();
        Frame.setSize(400, 800);
        Frame.setVisible(true);
    }

	public void add_ve_panel(int case_from){

		switch(case_from){

			case 1:

			T_panel.remove(V_panel);
			T_panel.remove(Cu_panel);
			T_panel.remove(I_panel);
			T_panel.remove(Ve_panel);
			T_panel.remove(A_panel);

			Ve_panel = new Vending_panel();

        	T_panel.addTab("Vendors", V_panel);
        	T_panel.addTab("Customers", Cu_panel);
        	T_panel.addTab("Invoice", I_panel);
        	T_panel.addTab("Vending", Ve_panel);
        	T_panel.addTab("Analytics", A_panel);

			break;

			case 2:

			T_panel.remove(I_panel);
			T_panel.remove(Ve_panel);
			T_panel.remove(A_panel);

			Ve_panel = new Vending_panel();

        	T_panel.addTab("Invoice", I_panel);
        	T_panel.addTab("Vending", Ve_panel);
        	T_panel.addTab("Analytics", A_panel);

			break;
		}
	}
}
